/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[0] = x9;
  return 0;
}

int
pattern36 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!scc_eq_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode)
          || !const_int_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode)
          || !const_int_operand (operands[2], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!indexed_or_indirect_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!indexed_or_indirect_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return pattern67 (); /* [-1, 2] */
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!vfloat_operand (operands[1], E_V2DFmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!scratch_operand (operands[2], E_V2DFmode))
    return -1;
  x9 = XEXP (x4, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  return 0;
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern83 (x5, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern83 (x5, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || pattern101 (
E_SImode) != 0)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (pattern101 (
E_DImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern101 (
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern119 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!scc_eq_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!rs6000_tls_symbol_ref (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern141 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_DDmode))
        return -1;
      return 0;

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode
          || !gpc_reg_operand (operands[1], E_TDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          return pattern169 (x1); /* [-1, 1] */

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT)
            return -1;
          res = pattern173 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!reg_or_mem_operand (operands[1], E_SImode)
          || !u6bit_cint_operand (operands[2], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          return 4;

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT
              || GET_MODE (x10) != E_DImode)
            return -1;
          x13 = XEXP (x10, 0);
          if (GET_CODE (x13) != SIGN_EXTEND
              || GET_MODE (x13) != E_DImode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x10, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], i1))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  operands[2] = x10;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  return 0;
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern231 (x4, 
i1); /* [-1, 0] */
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  return pattern233 (x4); /* [-1, 23] */
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 87)
    return -1;
  return 0;
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 440
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  x9 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern270 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern284 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  return 0;
}

int
pattern298 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!memory_operand (operands[0], E_V4SFmode)
          || !immediate_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!memory_operand (operands[0], E_V4SImode)
          || !immediate_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern308 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern315 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern324 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern333 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern340 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_DImode))
    return -1;
  return pattern338 (x7); /* [-1, 1] */
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!base_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[2], E_QImode)
          || !fusion_gpr_mem_load (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!base_reg_operand (operands[2], E_HImode)
          || !fusion_gpr_mem_load (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!base_reg_operand (operands[2], E_SImode)
          || !fusion_gpr_mem_load (operands[3], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!base_reg_operand (operands[2], E_DImode)
          || !fusion_gpr_mem_load (operands[3], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern368 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern376 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern375 (x4, 
i1); /* [-1, 0] */
}

int
pattern384 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern377 (x1); /* [-1, 11] */

    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          res = pattern380 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        case NOT:
          res = pattern383 (x1);
          if (res >= 0)
            return res + 24; /* [24, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern392 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DFmode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!gpc_reg_operand (operands[3], E_DFmode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!offsettable_mem_operand (operands[4], E_DFmode))
    return -1;
  x12 = XVECEXP (x1, 0, 4);
  x13 = XEXP (x12, 0);
  operands[5] = x13;
  if (!gpc_reg_operand (operands[5], E_DFmode))
    return -1;
  return 0;
}

int
pattern401 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern415 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode
      || !register_operand (operands[0], E_V2DImode)
      || !register_operand (operands[1], E_V2DImode)
      || !register_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern421 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern432 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern437 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], E_V4SFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (!const_0_to_3_operand (x4, E_QImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (!scratch_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 0;

    case CONST_DOUBLE:
      operands[2] = x7;
      if (!zero_fp_constant (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 1;

    case VEC_SELECT:
      if (GET_MODE (x7) != E_SFmode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x4;
      operands[5] = x6;
      return 2;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern476 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[3], i1)
      || !vsx_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern480 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern487 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern492 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern500 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern510 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], E_V16QImode)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !const_0_to_15_operand (operands[3], E_SImode)
      || !const_0_to_3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern513 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern525 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern536 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern546 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[2], E_DImode)
          || !memory_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[2], E_DFmode)
          || !memory_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x11 = XEXP (x4, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  x13 = XEXP (x5, 0);
  operands[2] = x13;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x14 = XEXP (x8, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case AND:
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!
#line 3906 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 2;
      return 212; /* *branch_anddi3_dot */

    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x3, 0);
      operands[0] = x11;
      if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
        return -1;
      *pnum_clobbers = 2;
      return 561; /* *rotate_on_cmpdi */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (branch_comparison_operator (operands[0], E_VOIDmode))
    {
      res = recog_12 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (fpmask_comparison_operator (operands[1], E_CCFPmode))
    {
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x2, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != PC
      || !branch_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[0] = x9;
  return 889; /* *cbranch */
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern356 (
E_SImode) != 0)
            return -1;
          return 213; /* *boolsi3_imm */

        case E_DImode:
          if (pattern356 (
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 214; /* *booldi3_imm */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern343 (
E_TImode) != 0)
            return -1;
          return 505; /* *boolti3_internal */

        case E_PTImode:
          if (pattern343 (
E_PTImode) != 0)
            return -1;
          return 506; /* *boolpti3_internal */

        case E_V16QImode:
          if (pattern343 (
E_V16QImode) != 0
              || !
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 507; /* *boolv16qi3_internal */

        case E_V8HImode:
          if (pattern343 (
E_V8HImode) != 0
              || !
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 508; /* *boolv8hi3_internal */

        case E_V4SImode:
          if (pattern343 (
E_V4SImode) != 0
              || !
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 509; /* *boolv4si3_internal */

        case E_V4SFmode:
          if (pattern343 (
E_V4SFmode) != 0
              || !
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 510; /* *boolv4sf3_internal */

        case E_V2DImode:
          if (pattern343 (
E_V2DImode) != 0
              || !
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 511; /* *boolv2di3_internal */

        case E_V2DFmode:
          if (pattern343 (
E_V2DFmode) != 0
              || !
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 512; /* *boolv2df3_internal */

        case E_V1TImode:
          if (pattern343 (
E_V1TImode) != 0
              || !
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 513; /* *boolv1ti3_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern275 (x3))
        {
        case 0:
          if (!
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2432; /* *fuse_and_nand */

        case 1:
          if (!(
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2433; /* *fuse_and_nand */

        case 2:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2788; /* *fuse_vand_vnand */

        case 3:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2789; /* *fuse_vand_vnand */

        case 4:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2790; /* *fuse_vand_vnand */

        case 5:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2791; /* *fuse_vand_vnand */

        case 6:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2792; /* *fuse_vand_vnand */

        case 7:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2793; /* *fuse_vand_vnand */

        case 8:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2794; /* *fuse_vand_vnand */

        case 9:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2795; /* *fuse_vand_vnand */

        case 10:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2796; /* *fuse_vand_vnand */

        case 11:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2797; /* *fuse_vand_vnand */

        case 12:
          if (!
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2434; /* *fuse_andc_nand */

        case 13:
          if (!(
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2435; /* *fuse_andc_nand */

        case 14:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2798; /* *fuse_vandc_vnand */

        case 15:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2799; /* *fuse_vandc_vnand */

        case 16:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2800; /* *fuse_vandc_vnand */

        case 17:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2801; /* *fuse_vandc_vnand */

        case 18:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2802; /* *fuse_vandc_vnand */

        case 19:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2803; /* *fuse_vandc_vnand */

        case 20:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2804; /* *fuse_vandc_vnand */

        case 21:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2805; /* *fuse_vandc_vnand */

        case 22:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2806; /* *fuse_vandc_vnand */

        case 23:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2807; /* *fuse_vandc_vnand */

        case 24:
          if (!
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2440; /* *fuse_nor_nand */

        case 25:
          if (!(
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2441; /* *fuse_nor_nand */

        case 26:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2828; /* *fuse_vnor_vnand */

        case 27:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2829; /* *fuse_vnor_vnand */

        case 28:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2830; /* *fuse_vnor_vnand */

        case 29:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2831; /* *fuse_vnor_vnand */

        case 30:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2832; /* *fuse_vnor_vnand */

        case 31:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2833; /* *fuse_vnor_vnand */

        case 32:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2834; /* *fuse_vnor_vnand */

        case 33:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2835; /* *fuse_vnor_vnand */

        case 34:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2836; /* *fuse_vnor_vnand */

        case 35:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2837; /* *fuse_vnor_vnand */

        default:
          return -1;
        }

    case NOT:
      switch (pattern278 (x3))
        {
        case 0:
          if (!
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2436; /* *fuse_eqv_nand */

        case 1:
          if (!(
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2437; /* *fuse_eqv_nand */

        case 2:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2808; /* *fuse_veqv_vnand */

        case 3:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2809; /* *fuse_veqv_vnand */

        case 4:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2810; /* *fuse_veqv_vnand */

        case 5:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2811; /* *fuse_veqv_vnand */

        case 6:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2812; /* *fuse_veqv_vnand */

        case 7:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2813; /* *fuse_veqv_vnand */

        case 8:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2814; /* *fuse_veqv_vnand */

        case 9:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2815; /* *fuse_veqv_vnand */

        case 10:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2816; /* *fuse_veqv_vnand */

        case 11:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2817; /* *fuse_veqv_vnand */

        default:
          return -1;
        }

    case IOR:
      switch (pattern279 (x3))
        {
        case 0:
          if (!
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2438; /* *fuse_nand_nand */

        case 1:
          if (!(
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2439; /* *fuse_nand_nand */

        case 2:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2818; /* *fuse_vnand_vnand */

        case 3:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2819; /* *fuse_vnand_vnand */

        case 4:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2820; /* *fuse_vnand_vnand */

        case 5:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2821; /* *fuse_vnand_vnand */

        case 6:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2822; /* *fuse_vnand_vnand */

        case 7:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2823; /* *fuse_vnand_vnand */

        case 8:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2824; /* *fuse_vnand_vnand */

        case 9:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2825; /* *fuse_vnand_vnand */

        case 10:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2826; /* *fuse_vnand_vnand */

        case 11:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2827; /* *fuse_vnand_vnand */

        case 12:
          if (!
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2444; /* *fuse_orc_nand */

        case 13:
          if (!(
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2445; /* *fuse_orc_nand */

        case 14:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2848; /* *fuse_vorc_vnand */

        case 15:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2849; /* *fuse_vorc_vnand */

        case 16:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2850; /* *fuse_vorc_vnand */

        case 17:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2851; /* *fuse_vorc_vnand */

        case 18:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2852; /* *fuse_vorc_vnand */

        case 19:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2853; /* *fuse_vorc_vnand */

        case 20:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2854; /* *fuse_vorc_vnand */

        case 21:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2855; /* *fuse_vorc_vnand */

        case 22:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2856; /* *fuse_vorc_vnand */

        case 23:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2857; /* *fuse_vorc_vnand */

        case 24:
          if (!
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2442; /* *fuse_or_nand */

        case 25:
          if (!(
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2443; /* *fuse_or_nand */

        case 26:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2838; /* *fuse_vor_vnand */

        case 27:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2839; /* *fuse_vor_vnand */

        case 28:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2840; /* *fuse_vor_vnand */

        case 29:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2841; /* *fuse_vor_vnand */

        case 30:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2842; /* *fuse_vor_vnand */

        case 31:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2843; /* *fuse_vor_vnand */

        case 32:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2844; /* *fuse_vor_vnand */

        case 33:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2845; /* *fuse_vor_vnand */

        case 34:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2846; /* *fuse_vor_vnand */

        case 35:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2847; /* *fuse_vor_vnand */

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern266 (x3, 
E_SImode) != 0
                  || !
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2446; /* *fuse_xor_nand */

            case E_DImode:
              if (pattern266 (x3, 
E_DImode) != 0
                  || !(
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2447; /* *fuse_xor_nand */

            case E_V4SImode:
              if (pattern267 (x3, 
E_V4SImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2858; /* *fuse_vxor_vnand */

            case E_V8HImode:
              if (pattern267 (x3, 
E_V8HImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2859; /* *fuse_vxor_vnand */

            case E_V16QImode:
              if (pattern267 (x3, 
E_V16QImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2860; /* *fuse_vxor_vnand */

            case E_V4SFmode:
              if (pattern267 (x3, 
E_V4SFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2861; /* *fuse_vxor_vnand */

            case E_V2DFmode:
              if (pattern267 (x3, 
E_V2DFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2862; /* *fuse_vxor_vnand */

            case E_V2DImode:
              if (pattern267 (x3, 
E_V2DImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2863; /* *fuse_vxor_vnand */

            case E_V1TImode:
              if (pattern267 (x3, 
E_V1TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2864; /* *fuse_vxor_vnand */

            case E_TImode:
              if (pattern267 (x3, 
E_TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2865; /* *fuse_vxor_vnand */

            case E_KFmode:
              if (pattern267 (x3, 
E_KFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2866; /* *fuse_vxor_vnand */

            case E_TFmode:
              if (pattern267 (x3, 
E_TFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2867; /* *fuse_vxor_vnand */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern409 (x3))
            {
            case 0:
              if (!
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2476; /* *fuse_eqv_or */

            case 1:
              if (!(
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2477; /* *fuse_eqv_or */

            case 2:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2968; /* *fuse_veqv_vor */

            case 3:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2969; /* *fuse_veqv_vor */

            case 4:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2970; /* *fuse_veqv_vor */

            case 5:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2971; /* *fuse_veqv_vor */

            case 6:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2972; /* *fuse_veqv_vor */

            case 7:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2973; /* *fuse_veqv_vor */

            case 8:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2974; /* *fuse_veqv_vor */

            case 9:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2975; /* *fuse_veqv_vor */

            case 10:
              if (!(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2976; /* *fuse_veqv_vor */

            case 11:
              if (!(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2977; /* *fuse_veqv_vor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern280 (x3))
        {
        case 0:
          if (!
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2448; /* *fuse_add_nand */

        case 1:
          if (!(
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2449; /* *fuse_add_nand */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern280 (x3))
        {
        case 0:
          if (!
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2450; /* *fuse_subf_nand */

        case 1:
          if (!(
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2451; /* *fuse_subf_nand */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!u5bit_cint_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 4870 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
        return -1;
      return 1510; /* vsx_xxspltw_v4sf_direct */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 4870 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
        return -1;
      return 1511; /* vsx_xxspltw_v4si_direct */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (!rs6000_tls_symbol_ref (x4, E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      operands[1] = x4;
      return 750; /* *tls_got_tprel_pcrel_64 */

    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      operands[2] = x4;
      return 751; /* tls_got_tprel_64 */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!got_no_const_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode)
      || !
#line 7696 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4 && flag_pic == 1))
    return -1;
  return 556; /* *movsi_got_internal */
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!vsx_register_operand (operands[1], E_DFmode)
              || !
#line 2362 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1313; /* vsx_xscvdpsp */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2400 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1316; /* vsx_xvcvdpsp */

        case E_SFmode:
          if (!vsx_register_operand (operands[1], E_SFmode)
              || !
#line 2446 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1321; /* vsx_xscvdpsp_scalar */

        default:
          return -1;
        }

    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2409 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1317; /* vsx_xscvspdp */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2418 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1318; /* vsx_xscvspdp_scalar2 */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2137; /* altivec_stvehx */

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2138; /* altivec_stvebx */

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 3249 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2139; /* *altivec_stvesfx */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern210 (x2))
    {
    case 0:
      if (!
#line 5209 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_HAVE_RSQRTE_P (SFmode)))
        return -1;
      return 313; /* *rsqrtsf2 */

    case 1:
      if (!
#line 5209 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_HAVE_RSQRTE_P (DFmode)))
        return -1;
      return 314; /* *rsqrtdf2 */

    case 2:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2031 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1262; /* *vsx_rsqrtev4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2651 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 2001; /* *altivec_vrsqrtefp */

    case 3:
      if (!
#line 2031 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1263; /* *vsx_rsqrtev2df2 */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !
#line 9564 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 634; /* p8_mtvsrwz */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !
#line 9572 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 635; /* p8_mtvsrwz_v16qisi2 */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!int_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !d_form_memory (operands[1], E_QImode)
          || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3193; /* *pcrel_opt_ldqi_gpr */

    case E_HImode:
      if (!int_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !d_form_memory (operands[1], E_HImode)
          || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3194; /* *pcrel_opt_ldhi_gpr */

    case E_SFmode:
      if (!int_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !d_form_memory (operands[1], E_SFmode)
          || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3197; /* *pcrel_opt_ldsf_gpr */

    case E_DFmode:
      if (!int_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !d_form_memory (operands[1], E_DFmode)
          || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3198; /* *pcrel_opt_lddf_gpr */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      switch (XINT (x3, 1))
        {
        case 88:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          if (!symbol_ref_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          operands[3] = x6;
          if (memory_operand (operands[0], E_DImode)
              && (
#line 11367 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ
   && DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return 769; /* *pltseq_tocsave_di */
          if (!register_operand (operands[0], E_DImode)
              || !(
#line 11402 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 772; /* *pltseq_mtctr_di */

        case 89:
          if (GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          if (!symbol_ref_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          operands[3] = x6;
          if (!(
#line 11379 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 770; /* *pltseq_plt16_ha_di */

        case 17:
          if (pattern219 (x3, 
E_CCmode, 
102) != 0)
            return -1;
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 103
              || GET_MODE (x5) != E_CCmode)
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 104
              || GET_MODE (x6) != E_CCmode
              || !gpc_reg_operand (operands[0], E_SImode))
            return -1;
          return 917; /* prologue_movesi_from_cr */

        case 444:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          if (!int_reg_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !d_form_memory (operands[1], E_SImode)
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              *pnum_clobbers = 1;
              return 3195; /* *pcrel_opt_ldsi_gpr */

            case E_DImode:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !d_form_memory (operands[1], E_DImode)
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              *pnum_clobbers = 1;
              return 3196; /* *pcrel_opt_lddi_gpr */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (XINT (x3, 1))
        {
        case 0:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !memory_operand (operands[0], E_DImode))
            return -1;
          return 802; /* probe_stack_di */

        case 74:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !gpc_reg_operand (operands[0], E_DImode))
            return -1;
          return 944; /* load_split_stack_limit_di */

        case 73:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!base_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !fusion_addis_mem_combo_load (operands[1], E_SImode)
                  || !
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
                return -1;
              return 964; /* *fusion_gpr_load_si */

            case E_DImode:
              if (!base_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !fusion_addis_mem_combo_load (operands[1], E_DImode)
                  || !(
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 965; /* *fusion_gpr_load_di */

            default:
              return -1;
            }

        case 66:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 14829 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
            return -1;
          return 967; /* cdtbcd */

        case 67:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 14837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
            return -1;
          return 968; /* cbcdtd */

        case 139:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              switch (pattern320 (x3, 
E_DImode))
                {
                case 0:
                  if (!
#line 5099 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1541; /* vsx_sign_extend_v16qi_di */

                case 1:
                  if (!
#line 5108 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1545; /* vsx_sign_extend_v8hi_di */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern320 (x3, 
E_SImode))
                {
                case 0:
                  if (!
#line 5099 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1542; /* vsx_sign_extend_v16qi_si */

                case 1:
                  if (!
#line 5108 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1546; /* vsx_sign_extend_v8hi_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 146:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) != E_DImode)
                return -1;
              if (altivec_register_operand (operands[0], E_DImode))
                {
                  switch (GET_MODE (operands[1]))
                    {
                    case E_KFmode:
                      if (altivec_register_operand (operands[1], E_KFmode)
                          && (
#line 5200 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                        return 1551; /* xsxexpqp_kf_di */
                      break;

                    case E_TFmode:
                      if (altivec_register_operand (operands[1], E_TFmode)
                          && (
#line 5200 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                        return 1553; /* xsxexpqp_tf_di */
                      break;

                    default:
                      break;
                    }
                }
              if (!register_operand (operands[0], E_DImode)
                  || !vsx_register_operand (operands[1], E_DFmode)
                  || !(
#line 5209 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 1555; /* xsxexpdp_di */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !vsx_register_operand (operands[1], E_DFmode)
                  || !
#line 5209 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1554; /* xsxexpdp_si */

            default:
              return -1;
            }

        case 147:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!vsx_register_operand (operands[1], E_DFmode)
              || !
#line 5228 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1560; /* xsxsigdp */

        case 168:
          switch (pattern220 (x3))
            {
            case 0:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1609; /* vclzlsbb_v16qi */

            case 1:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1611; /* vclzlsbb_v8hi */

            case 2:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1613; /* vclzlsbb_v4si */

            default:
              return -1;
            }

        case 169:
          switch (pattern220 (x3))
            {
            case 0:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1610; /* vctzlsbb_v16qi */

            case 1:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1612; /* vctzlsbb_v8hi */

            case 2:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1614; /* vctzlsbb_v4si */

            default:
              return -1;
            }

        case 193:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!altivec_register_operand (operands[1], E_V16QImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1639; /* vec_extract_v16qi */

            case E_V8HImode:
              if (!altivec_register_operand (operands[1], E_V8HImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1640; /* vec_extract_v8hi */

            case E_V4SImode:
              if (!altivec_register_operand (operands[1], E_V4SImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1641; /* vec_extract_v4si */

            case E_V2DImode:
              if (!altivec_register_operand (operands[1], E_V2DImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1642; /* vec_extract_v2di */

            case E_V1TImode:
              if (!altivec_register_operand (operands[1], E_V1TImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1643; /* vec_extract_v1ti */

            default:
              return -1;
            }

        case 283:
          if (pattern219 (x3, 
E_SImode, 
108) != 0
              || !register_operand (operands[0], E_SImode)
              || !
#line 407 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1700; /* get_vrsave_internal */

        case 281:
          if (GET_MODE (x3) != E_SImode
              || !memory_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_V4SImode)
              || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2136; /* altivec_stvewx */

        case 426:
          if (GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[1]))
            {
            case E_DDmode:
              if (!gpc_reg_operand (operands[1], E_DDmode)
                  || !
#line 325 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2308; /* dfp_dxex_dd */

            case E_TDmode:
              if (!gpc_reg_operand (operands[1], E_TDmode)
                  || !
#line 325 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2309; /* dfp_dxex_td */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 49:
          if (pattern322 (x3, 
E_DImode) != 0
              || !(
#line 14443 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 946; /* bpermd_di */

        case 65:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 14821 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
            return -1;
          return 966; /* addg6s */

        case 68:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern141 (x3, 
E_SImode) != 0
                  || !
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                return -1;
              return 969; /* dive_si */

            case E_DImode:
              if (pattern141 (x3, 
E_DImode) != 0
                  || !(
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 971; /* dive_di */

            default:
              return -1;
            }

        case 69:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern141 (x3, 
E_SImode) != 0
                  || !
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                return -1;
              return 970; /* diveu_si */

            case E_DImode:
              if (pattern141 (x3, 
E_DImode) != 0
                  || !(
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 972; /* diveu_di */

            default:
              return -1;
            }

        case 70:
          if (GET_MODE (x3) != E_DImode
              || !const_0_to_1_operand (operands[2], E_QImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_TDmode))
            {
              if ((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                return 975; /* unpacktd_dm */
              if ((
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                return 978; /* unpacktd_nodm */
            }
          if (!register_operand (operands[0], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1TImode:
              if (!register_operand (operands[1], E_V1TImode)
                  || !
#line 14991 "../../gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                return -1;
              return 983; /* unpackv1ti */

            case E_KFmode:
              if (!register_operand (operands[1], E_KFmode)
                  || !
#line 14991 "../../gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)))
                return -1;
              return 984; /* unpackkf */

            default:
              return -1;
            }

        case 144:
          if (pattern322 (x3, 
E_V2DImode) != 0
              || !
#line 3646 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1394; /* vsx_vslo_v2di */

        case 145:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[2], E_DImode))
            return -1;
          switch (pattern206 (x3))
            {
            case 0:
              if (gpc_reg_operand (operands[1], E_V2DImode)
                  && 
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                {
                  *pnum_clobbers = 2;
                  return 1396; /* vsx_extract_v2di_var */
                }
              if (!memory_operand (operands[1], E_V2DImode)
                  || !
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1398; /* *vsx_extract_v2di_var_load */

            case 1:
              if (gpc_reg_operand (operands[1], E_V4SImode)
                  && 
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                {
                  *pnum_clobbers = 2;
                  return 1424; /* vsx_extract_v4si_var */
                }
              if (!memory_operand (operands[1], E_V4SImode)
                  || !
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1427; /* *vsx_extract_v4si_var_load */

            default:
              return -1;
            }

        case 170:
          if (pattern323 (x3, 
E_V16QImode) != 0
              || !
#line 5974 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1615; /* vextublx */

        case 173:
          if (pattern323 (x3, 
E_V16QImode) != 0
              || !
#line 5985 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1616; /* vextubrx */

        case 171:
          if (pattern323 (x3, 
E_V8HImode) != 0
              || !
#line 5996 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1617; /* vextuhlx */

        case 174:
          if (pattern323 (x3, 
E_V8HImode) != 0
              || !
#line 6007 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1618; /* vextuhrx */

        case 172:
          if (pattern323 (x3, 
E_V4SImode) != 0
              || !
#line 6018 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1619; /* vextuwlx */

        case 175:
          if (pattern323 (x3, 
E_V4SImode) != 0
              || !
#line 6029 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1620; /* vextuwrx */

        case 191:
          if (GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || !const_0_to_1_operand (operands[2], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!altivec_register_operand (operands[1], E_V16QImode)
                  || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1635; /* vec_cntmb_v16qi */

            case E_V8HImode:
              if (!altivec_register_operand (operands[1], E_V8HImode)
                  || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1636; /* vec_cntmb_v8hi */

            case E_V4SImode:
              if (!altivec_register_operand (operands[1], E_V4SImode)
                  || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1637; /* vec_cntmb_v4si */

            case E_V2DImode:
              if (!altivec_register_operand (operands[1], E_V2DImode)
                  || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1638; /* vec_cntmb_v2di */

            default:
              return -1;
            }

        case 351:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !altivec_register_operand (operands[1], E_V2DImode)
              || !u3bit_cint_operand (operands[2], E_QImode)
              || !
#line 4681 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 2201; /* vgnb */

        case 443:
          if (GET_MODE (x3) != E_DImode
              || !base_reg_operand (operands[0], E_DImode)
              || !pcrel_external_address (operands[1], E_DImode)
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 125 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3192; /* pcrel_opt_ld_addr_same_reg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_117 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[4] = x9;
          if (!const_2_to_3_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern486 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 3855 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1403; /* vsx_xxpermdi2_v2df_1 */

            case E_V2DImode:
              if (pattern486 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 3855 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1404; /* vsx_xxpermdi2_v2di_1 */

            default:
              return -1;
            }

        case 16:
          if (pattern221 (x3) != 0
              || pattern513 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 16L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 17L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 18L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 19L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 4L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 20L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 5L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 21L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 6L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 22L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 7L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 23L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1177 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1845; /* altivec_vmrghb_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1351 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1855; /* altivec_vmrglb_direct_le */

            case 8L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 24L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 9L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 25L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 10L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 26L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 11L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 27L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 12L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 28L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 13L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 29L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 14L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 30L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 15L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 31L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1195 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1846; /* altivec_vmrghb_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1333 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1854; /* altivec_vmrglb_direct_be */

            default:
              return -1;
            }

        case 8:
          if (pattern222 (x3) != 0
              || pattern513 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 8L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 9L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 10L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 11L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1224 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1847; /* altivec_vmrghh_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1394 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1857; /* altivec_vmrglh_direct_le */

            case 4L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 12L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 5L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 13L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 6L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 14L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 7L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 15L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1238 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1848; /* altivec_vmrghh_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1380 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1856; /* altivec_vmrglh_direct_be */

            default:
              return -1;
            }

        case 4:
          if (pattern223 (x3) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 4L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              switch (XWINT (x10, 0))
                {
                case 1L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 5L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern513 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1849; /* altivec_vmrghw_direct_v4sf_be */
                      if (
#line 1295 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                        return 1853; /* *altivec_vmrghsf */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1860; /* altivec_vmrglw_direct_v4sf_le */

                    case E_V4SImode:
                      if (pattern513 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1850; /* altivec_vmrghw_direct_v4si_be */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1861; /* altivec_vmrglw_direct_v4si_le */

                    default:
                      return -1;
                    }

                case 2L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 6L)
                    return -1;
                  switch (pattern515 (x2))
                    {
                    case 0:
                      if (!
#line 1487 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1863; /* p8_vmrgew_v4sf */

                    case 1:
                      if (!
#line 1487 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1864; /* p8_vmrgew_v4si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 2L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 6L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern513 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1851; /* altivec_vmrghw_direct_v4sf_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (
#line 1423 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return 1858; /* altivec_vmrglw_direct_v4sf_be */
                  if (!
#line 1451 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                    return -1;
                  return 1862; /* *altivec_vmrglsf */

                case E_V4SImode:
                  if (pattern513 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1852; /* altivec_vmrghw_direct_v4si_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (!
#line 1423 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return -1;
                  return 1859; /* altivec_vmrglw_direct_v4si_be */

                default:
                  return -1;
                }

            case 1L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 5L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (pattern515 (x2))
                {
                case 0:
                  if (!
#line 1504 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1865; /* p8_vmrgow_v4sf */

                case 1:
                  if (!
#line 1504 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1866; /* p8_vmrgow_v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern166 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1532; /* *vsx_reduc_plus_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1535; /* *vsx_reduc_plus_v4sf_scalar */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern166 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1533; /* *vsx_reduc_smin_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1536; /* *vsx_reduc_smin_v4sf_scalar */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern166 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1534; /* *vsx_reduc_smax_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1537; /* *vsx_reduc_smax_v4sf_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 19; /* extendqisi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode))
                return -1;
              return 25; /* *extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode)
                  || !
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 20; /* extendqidi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode)
                  || !
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 26; /* *extendhidi2 */

            case E_SImode:
              if (!lwa_operand (operands[1], E_SImode)
                  || !
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 31; /* extendsidi2 */

            default:
              return -1;
            }

        case E_TImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !input_operand (operands[1], E_DImode)
              || !
#line 5133 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && TARGET_POWER10))
            return -1;
          *pnum_clobbers = 1;
          return 1548; /* extendditi2 */

        default:
          return -1;
        }

    case PLUS:
      if (pattern35 (x3) != 0
          || !
#line 2388 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 115; /* *subfsi3_carry_in_xx_64 */

    case ASHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode
          || pattern118 (x3, 
E_SImode) != 0
          || !
#line 4906 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 1;
      return 290; /* *ashrsi3_64 */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 3)
        return -1;
      switch (pattern198 (x4))
        {
        case 0:
          if (!int_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!d_form_memory (operands[1], E_SImode)
                  || !(
#line 170 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 3199; /* *pcrel_opt_ldsi_di_gpr */

            case E_HImode:
              if (!d_form_memory (operands[1], E_HImode)
                  || !(
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 3203; /* *pcrel_opt_ldhi_di_gpr */

            default:
              return -1;
            }

        case 1:
          if (!int_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode
              || !d_form_memory (operands[1], E_HImode)
              || !
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          *pnum_clobbers = 1;
          return 3201; /* *pcrel_opt_ldhi_si_gpr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern121 (x3, 
E_SImode) == 0)
            return 264; /* rotlsi3 */
          break;

        case E_DImode:
          if (pattern121 (x3, 
E_DImode) == 0
              && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return 265; /* rotldi3 */
          break;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) == 0
              && 
#line 1989 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return 1903; /* altivec_vrlw */
          break;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) == 0
              && 
#line 1989 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return 1904; /* altivec_vrlh */
          break;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) == 0
              && 
#line 1989 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return 1905; /* altivec_vrlb */
          break;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) == 0
              && 
#line 1989 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return 1906; /* altivec_vrld */
          break;

        case E_V1TImode:
          if (pattern2 (x3, 
E_V1TImode) == 0
              && 
#line 1997 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return 1907; /* altivec_vrlq */
          break;

        default:
          break;
        }
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !input_operand (operands[1], E_V1TImode)
              || !
#line 1003 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1165; /* *vsx_le_permute_v1ti */

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !input_operand (operands[1], E_TImode)
              || !
#line 1003 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1166; /* *vsx_le_permute_ti */

        default:
          return -1;
        }

    case ROTATE:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (pattern205 (x3))
        {
        case 0:
          if (!
#line 1021 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1167; /* *vsx_le_undo_permute_v1ti */

        case 1:
          if (!
#line 1021 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1168; /* *vsx_le_undo_permute_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 98)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 98)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern525 (x1, 
E_SImode) != 0)
        return -1;
      return 80; /* *addsi3_carry_in_internal */

    case E_DImode:
      if (pattern525 (x1, 
E_DImode) != 0
          || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 81; /* *adddi3_carry_in_internal */

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case XOR:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 1);
      operands[1] = x10;
      x11 = XEXP (x6, 1);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern504 (x6, 
E_SImode) != 0
                  || !
#line 403 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2384; /* *fuse_eqv_and */

            case E_DImode:
              if (pattern504 (x6, 
E_DImode) != 0
                  || !(
#line 403 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2385; /* *fuse_eqv_and */

            case E_V4SImode:
              if (pattern505 (x6, 
E_V4SImode) != 0
                  || !
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2568; /* *fuse_veqv_vand */

            case E_V8HImode:
              if (pattern505 (x6, 
E_V8HImode) != 0
                  || !
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2569; /* *fuse_veqv_vand */

            case E_V16QImode:
              if (pattern505 (x6, 
E_V16QImode) != 0
                  || !
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2570; /* *fuse_veqv_vand */

            case E_V4SFmode:
              if (pattern505 (x6, 
E_V4SFmode) != 0
                  || !
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2571; /* *fuse_veqv_vand */

            case E_V2DFmode:
              if (pattern505 (x6, 
E_V2DFmode) != 0
                  || !
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2572; /* *fuse_veqv_vand */

            case E_V2DImode:
              if (pattern505 (x6, 
E_V2DImode) != 0
                  || !
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2573; /* *fuse_veqv_vand */

            case E_V1TImode:
              if (pattern505 (x6, 
E_V1TImode) != 0
                  || !
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2574; /* *fuse_veqv_vand */

            case E_TImode:
              if (pattern505 (x6, 
E_TImode) != 0
                  || !
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2575; /* *fuse_veqv_vand */

            case E_KFmode:
              if (pattern505 (x6, 
E_KFmode) != 0
                  || !(
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2576; /* *fuse_veqv_vand */

            case E_TFmode:
              if (pattern505 (x6, 
E_TFmode) != 0
                  || !(
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2577; /* *fuse_veqv_vand */

            default:
              return -1;
            }

        case NOT:
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern374 (x6, 
E_SImode) != 0
                  || !
#line 583 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2404; /* *fuse_eqv_andc */

            case E_DImode:
              if (pattern374 (x6, 
E_DImode) != 0
                  || !(
#line 583 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2405; /* *fuse_eqv_andc */

            case E_V4SImode:
              if (pattern376 (x6, 
E_V4SImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2648; /* *fuse_veqv_vandc */

            case E_V8HImode:
              if (pattern376 (x6, 
E_V8HImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2649; /* *fuse_veqv_vandc */

            case E_V16QImode:
              if (pattern376 (x6, 
E_V16QImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2650; /* *fuse_veqv_vandc */

            case E_V4SFmode:
              if (pattern376 (x6, 
E_V4SFmode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2651; /* *fuse_veqv_vandc */

            case E_V2DFmode:
              if (pattern376 (x6, 
E_V2DFmode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2652; /* *fuse_veqv_vandc */

            case E_V2DImode:
              if (pattern376 (x6, 
E_V2DImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2653; /* *fuse_veqv_vandc */

            case E_V1TImode:
              if (pattern376 (x6, 
E_V1TImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2654; /* *fuse_veqv_vandc */

            case E_TImode:
              if (pattern376 (x6, 
E_TImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2655; /* *fuse_veqv_vandc */

            case E_KFmode:
              if (pattern376 (x6, 
E_KFmode) != 0
                  || !(
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2656; /* *fuse_veqv_vandc */

            case E_TFmode:
              if (pattern376 (x6, 
E_TFmode) != 0
                  || !(
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2657; /* *fuse_veqv_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern384 (x6))
        {
        case 0:
          if (!
#line 1015 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2452; /* *fuse_and_nor */

        case 1:
          if (!(
#line 1015 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2453; /* *fuse_and_nor */

        case 2:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2868; /* *fuse_vand_vnor */

        case 3:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2869; /* *fuse_vand_vnor */

        case 4:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2870; /* *fuse_vand_vnor */

        case 5:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2871; /* *fuse_vand_vnor */

        case 6:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2872; /* *fuse_vand_vnor */

        case 7:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2873; /* *fuse_vand_vnor */

        case 8:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2874; /* *fuse_vand_vnor */

        case 9:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2875; /* *fuse_vand_vnor */

        case 10:
          if (!(
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2876; /* *fuse_vand_vnor */

        case 11:
          if (!(
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2877; /* *fuse_vand_vnor */

        case 12:
          if (!
#line 1033 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2454; /* *fuse_andc_nor */

        case 13:
          if (!(
#line 1033 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2455; /* *fuse_andc_nor */

        case 14:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2878; /* *fuse_vandc_vnor */

        case 15:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2879; /* *fuse_vandc_vnor */

        case 16:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2880; /* *fuse_vandc_vnor */

        case 17:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2881; /* *fuse_vandc_vnor */

        case 18:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2882; /* *fuse_vandc_vnor */

        case 19:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2883; /* *fuse_vandc_vnor */

        case 20:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2884; /* *fuse_vandc_vnor */

        case 21:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2885; /* *fuse_vandc_vnor */

        case 22:
          if (!(
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2886; /* *fuse_vandc_vnor */

        case 23:
          if (!(
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2887; /* *fuse_vandc_vnor */

        case 24:
          if (!
#line 1087 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2460; /* *fuse_nor_nor */

        case 25:
          if (!(
#line 1087 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2461; /* *fuse_nor_nor */

        case 26:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2908; /* *fuse_vnor_vnor */

        case 27:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2909; /* *fuse_vnor_vnor */

        case 28:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2910; /* *fuse_vnor_vnor */

        case 29:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2911; /* *fuse_vnor_vnor */

        case 30:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2912; /* *fuse_vnor_vnor */

        case 31:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2913; /* *fuse_vnor_vnor */

        case 32:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2914; /* *fuse_vnor_vnor */

        case 33:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2915; /* *fuse_vnor_vnor */

        case 34:
          if (!(
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2916; /* *fuse_vnor_vnor */

        case 35:
          if (!(
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2917; /* *fuse_vnor_vnor */

        default:
          return -1;
        }

    case NOT:
      switch (pattern387 (x6))
        {
        case 0:
          if (!
#line 1051 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2456; /* *fuse_eqv_nor */

        case 1:
          if (!(
#line 1051 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2457; /* *fuse_eqv_nor */

        case 2:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2888; /* *fuse_veqv_vnor */

        case 3:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2889; /* *fuse_veqv_vnor */

        case 4:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2890; /* *fuse_veqv_vnor */

        case 5:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2891; /* *fuse_veqv_vnor */

        case 6:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2892; /* *fuse_veqv_vnor */

        case 7:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2893; /* *fuse_veqv_vnor */

        case 8:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2894; /* *fuse_veqv_vnor */

        case 9:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2895; /* *fuse_veqv_vnor */

        case 10:
          if (!(
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2896; /* *fuse_veqv_vnor */

        case 11:
          if (!(
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2897; /* *fuse_veqv_vnor */

        default:
          return -1;
        }

    case IOR:
      switch (pattern388 (x6))
        {
        case 0:
          if (!
#line 1069 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2458; /* *fuse_nand_nor */

        case 1:
          if (!(
#line 1069 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2459; /* *fuse_nand_nor */

        case 2:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2898; /* *fuse_vnand_vnor */

        case 3:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2899; /* *fuse_vnand_vnor */

        case 4:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2900; /* *fuse_vnand_vnor */

        case 5:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2901; /* *fuse_vnand_vnor */

        case 6:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2902; /* *fuse_vnand_vnor */

        case 7:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2903; /* *fuse_vnand_vnor */

        case 8:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2904; /* *fuse_vnand_vnor */

        case 9:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2905; /* *fuse_vnand_vnor */

        case 10:
          if (!(
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2906; /* *fuse_vnand_vnor */

        case 11:
          if (!(
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2907; /* *fuse_vnand_vnor */

        case 12:
          if (!
#line 1123 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2464; /* *fuse_orc_nor */

        case 13:
          if (!(
#line 1123 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2465; /* *fuse_orc_nor */

        case 14:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2928; /* *fuse_vorc_vnor */

        case 15:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2929; /* *fuse_vorc_vnor */

        case 16:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2930; /* *fuse_vorc_vnor */

        case 17:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2931; /* *fuse_vorc_vnor */

        case 18:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2932; /* *fuse_vorc_vnor */

        case 19:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2933; /* *fuse_vorc_vnor */

        case 20:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2934; /* *fuse_vorc_vnor */

        case 21:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2935; /* *fuse_vorc_vnor */

        case 22:
          if (!(
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2936; /* *fuse_vorc_vnor */

        case 23:
          if (!(
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2937; /* *fuse_vorc_vnor */

        case 24:
          if (!
#line 1105 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2462; /* *fuse_or_nor */

        case 25:
          if (!(
#line 1105 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2463; /* *fuse_or_nor */

        case 26:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2918; /* *fuse_vor_vnor */

        case 27:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2919; /* *fuse_vor_vnor */

        case 28:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2920; /* *fuse_vor_vnor */

        case 29:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2921; /* *fuse_vor_vnor */

        case 30:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2922; /* *fuse_vor_vnor */

        case 31:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2923; /* *fuse_vor_vnor */

        case 32:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2924; /* *fuse_vor_vnor */

        case 33:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2925; /* *fuse_vor_vnor */

        case 34:
          if (!(
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2926; /* *fuse_vor_vnor */

        case 35:
          if (!(
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2927; /* *fuse_vor_vnor */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern389 (x6))
        {
        case 0:
          if (!
#line 1159 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2468; /* *fuse_add_nor */

        case 1:
          if (!(
#line 1159 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2469; /* *fuse_add_nor */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern389 (x6))
        {
        case 0:
          if (!
#line 1177 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2470; /* *fuse_subf_nor */

        case 1:
          if (!(
#line 1177 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2471; /* *fuse_subf_nor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (XINT (x4, 1) != 87
              || GET_MODE (x4) != E_SImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[1] = x7;
          if (!input_operand (operands[1], E_SFmode))
            return -1;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!scratch_operand (operands[2], E_V4SFmode)
              || !
#line 7892 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))))
            return -1;
          return 559; /* *movdi_from_sf_zero_ext */

        case 3:
          if (XINT (x4, 1) != 444)
            return -1;
          switch (pattern390 (x1))
            {
            case 0:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  if (!d_form_memory (operands[1], E_SImode)
                      || !(
#line 170 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3200; /* *pcrel_opt_ldsi_udi_gpr */

                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !(
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3204; /* *pcrel_opt_ldhi_udi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !(
#line 200 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3206; /* *pcrel_opt_ldqi_udi_gpr */

                default:
                  return -1;
                }

            case 1:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  return 3202; /* *pcrel_opt_ldhi_usi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !
#line 200 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  return 3205; /* *pcrel_opt_ldqi_usi_gpr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      if (pattern188 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          switch (pattern528 (x1, 
E_SImode))
            {
            case 0:
              if (!(
#line 10372 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 703; /* *movhi_update2 */

            case 1:
              if (!(
#line 10372 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 705; /* *movhi_update2 */

            case 2:
              if (!(
#line 10439 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 715; /* *movqi_update2 */

            case 3:
              if (!(
#line 10439 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 717; /* *movqi_update2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern528 (x1, 
E_DImode))
            {
            case 0:
              if (!(
#line 10372 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 704; /* *movhi_update2 */

            case 1:
              if (!(
#line 10372 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 706; /* *movhi_update2 */

            case 2:
              if (!(
#line 10439 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 716; /* *movqi_update2 */

            case 3:
              if (!(
#line 10439 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 718; /* *movqi_update2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      if (vsx_register_operand (operands[1], E_V4SImode)
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x4) == E_SImode)
        {
          x11 = XVECEXP (x9, 0, 0);
          operands[2] = x11;
          if (const_int_operand (operands[2], E_QImode))
            {
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              if (scratch_operand (operands[3], E_V4SImode)
                  && 
#line 3957 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
                return 1406; /* *mfvsrwz */
            }
        }
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      switch (pattern471 (x1))
        {
        case 0:
          if (!
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1410; /* *vsx_extract_v16qi_di_p9 */

        case 1:
          if (!
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1411; /* *vsx_extract_v8hi_di_p9 */

        case 2:
          if (!
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1412; /* *vsx_extract_v4si_di_p9 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case COMPARE:
          switch (pattern93 (x1))
            {
            case 0:
              if (!
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 71; /* *addsi3_imm_dot */

            case 1:
              if (!(
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 72; /* *adddi3_imm_dot */

            case 2:
              if (!
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 73; /* *addsi3_imm_dot2 */

            case 3:
              if (!(
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 74; /* *adddi3_imm_dot2 */

            case 4:
              if (!(
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 102; /* subfsi3_carry_dot2 */

            case 5:
              if (!(
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 103; /* subfdi3_carry_dot2 */

            case 6:
              if (!
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 183; /* *divsi3_sra_dot */

            case 7:
              if (!(
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 184; /* *divdi3_sra_dot */

            case 8:
              if (!
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 185; /* *divsi3_sra_dot2 */

            case 9:
              if (!(
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 186; /* *divdi3_sra_dot2 */

            case 10:
              if (!
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
                return -1;
              return 190; /* *andsi3_imm_dot */

            case 11:
              if (!(
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 191; /* *anddi3_imm_dot */

            case 12:
              if (!
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
                return -1;
              return 192; /* *andsi3_imm_dot2 */

            case 13:
              if (!(
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 193; /* *anddi3_imm_dot2 */

            case 14:
              if (!
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 291; /* *ashrsi3_dot */

            case 15:
              if (!(
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 292; /* *ashrdi3_dot */

            case 16:
              if (!
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 293; /* *ashrsi3_dot2 */

            case 17:
              if (!(
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 294; /* *ashrdi3_dot2 */

            default:
              return -1;
            }

        case BSWAP:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (gpc_reg_operand (operands[1], E_DImode)
              && gpc_reg_operand (operands[0], E_DImode))
            {
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (scratch_operand (operands[2], E_DImode))
                {
                  x9 = XEXP (x5, 0);
                  operands[3] = x9;
                  if (scratch_operand (operands[3], E_DImode)
                      && 
#line 2806 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX && !TARGET_P9_VECTOR))
                    return 151; /* bswapdi2_reg */
                }
            }
          if (!reg_or_mem_operand (operands[1], E_DImode)
              || !reg_or_mem_operand (operands[0], E_DImode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          if (!scratch_operand (operands[2], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (!scratch_operand (operands[3], E_DImode)
              || !
#line 2816 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX
   && (REG_P (operands[0]) || REG_P (operands[1]))
   && !(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))
   && !(MEM_P (operands[1]) && MEM_VOLATILE_P (operands[1]))))
            return -1;
          return 152; /* *bswapdi2_64bit */

        case IF_THEN_ELSE:
          switch (pattern94 (x1))
            {
            case 0:
              if (!
#line 3906 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64))
                return -1;
              return 212; /* *branch_anddi3_dot */

            case 1:
              if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
                return -1;
              return 561; /* *rotate_on_cmpdi */

            case 2:
              if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
                return -1;
              return 562; /* *rotate_on_cmpdi */

            default:
              return -1;
            }

        case UNSIGNED_FLOAT:
          switch (pattern98 (x1))
            {
            case 0:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 410; /* *floatunsqisf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 411; /* *floatunshisf2_internal */

            case 2:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 412; /* *floatunsqidf2_internal */

            case 3:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 413; /* *floatunshidf2_internal */

            case 4:
              if (!
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
                return -1;
              return 460; /* *roundu32sf2_fprs */

            case 5:
              if (!
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
                return -1;
              return 461; /* *roundu32df2_fprs */

            case 6:
              if (!
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1463; /* *vsx_extract_si_unsfloat_sf */

            case 7:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
                return -1;
              return 1465; /* *vsx_extract_si_unsfloat_if */

            case 8:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
                return -1;
              return 1467; /* *vsx_extract_si_unsfloat_kf */

            case 9:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
                return -1;
              return 1469; /* *vsx_extract_si_unsfloat_tf */

            default:
              return -1;
            }

        case FIX:
          switch (pattern99 (x1))
            {
            case 0:
              if (!
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
                return -1;
              return 416; /* fix_truncsfsi2_internal */

            case 1:
              if (!
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
                return -1;
              return 417; /* fix_truncdfsi2_internal */

            default:
              return -1;
            }

        case FLOAT:
          switch (pattern100 (x1))
            {
            case 0:
              if (!
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
                return -1;
              return 458; /* *round32sf2_fprs */

            case 1:
              if (!
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
                return -1;
              return 459; /* *round32df2_fprs */

            case 2:
              if (!
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1462; /* *vsx_extract_si_float_sf */

            case 3:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
                return -1;
              return 1464; /* *vsx_extract_si_float_if */

            case 4:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
                return -1;
              return 1466; /* *vsx_extract_si_float_kf */

            case 5:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
                return -1;
              return 1468; /* *vsx_extract_si_float_tf */

            default:
              return -1;
            }

        case CALL:
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != MEM)
            return -1;
          switch (pattern189 (x1))
            {
            case 0:
              x5 = XVECEXP (x1, 0, 2);
              switch (pattern428 (x5, pnum_clobbers))
                {
                case 0:
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11512 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 776; /* *call_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  if ((
#line 11637 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 781; /* *call_value_nonlocal_sysvdi */
                  if (!(
#line 11705 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 784; /* *call_value_nonlocal_aixdi */

                case 1:
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  x9 = XEXP (x5, 0);
                  operands[4] = x9;
                  if (!register_operand (operands[4], E_SImode)
                      || !(
#line 11662 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 782; /* *call_value_nonlocal_sysv_securedi */

                case 2:
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11949 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 794; /* *sibcall_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !(
#line 12045 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 798; /* *sibcall_value_nonlocal_sysvdi */

                default:
                  return -1;
                }

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              switch (GET_CODE (x5))
                {
                case CLOBBER:
                  x9 = XEXP (x5, 0);
                  if (GET_CODE (x9) != REG
                      || REGNO (x9) != 96)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_DImode:
                      if (!indirect_call_operand (operands[1], E_DImode)
                          || !unspec_tls (operands[2], E_DImode)
                          || GET_MODE (x9) != E_DImode)
                        return -1;
                      if ((
#line 11609 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return 780; /* *call_value_indirect_nonlocal_sysvdi */
                      if (!(
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return -1;
                      return 792; /* *call_value_indirect_pcreldi */

                    case E_SImode:
                      if (!indirect_call_operand (operands[1], E_SImode)
                          || !unspec_tls (operands[2], E_SImode)
                          || GET_MODE (x9) != E_SImode
                          || !(
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        return -1;
                      return 791; /* *call_value_indirect_pcrelsi */

                    default:
                      return -1;
                    }

                case SET:
                  if (pattern473 (x5, pnum_clobbers) != 0
                      || !indirect_call_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  x10 = XEXP (x5, 1);
                  x11 = XVECEXP (x10, 0, 0);
                  operands[4] = x11;
                  if (!const_int_operand (operands[4], E_DImode)
                      || !(
#line 11806 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 790; /* *call_value_indirect_elfv2di */

                case SIMPLE_RETURN:
                  if (!indirect_call_operand (operands[1], E_DImode)
                      || !(
#line 12016 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 797; /* *sibcall_value_indirect_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 2)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x12 = XVECEXP (x3, 0, 0);
          operands[1] = x12;
          x13 = XVECEXP (x3, 0, 1);
          operands[2] = x13;
          switch (XINT (x3, 1))
            {
            case 35:
              if (GET_MODE (x3) != E_CCEQmode)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x14 = XEXP (x4, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !cc_reg_operand (operands[0], E_CCEQmode)
                  || !memory_operand (operands[1], E_DImode)
                  || !memory_operand (operands[2], E_DImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_DImode))
                return -1;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!scratch_operand (operands[3], E_DImode))
                return -1;
              return 805; /* stack_protect_testdi */

            case 145:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              switch (pattern457 (x1))
                {
                case 0:
                  if (!
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1395; /* vsx_extract_v2df_var */

                case 1:
                  if (!
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1396; /* vsx_extract_v2di_var */

                case 2:
                  if (!
#line 3745 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1401; /* vsx_extract_v4sf_var */

                case 3:
                  if (!
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1422; /* vsx_extract_v16qi_var */

                case 4:
                  if (!
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1423; /* vsx_extract_v8hi_var */

                case 5:
                  if (!
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1424; /* vsx_extract_v4si_var */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          switch (pattern102 (x1))
            {
            case 0:
              if (!
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)))
                return -1;
              return 858; /* *eqsi3 */

            case 1:
              if (!(
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 859; /* *eqdi3 */

            case 2:
              if (!(
#line 13220 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 867; /* *eqsi3_extdi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x15 = XEXP (x8, 0);
          operands[1] = x15;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!cc_reg_operand (operands[2], E_CCmode)
              || !(
#line 13656 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 905; /* tablejumpdi_insn_nospec */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 6
              || GET_MODE (x3) != E_DImode)
            return -1;
          x12 = XVECEXP (x3, 0, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!scratch_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!scratch_operand (operands[2], E_CCmode)
              || !
#line 14589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
            return -1;
          return 955; /* rs6000_get_timebase_ppc32 */

        case VEC_SELECT:
          switch (pattern104 (x1))
            {
            case 0:
              if (!
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
                return -1;
              return 1413; /* *vsx_extract_v16qi_store_p9 */

            case 1:
              if (!
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
                return -1;
              return 1414; /* *vsx_extract_v8hi_store_p9 */

            case 2:
              if (!
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
                return -1;
              return 1415; /* *vsx_extract_v4si_store_p9 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern105 (x1) != 0
              || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1529; /* vsx_reduc_plus_v4sf */

        case SMIN:
          if (pattern105 (x1) != 0
              || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1530; /* vsx_reduc_smin_v4sf */

        case SMAX:
          if (pattern105 (x1) != 0
              || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1531; /* vsx_reduc_smax_v4sf */

        case FLOAT_TRUNCATE:
          if (GET_MODE (x3) != E_SDmode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!gpc_reg_operand (operands[0], E_SDmode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!gpc_reg_operand (operands[1], E_TDmode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          if (!scratch_operand (operands[2], E_TDmode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (!scratch_operand (operands[3], E_DFmode)
              || !
#line 165 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2284; /* trunctdsd2 */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x16 = XEXP (x6, 0);
      operands[0] = x16;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      switch (GET_CODE (operands[0]))
        {
        case SYMBOL_REF:
          x5 = XVECEXP (x1, 0, 2);
          switch (pattern428 (x5, pnum_clobbers))
            {
            case 0:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              if (current_file_function_operand (operands[0], E_DImode)
                  && (
#line 11491 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 775; /* *call_localdi */
              if (!symbol_ref_operand (operands[0], E_DImode))
                return -1;
              if ((
#line 11567 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 778; /* *call_nonlocal_sysvdi */
              if (!(
#line 11688 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 783; /* *call_nonlocal_aixdi */

            case 1:
              if (!symbol_ref_operand (operands[0], E_DImode)
                  || !immediate_operand (operands[2], E_SImode))
                return -1;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!register_operand (operands[3], E_SImode)
                  || !(
#line 11588 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 779; /* *call_nonlocal_sysv_securedi */

            case 2:
              if (current_file_function_operand (operands[0], E_DImode)
                  && immediate_operand (operands[2], E_SImode)
                  && (
#line 11930 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 793; /* *sibcall_localdi */
              if (!symbol_ref_operand (operands[0], E_DImode)
                  || !immediate_operand (operands[2], E_VOIDmode)
                  || !(
#line 11995 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 796; /* *sibcall_nonlocal_sysvdi */

            default:
              return -1;
            }

        case UNSPEC:
        case REG:
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case CLOBBER:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!indirect_call_operand (operands[0], E_DImode)
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  if ((
#line 11539 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 777; /* *call_indirect_nonlocal_sysvdi */
                  if (!(
#line 11786 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 789; /* *call_indirect_pcreldi */

                case E_SImode:
                  if (!indirect_call_operand (operands[0], E_SImode)
                      || GET_MODE (x9) != E_SImode
                      || !(
#line 11786 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 788; /* *call_indirect_pcrelsi */

                default:
                  return -1;
                }

            case SET:
              if (pattern473 (x5, pnum_clobbers) != 0
                  || !indirect_call_operand (operands[0], E_DImode))
                return -1;
              x10 = XEXP (x5, 1);
              x11 = XVECEXP (x10, 0, 0);
              operands[3] = x11;
              if (!const_int_operand (operands[3], E_DImode)
                  || !(
#line 11770 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 787; /* *call_indirect_elfv2di */

            case SIMPLE_RETURN:
              if (!indirect_call_operand (operands[0], E_DImode)
                  || !(
#line 11967 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 795; /* *sibcall_indirect_nonlocal_sysvdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case MEM:
          operands[1] = x4;
          if (!indexed_or_indirect_operand (operands[1], E_HImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!altivec_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 1106 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
                return NULL;
              return gen_split_15 (insn, operands);

            case E_DImode:
              if (!altivec_register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !(
#line 1106 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_16 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (vsx_register_operand (operands[1], E_SImode)
              && int_reg_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && (
#line 1180 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && reload_completed) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return gen_split_21 (insn, operands);
          if (!altivec_register_operand (operands[1], E_SImode)
              || !altivec_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 1192 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && !TARGET_P9_VECTOR && reload_completed))
            return NULL;
          return gen_split_22 (insn, operands);

        case PLUS:
          if (pattern35 (x2) != 0
              || !(
#line 2388 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 2390 "../../gcc/config/rs6000/rs6000.md"
(1)))
            return NULL;
          return gen_split_45 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2708 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], SImode)))
        return NULL;
      return gen_split_51 (insn, operands);

    case ASHIFT:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != SIGN_EXTEND
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_mem_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!u6bit_cint_operand (operands[2], E_DImode)
          || !(
#line 4707 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4711 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && MEM_P (operands[1]))))
        return NULL;
      return gen_split_137 (insn, operands);

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_VOIDmode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!gpc_reg_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !
#line 4984 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 4984 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_V4SFmode:
          if (!gpc_reg_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !
#line 4984 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (V4SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_V2DFmode:
          if (!gpc_reg_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !
#line 4984 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (V2DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !reg_or_mem_operand (operands[1], E_SFmode)
              || !(
#line 5241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)) && 
#line 5250 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && REG_P (operands[1]) && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_152 (insn, operands);

        case E_IFmode:
          switch (pattern195 (x2))
            {
            case 0:
              if (!((
#line 8930 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8932 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_324 (insn, operands);

            case 1:
              if (!(
#line 9461 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)) && 
#line 9464 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_338 (insn, operands);

            default:
              return NULL;
            }

        case E_TFmode:
          if (GET_MODE (x2) != E_TFmode)
            return NULL;
          if (gpc_reg_operand (operands[0], E_TFmode))
            {
              switch (pattern299 ())
                {
                case 0:
                  if (((
#line 8930 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8932 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_325 (insn, operands);
                  break;

                case 1:
                  if ((
#line 9448 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)) && 
#line 9451 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_336 (insn, operands);
                  break;

                case 2:
                  if ((
#line 9448 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)) && 
#line 9451 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_337 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_TFmode)
              || !vsx_register_operand (operands[1], E_KFmode)
              || !(
#line 15211 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD) && 
#line 15215 "../../gcc/config/rs6000/rs6000.md"
( reload_completed  && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_488 (insn, operands);

        case E_KFmode:
          if (GET_MODE (x2) != E_KFmode)
            return NULL;
          if (gpc_reg_operand (operands[0], E_KFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && (
#line 9461 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)) && 
#line 9464 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_339 (insn, operands);
          if (!vsx_register_operand (operands[0], E_KFmode)
              || !vsx_register_operand (operands[1], E_TFmode)
              || !(
#line 15227 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD) && 
#line 15231 "../../gcc/config/rs6000/rs6000.md"
( reload_completed  && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_489 (insn, operands);

        default:
          return NULL;
        }

    case SMIN:
      switch (pattern20 (x1))
        {
        case 0:
          if (!(
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_157 (insn, operands);

        case 1:
          if (!(
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      switch (pattern20 (x1))
        {
        case 0:
          if (!(
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_158 (insn, operands);

        case 1:
          if (!(
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_160 (insn, operands);

        default:
          return NULL;
        }

    case AND:
    case IOR:
    case XOR:
      return split_16 (x1, insn);

    case NOT:
      return split_17 (x1, insn);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
    case VEC_DUPLICATE:
      return split_15 (x1, insn);

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_DFmode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_IFmode:
          if (!gpc_reg_operand (operands[1], E_IFmode)
              || !((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8983 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_326 (insn, operands);

        case E_TFmode:
          if (!gpc_reg_operand (operands[1], E_TFmode)
              || !((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8983 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_327 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case PLUS:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              x6 = XEXP (x2, 1);
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern344 (x2, 
E_SImode) == 0)
                    return gen_split_33 (insn, operands);
                  break;

                case E_DImode:
                  if (pattern344 (x2, 
E_DImode) == 0
                      && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return gen_split_34 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              x6 = XEXP (x2, 1);
              if (GET_CODE (x6) == ASHIFT)
                {
                  switch (pattern209 (x2))
                    {
                    case 0:
                      if ((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_105 (insn, operands);
                      break;

                    case 1:
                      if (((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_107 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case ASHIFT:
              switch (pattern197 (x2))
                {
                case 0:
                  if (
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                    return gen_split_109 (insn, operands);
                  break;

                case 1:
                  if ((
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return gen_split_112 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case UNSPEC:
          res = split_14 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x2;
      switch (pattern65 ())
        {
        case 0:
          if (((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 11340 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL && reload_completed)))
            return gen_split_395 (insn, operands);
          break;

        case 1:
          if (((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 11340 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL && reload_completed)))
            return gen_split_396 (insn, operands);
          break;

        default:
          break;
        }
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_CODE (x2) != UNSPEC
          || XVECLEN (x2, 0) != 2
          || XINT (x2, 1) != 70
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_TDmode))
        return NULL;
      x8 = XVECEXP (x2, 0, 1);
      operands[2] = x8;
      if (!const_0_to_1_operand (operands[2], E_QImode))
        return NULL;
      if (((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14883 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_480 (insn, operands);
      if (!((
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14906 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_483 (insn, operands);

    case ORDERED:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_452 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_456 (insn, operands);

        case 2:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_543 (insn, operands);

        case 3:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_547 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_453 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_457 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_528 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_535 (insn, operands);

        default:
          return NULL;
        }

    case UNLE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_454 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_458 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_532 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_539 (insn, operands);

        default:
          return NULL;
        }

    case UNGE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_455 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_459 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_530 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_537 (insn, operands);

        default:
          return NULL;
        }

    case LTGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_460 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_466 (insn, operands);

        case 2:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_540 (insn, operands);

        case 3:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_544 (insn, operands);

        default:
          return NULL;
        }

    case LE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_461 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_467 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_527 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_534 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!cc_reg_operand (operands[1], E_CCFPmode))
        return NULL;
      switch (pattern9 (x2))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_462 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_468 (insn, operands);

        default:
          return NULL;
        }

    case UNLT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_463 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_469 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_531 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_538 (insn, operands);

        default:
          return NULL;
        }

    case UNGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_464 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_470 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_529 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_536 (insn, operands);

        default:
          return NULL;
        }

    case UNEQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_465 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_471 (insn, operands);

        case 2:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_541 (insn, operands);

        case 3:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_545 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (!extra_insn_branch_comparison_operator (x4, E_VOIDmode)
          || pattern28 (x1) != 0
          || !(
#line 13342 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13344 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_472 (insn, operands);

    case COMPARE:
      if (GET_MODE (x2) != E_CCEQmode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (!branch_comparison_operator (x4, E_VOIDmode))
        return NULL;
      operands[1] = x4;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 1);
      if (!branch_comparison_operator (x6, E_VOIDmode))
        return NULL;
      operands[3] = x6;
      x10 = XEXP (x6, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!cc_reg_operand (operands[0], E_CCEQmode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return NULL;
      x11 = XEXP (x6, 0);
      operands[4] = x11;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return NULL;
      return gen_split_473 (insn, operands);

    case LT:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_526 (insn, operands);

        case 1:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_533 (insn, operands);

        default:
          return NULL;
        }

    case UNORDERED:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_542 (insn, operands);

        case 1:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_546 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ROTATE)
        return NULL;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern205 (x2))
        {
        case 0:
          if (!(
#line 1021 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX) && 
#line 1025 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_567 (insn, operands);

        case 1:
          if (!(
#line 1021 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX) && 
#line 1025 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_568 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 4
          || pattern29 (x1) != 0
          || !(
#line 433 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)) && 
#line 436 "../../gcc/config/rs6000/mma.md"
( reload_completed)))
        return NULL;
      return gen_split_723 (insn, operands);

    default:
      return NULL;
    }
}
