/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern12 (x3); /* [-1, 3] */
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern19 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern19 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern26 (x5); /* [-1, 1] */
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern51 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern51 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern52 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern52 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern52 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern52 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern52 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern52 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern52 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern52 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern52 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern52 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x3 = XEXP (x1, 0);
  return pattern32 (x3); /* [-1, 1] */
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_V4SImode))
    return -1;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[0], E_IFmode)
          || GET_MODE (x3) != E_IFmode)
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      return 2;

    case E_TFmode:
      if (!gpc_reg_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_CCUNSmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern110 (x4, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern110 (x4, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 96
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!immediate_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern141 (x3, 
E_V4SFmode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode)
          || !altivec_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode)
          || !altivec_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode)
          || !altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!altivec_register_operand (operands[1], E_V2DImode)
          || !altivec_register_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern167 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return pattern170 (x1); /* [-1, 1] */
}

int
pattern176 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 106
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_m1_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 0;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 1;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!scratch_operand (operands[0], E_SImode))
                    return -1;
                  return 2;

                case E_DImode:
                  if (!scratch_operand (operands[0], E_DImode))
                    return -1;
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_0_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 4;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 5;

            case E_HImode:
              res = pattern177 (
E_HImode);
              if (res >= 0)
                return res + 6; /* [6, 7] */
              return -1;

            case E_QImode:
              res = pattern177 (
E_QImode);
              if (res >= 0)
                return res + 8; /* [8, 9] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x7, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_CCmode:
              if (!cc_reg_operand (operands[2], E_CCmode)
                  || GET_MODE (x3) != E_CCmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_m1_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 10;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_m1_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            case E_CCUNSmode:
              if (!cc_reg_operand (operands[2], E_CCUNSmode)
                  || GET_MODE (x3) != E_CCUNSmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_0_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 12;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_0_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 13;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 14;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              res = pattern178 (x9);
              if (res >= 0)
                return res + 15; /* [15, 16] */
              return -1;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 17;

            case E_HImode:
              res = pattern179 (x9, 
E_HImode);
              if (res >= 0)
                return res + 18; /* [18, 19] */
              return -1;

            case E_QImode:
              res = pattern179 (x9, 
E_QImode);
              if (res >= 0)
                return res + 20; /* [20, 21] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern276 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern276 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern277 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern277 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern277 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern277 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern277 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern277 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern277 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern277 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern277 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern277 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern313 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], E_V8HImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8HImode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[3] = x9;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode
      || !vsx_register_operand (operands[0], E_V2DImode)
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[2], E_V2DImode))
    return -1;
  return 0;
}

int
pattern352 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1)
      || !vsx_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern358 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern364 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern372 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              return pattern366 (
E_SImode); /* [-1, 0] */

            case E_DImode:
              if (pattern366 (
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case SET:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[3]))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern367 (
E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern367 (
E_DImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x10 = XEXP (x5, 0);
          operands[2] = x10;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern368 (x5, 
E_SImode) != 0)
                    return -1;
                  return 4;

                case E_DImode:
                  if (pattern368 (x5, 
E_DImode) != 0)
                    return -1;
                  return 5;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern369 (x5, 
E_SImode) != 0)
                    return -1;
                  return 6;

                case E_DImode:
                  if (pattern369 (x5, 
E_DImode) != 0)
                    return -1;
                  return 7;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x6, 0);
          operands[2] = x11;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern370 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 8;

                case E_DImode:
                  if (pattern370 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 9;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern371 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 10;

                case E_DImode:
                  if (pattern371 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern427 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || !memory_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern454 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern463 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern467 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern475 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case USE:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 3
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 2
          || GET_MODE (x5) != E_DImode)
        return -1;
      return 0;

    case SET:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 3
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 2
          || GET_MODE (x7) != E_DImode)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (pattern474 (x3, 
96) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern491 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

int
pattern503 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern507 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DImode
      || !gpc_reg_operand (operands[1], E_DImode)
      || !scc_eq_operand (operands[2], E_DImode)
      || !scratch_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !d_form_memory (operands[1], i1)
      || !vsx_register_operand (operands[2], E_DImode)
      || !base_reg_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern523 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[2] = x7;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern537 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern545 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern554 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case EQ:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      return 0;

    case NE:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern310 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 362; /* *setnbcr_cc_si */

        case 1:
          if (!
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 364; /* *setnbcr_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern310 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 363; /* *setnbcr_cc_di */

        case 1:
          if (!(
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 365; /* *setnbcr_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!cc_reg_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x2, 1);
  switch (GET_CODE (x8))
    {
    case RETURN:
      if (!
#line 13383 "../../gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 891; /* *creturn */

    case SIMPLE_RETURN:
      return 892; /* *creturn */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      switch (pattern59 (x3))
        {
        case 0:
          if (!
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2380; /* *fuse_and_and */

        case 1:
          if (!(
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2381; /* *fuse_and_and */

        case 2:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2548; /* *fuse_vand_vand */

        case 3:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2549; /* *fuse_vand_vand */

        case 4:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2550; /* *fuse_vand_vand */

        case 5:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2551; /* *fuse_vand_vand */

        case 6:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2552; /* *fuse_vand_vand */

        case 7:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2553; /* *fuse_vand_vand */

        case 8:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2554; /* *fuse_vand_vand */

        case 9:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2555; /* *fuse_vand_vand */

        case 10:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2556; /* *fuse_vand_vand */

        case 11:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2557; /* *fuse_vand_vand */

        case 12:
          if (!
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2400; /* *fuse_and_andc */

        case 13:
          if (!(
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2401; /* *fuse_and_andc */

        case 14:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2628; /* *fuse_vand_vandc */

        case 15:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2629; /* *fuse_vand_vandc */

        case 16:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2630; /* *fuse_vand_vandc */

        case 17:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2631; /* *fuse_vand_vandc */

        case 18:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2632; /* *fuse_vand_vandc */

        case 19:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2633; /* *fuse_vand_vandc */

        case 20:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2634; /* *fuse_vand_vandc */

        case 21:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2635; /* *fuse_vand_vandc */

        case 22:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2636; /* *fuse_vand_vandc */

        case 23:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2637; /* *fuse_vand_vandc */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern54 (x3))
            {
            case 0:
              if (!
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2382; /* *fuse_andc_and */

            case 1:
              if (!(
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2383; /* *fuse_andc_and */

            case 2:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2558; /* *fuse_vandc_vand */

            case 3:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2559; /* *fuse_vandc_vand */

            case 4:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2560; /* *fuse_vandc_vand */

            case 5:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2561; /* *fuse_vandc_vand */

            case 6:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2562; /* *fuse_vandc_vand */

            case 7:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2563; /* *fuse_vandc_vand */

            case 8:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2564; /* *fuse_vandc_vand */

            case 9:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2565; /* *fuse_vandc_vand */

            case 10:
              if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2566; /* *fuse_vandc_vand */

            case 11:
              if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2567; /* *fuse_vandc_vand */

            case 12:
              if (!
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2402; /* *fuse_andc_andc */

            case 13:
              if (!(
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2403; /* *fuse_andc_andc */

            case 14:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2638; /* *fuse_vandc_vandc */

            case 15:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2639; /* *fuse_vandc_vandc */

            case 16:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2640; /* *fuse_vandc_vandc */

            case 17:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2641; /* *fuse_vandc_vandc */

            case 18:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2642; /* *fuse_vandc_vandc */

            case 19:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2643; /* *fuse_vandc_vandc */

            case 20:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2644; /* *fuse_vandc_vandc */

            case 21:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2645; /* *fuse_vandc_vandc */

            case 22:
              if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2646; /* *fuse_vandc_vandc */

            case 23:
              if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2647; /* *fuse_vandc_vandc */

            default:
              return -1;
            }

        case NOT:
          switch (pattern48 (x3))
            {
            case 0:
              if (!
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2388; /* *fuse_nor_and */

            case 1:
              if (!(
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2389; /* *fuse_nor_and */

            case 2:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2588; /* *fuse_vnor_vand */

            case 3:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2589; /* *fuse_vnor_vand */

            case 4:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2590; /* *fuse_vnor_vand */

            case 5:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2591; /* *fuse_vnor_vand */

            case 6:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2592; /* *fuse_vnor_vand */

            case 7:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2593; /* *fuse_vnor_vand */

            case 8:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2594; /* *fuse_vnor_vand */

            case 9:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2595; /* *fuse_vnor_vand */

            case 10:
              if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2596; /* *fuse_vnor_vand */

            case 11:
              if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2597; /* *fuse_vnor_vand */

            case 12:
              if (!
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2408; /* *fuse_nor_andc */

            case 13:
              if (!(
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2409; /* *fuse_nor_andc */

            case 14:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2668; /* *fuse_vnor_vandc */

            case 15:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2669; /* *fuse_vnor_vandc */

            case 16:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2670; /* *fuse_vnor_vandc */

            case 17:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2671; /* *fuse_vnor_vandc */

            case 18:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2672; /* *fuse_vnor_vandc */

            case 19:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2673; /* *fuse_vnor_vandc */

            case 20:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2674; /* *fuse_vnor_vandc */

            case 21:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2675; /* *fuse_vnor_vandc */

            case 22:
              if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2676; /* *fuse_vnor_vandc */

            case 23:
              if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2677; /* *fuse_vnor_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 824; /* lesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 844; /* lesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 834; /* ledisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 854; /* ledidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V4SFmode) != 0
          || !
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
        return -1;
      return 1131; /* vector_lev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V2DFmode) != 0
          || !
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
        return -1;
      return 1138; /* vector_lev2df */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 826; /* gesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 846; /* gesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 836; /* gedisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 856; /* gedidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2175 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1279; /* *vsx_gev4sf */
      if (!altivec_register_operand (operands[0], E_V4SFmode)
          || !altivec_register_operand (operands[1], E_V4SFmode)
          || !altivec_register_operand (operands[2], E_V4SFmode)
          || !
#line 690 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1754; /* *altivec_gev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern2 (x2, 
E_V2DFmode) != 0
          || !
#line 2175 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1280; /* *vsx_gev2df */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != REG
          || REGNO (x3) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 113; /* subfsi3_carry_in_xx */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 114; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFTRT:
          if (pattern282 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1286 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 35; /* *macchw */

            case ASHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1353 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 39; /* *machhw */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern282 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1318 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 37; /* *macchwu */

            case LSHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1388 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 41; /* *machhwu */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern283 (x2, 
SIGN_EXTEND) != 0
              || !
#line 1417 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 43; /* *maclhw */

        case ZERO_EXTEND:
          if (pattern283 (x2, 
ZERO_EXTEND) != 0
              || !
#line 1446 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 45; /* *maclhwu */

        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern410 (x2, 
E_SImode) != 0
                  || !
#line 3265 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD))
                return -1;
              return 170; /* maddldsi4 */

            case E_DImode:
              if (pattern410 (x2, 
E_DImode) != 0
                  || !(
#line 3265 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 171; /* maddlddi4 */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !register_operand (operands[3], E_V8HImode)
                  || !
#line 1144 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 1844; /* fmav8hi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 98)
            {
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern465 (x2, 
E_SImode) == 0)
                    {
                      *pnum_clobbers = 1;
                      return 80; /* *addsi3_carry_in_internal */
                    }
                  break;

                case E_DImode:
                  if (pattern465 (x2, 
E_DImode) == 0
                      && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    {
                      *pnum_clobbers = 1;
                      return 81; /* *adddi3_carry_in_internal */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x6;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x1, 0);
              operands[3] = x5;
              if (altivec_register_operand (operands[3], E_V2DImode)
                  && GET_MODE (x2) == E_V2DImode
                  && GET_MODE (x3) == E_V2DImode)
                {
                  x7 = XEXP (x3, 1);
                  operands[1] = x7;
                  if (altivec_register_operand (operands[1], E_V2DImode))
                    {
                      operands[2] = x4;
                      if (altivec_register_operand (operands[2], E_V2DImode)
                          && 
#line 3049 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        {
                          *pnum_clobbers = 1;
                          return 3190; /* *fuse_vaddudm_vaddudm */
                        }
                    }
                }
            }
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[2] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern481 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 82; /* *addsi3_carry_in_internal2 */

                case E_DImode:
                  if (pattern481 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 83; /* *adddi3_carry_in_internal2 */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x4, 0) != -1L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern482 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 86; /* addsi3_carry_in_m1 */

                case E_DImode:
                  if (pattern482 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 87; /* adddi3_carry_in_m1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern466 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 107; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern466 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              *pnum_clobbers = 1;
              return 108; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern411 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 109; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern411 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 110; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern436 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 111; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern436 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 112; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ASHIFT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern209 (x2))
        {
        case 0:
          if (!
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
            return -1;
          return 251; /* *rotlsi3_insert_3_plus */

        case 1:
          if (!(
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 253; /* *rotldi3_insert_3_plus */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 1)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x13 = XVECEXP (x10, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (pattern4 (x2) != 0
          || !
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1526; /* vsx_reduc_plus_v2df */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 102
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!vfloat_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!vfloat_operand (operands[1], E_V4SFmode)
          || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1529; /* vsx_reduc_plus_v4sf */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode
      || !altivec_register_operand (operands[0], E_V2DImode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 5200 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1550; /* xsxexpqp_kf_v2di */

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 5200 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1552; /* xsxexpqp_tf_v2di */

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1456; /* vreplace_un_si */

    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1457; /* vreplace_un_sf */

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1458; /* vreplace_un_di */

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1459; /* vreplace_un_df */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 32:
      return recog_84 (x1, insn, pnum_clobbers);

    case 50:
      return recog_60 (x1, insn, pnum_clobbers);

    case 33:
      return recog_75 (x1, insn, pnum_clobbers);

    case 46:
      return recog_76 (x1, insn, pnum_clobbers);

    case 85:
      return recog_73 (x1, insn, pnum_clobbers);

    case 54:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX))
        return -1;
      return 390; /* lfiwax */

    case 55:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5963 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX))
        return -1;
      return 399; /* lfiwzx */

    case 5:
      switch (pattern211 (x3, 
FIX))
        {
        case 0:
          if (!
#line 6669 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 453; /* fctiwz_sf */

        case 1:
          if (!
#line 6669 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 454; /* fctiwz_df */

        default:
          return -1;
        }

    case 56:
      switch (pattern211 (x3, 
UNSIGNED_FIX))
        {
        case 0:
          if (!
#line 6680 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 455; /* fctiwuz_sf */

        case 1:
          if (!
#line 6680 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 456; /* fctiwuz_df */

        default:
          return -1;
        }

    case 53:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 6776 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
            return -1;
          return 462; /* lrintsfdi2 */

        case E_DFmode:
          if (!gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 6776 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
            return -1;
          return 463; /* lrintdfdi2 */

        default:
          return -1;
        }

    case 52:
      return recog_92 (x1, insn, pnum_clobbers);

    case 9:
      return recog_61 (x1, insn, pnum_clobbers);

    case 8:
      return recog_70 (x1, insn, pnum_clobbers);

    case 6:
      return recog_71 (x1, insn, pnum_clobbers);

    case 7:
      return recog_67 (x1, insn, pnum_clobbers);

    case 10:
      return recog_83 (x1, insn, pnum_clobbers);

    case 31:
      if (GET_MODE (x3) != E_SImode
          || !memory_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !
#line 6880 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PPC_GFXOPT))
        return -1;
      return 478; /* stfiwx */

    case 87:
      return recog_74 (x1, insn, pnum_clobbers);

    case 86:
      return recog_68 (x1, insn, pnum_clobbers);

    case 97:
      switch (pattern213 (x3))
        {
        case 0:
          if (!
#line 8733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 586; /* xxspltidp_sf_internal */

        case 1:
          if (!
#line 8733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 587; /* xxspltidp_df_internal */

        default:
          return -1;
        }

    case 98:
      switch (pattern213 (x3))
        {
        case 0:
          if (!
#line 8742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 588; /* xxspltiw_sf_internal */

        case 1:
          if (!
#line 8742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 589; /* xxspltiw_df_internal */

        default:
          return -1;
        }

    case 60:
      return recog_87 (x1, insn, pnum_clobbers);

    case 62:
      return recog_72 (x1, insn, pnum_clobbers);

    case 64:
      return recog_62 (x1, insn, pnum_clobbers);

    case 15:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          if (XWINT (x4, 0) != 0L)
            return -1;
          return 737; /* *tls_ld_pcrel64 */

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          return 738; /* *tls_ld64 */

        default:
          return -1;
        }

    case 73:
      return recog_82 (x1, insn, pnum_clobbers);

    case 83:
      return recog_81 (x1, insn, pnum_clobbers);

    case 84:
      return recog_91 (x1, insn, pnum_clobbers);

    case 36:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1108; /* *hwsync */

    case 37:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1109; /* *lwsync */

    case 72:
      return recog_86 (x1, insn, pnum_clobbers);

    case 122:
      return recog_80 (x1, insn, pnum_clobbers);

    case 19:
      if (GET_MODE (x3) != E_CCmode
          || !cc_reg_operand (operands[0], E_CCmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2214 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1285; /* *xvtlsbb_internal */

    case 124:
      switch (pattern214 (x3))
        {
        case 0:
          if (!
#line 2308 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1298; /* vsx_xsrdpi */

        case 1:
          if (!
#line 2308 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1299; /* vsx_xvrspi */

        case 2:
          if (!
#line 2308 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1300; /* vsx_xvrdpi */

        default:
          return -1;
        }

    case 125:
      switch (pattern214 (x3))
        {
        case 0:
          if (!
#line 2316 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1301; /* vsx_xsrdpic */

        case 1:
          if (!
#line 2316 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1302; /* vsx_xvrspic */

        case 2:
          if (!
#line 2316 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1303; /* vsx_xvrdpic */

        default:
          return -1;
        }

    case 107:
      return recog_65 (x1, insn, pnum_clobbers);

    case 108:
      if (GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2427 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1319; /* vsx_xvcvhpsp */

    case 143:
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2436 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1320; /* vsx_xvcvsphp */

    case 110:
      return recog_90 (x1, insn, pnum_clobbers);

    case 109:
      return recog_79 (x1, insn, pnum_clobbers);

    case 105:
      if (GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2596 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1334; /* vsx_xvcvdpsxws */

    case 106:
      if (GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2604 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1335; /* vsx_xvcvdpuxws */

    case 113:
      if (GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2612 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1336; /* vsx_xvcvsxdsp */

    case 114:
      if (GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2620 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1337; /* vsx_xvcvuxdsp */

    case 111:
      if (GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2661 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1342; /* vsx_xvcvsxwdp_df */

    case 112:
      if (GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2669 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1343; /* vsx_xvcvuxwdp_df */

    case 139:
      return recog_66 (x1, insn, pnum_clobbers);

    case 190:
      if (GET_MODE (x3) != E_TImode
          || !gpc_reg_operand (operands[0], E_TImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_TImode)
          || !
#line 5187 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1549; /* extendditi2_vector */

    case 146:
      return recog_89 (x1, insn, pnum_clobbers);

    case 147:
      return recog_88 (x1, insn, pnum_clobbers);

    case 155:
      switch (pattern215 (x3))
        {
        case 0:
          if (!
#line 5463 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1578; /* xvxexpsp */

        case 1:
          if (!
#line 5463 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1579; /* xvxexpdp */

        default:
          return -1;
        }

    case 156:
      switch (pattern215 (x3))
        {
        case 0:
          if (!
#line 5473 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1580; /* xvxsigsp */

        case 1:
          if (!
#line 5473 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1581; /* xvxsigdp */

        default:
          return -1;
        }

    case 141:
      if (GET_MODE (x3) != E_V16QImode
          || !vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1627; /* vsx_xvcvspbf16 */

    case 140:
      if (GET_MODE (x3) != E_V16QImode
          || !vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1628; /* vsx_xvcvbf16spn */

    case 189:
      return recog_63 (x1, insn, pnum_clobbers);

    case 192:
      return recog_64 (x1, insn, pnum_clobbers);

    case 204:
      return recog_77 (x1, insn, pnum_clobbers);

    case 205:
      if (GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6628 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1668; /* xxspltidp_v2df_inst */

    case 356:
      switch (pattern216 (x3))
        {
        case 0:
          if (!
#line 907 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1807; /* vstrir_direct_v8hi */

        case 1:
          if (!
#line 907 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1808; /* vstrir_direct_v16qi */

        default:
          return -1;
        }

    case 357:
      switch (pattern216 (x3))
        {
        case 0:
          if (!
#line 959 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1811; /* vstril_direct_v8hi */

        case 1:
          if (!
#line 959 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1812; /* vstril_direct_v16qi */

        default:
          return -1;
        }

    case 360:
      return recog_85 (x1, insn, pnum_clobbers);

    case 256:
      if (GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2581 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1993; /* altivec_vrfin */

    case 261:
      if (GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2635 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1999; /* altivec_vlogefp */

    case 262:
      if (GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2643 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2000; /* altivec_vexptefp */

    case 264:
      switch (pattern217 (x3))
        {
        case 0:
          if (!
#line 2693 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2013; /* altivec_vupkhsw */

        case 1:
          if (!
#line 2693 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2014; /* altivec_vupkhsh */

        case 2:
          if (!
#line 2693 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2015; /* altivec_vupkhsb */

        default:
          return -1;
        }

    case 266:
      switch (pattern217 (x3))
        {
        case 0:
          if (!
#line 2706 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2016; /* altivec_vupkhsw_direct */

        case 1:
          if (!
#line 2706 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2017; /* altivec_vupkhsh_direct */

        case 2:
          if (!
#line 2706 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2018; /* altivec_vupkhsb_direct */

        default:
          return -1;
        }

    case 265:
      switch (pattern217 (x3))
        {
        case 0:
          if (!
#line 2714 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2019; /* altivec_vupklsw */

        case 1:
          if (!
#line 2714 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2020; /* altivec_vupklsh */

        case 2:
          if (!
#line 2714 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2021; /* altivec_vupklsb */

        default:
          return -1;
        }

    case 267:
      switch (pattern217 (x3))
        {
        case 0:
          if (!
#line 2727 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2022; /* *altivec_vupklsw_direct */

        case 1:
          if (!
#line 2727 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2023; /* *altivec_vupklsh_direct */

        case 2:
          if (!
#line 2727 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2024; /* *altivec_vupklsb_direct */

        default:
          return -1;
        }

    case 268:
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2735 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2025; /* altivec_vupkhpx */

    case 269:
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2748 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2026; /* altivec_vupklpx */

    case 162:
      switch (pattern218 (x3))
        {
        case 0:
          if (!
#line 3020 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2054; /* altivec_lvsl_reg_si */

        case 1:
          if (!(
#line 3020 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2055; /* altivec_lvsl_reg_di */

        default:
          return -1;
        }

    case 276:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3028 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2056; /* altivec_lvsl_direct */

    case 163:
      switch (pattern218 (x3))
        {
        case 0:
          if (!
#line 3058 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2057; /* altivec_lvsr_reg_si */

        case 1:
          if (!(
#line 3058 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2058; /* altivec_lvsr_reg_di */

        default:
          return -1;
        }

    case 277:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3066 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2059; /* altivec_lvsr_direct */

    case 281:
      return recog_69 (x1, insn, pnum_clobbers);

    case 301:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4247 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2144; /* altivec_lvlx */

    case 302:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4255 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2145; /* altivec_lvlxl */

    case 303:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4263 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2146; /* altivec_lvrx */

    case 304:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4271 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2147; /* altivec_lvrxl */

    case 329:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode)
          || !
#line 4419 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2172; /* p8v_vgbbd */

    case 420:
      if (GET_MODE (x3) != E_XOmode
          || !fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 467 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2211; /* mma_xxmfacc */

    case 421:
      if (GET_MODE (x3) != E_XOmode
          || !fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 467 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2212; /* mma_xxmtacc */

    case 423:
      if (GET_MODE (x3) != E_DDmode
          || !nonimmediate_operand (operands[0], E_DDmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_SDmode)
          || !
#line 41 "../../gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], DDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2272; /* movsd_store */

    case 422:
      if (GET_MODE (x3) != E_SDmode
          || !nonimmediate_operand (operands[0], E_SDmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DDmode)
          || !
#line 51 "../../gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], DDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2273; /* movsd_load */

    case 436:
      return recog_78 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
                    {
                      *pnum_clobbers = 1;
                      return 400; /* floatunssisf2_lfiwzx */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 7118 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
                    return 494; /* floatunsdisf2_fcfidus */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 7129 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
                    {
                      *pnum_clobbers = 1;
                      return 495; /* *floatunsdisf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern315 (
E_SFmode))
            {
            case 0:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 410; /* *floatunsqisf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 411; /* *floatunshisf2_internal */

            default:
              return -1;
            }

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
                    {
                      *pnum_clobbers = 1;
                      return 401; /* floatunssidf2_lfiwzx */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 6994 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDU))
                    return 489; /* *floatunsdidf2_fcfidu */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 7004 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))))
                    {
                      *pnum_clobbers = 1;
                      return 490; /* *floatunsdidf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern315 (
E_DFmode))
            {
            case 0:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 412; /* *floatunsqidf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 413; /* *floatunshidf2_internal */

            default:
              return -1;
            }

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_KFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6942 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 482; /* floatunstikf2 */
          if (!altivec_register_operand (operands[0], E_KFmode))
            return -1;
          switch (pattern316 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15384 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1061; /* floatuns_kfdi2_hw */

            case 1:
              if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1063; /* floatuns_kfsi2_hw */

            case 2:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1065; /* floatunsqikf2 */

            case 3:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1066; /* floatunshikf2 */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_TFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6942 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 483; /* floatunstitf2 */
          if (!altivec_register_operand (operands[0], E_TFmode))
            return -1;
          switch (pattern316 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15384 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1062; /* floatuns_tfdi2_hw */

            case 1:
              if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1064; /* floatuns_tfsi2_hw */

            case 2:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1067; /* floatunsqitf2 */

            case 3:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1068; /* floatunshitf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SFmode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && 
#line 2285 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1292; /* vsx_floatunsv4siv4sf2 */
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || !vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 2489 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1327; /* vsx_xvcvuxwsp */

        case E_V2DFmode:
          if (GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DFmode)
              && gpc_reg_operand (operands[1], E_V2DImode)
              && 
#line 2285 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1293; /* vsx_floatunsv2div2df2 */
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 2496 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1329; /* vsx_xvcvuxddp */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern62 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
            return -1;
          *pnum_clobbers = 1;
          return 402; /* floatunssisf2_lfiwzx_mem */

        case 1:
          if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
            return -1;
          *pnum_clobbers = 1;
          return 403; /* floatunssidf2_lfiwzx_mem */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 460; /* *roundu32sf2_fprs */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 461; /* *roundu32df2_fprs */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern64 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 2631 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1339; /* vsx_xvcvuxwdp_be */

        case 1:
          if (!
#line 2640 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1341; /* vsx_xvcvuxwdp_le */

        case 2:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 1;
              return 1461; /* *vsx_extract_si_unsfloat_df */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1491; /* *vsx_ext_SI_ufl_df */

        case 3:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1483; /* *vsx_ext_QI_ufl_df */

        case 4:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1487; /* *vsx_ext_HI_ufl_df */

        case 5:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 2;
              return 1463; /* *vsx_extract_si_unsfloat_sf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1490; /* *vsx_ext_SI_ufl_sf */

        case 6:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1482; /* *vsx_ext_QI_ufl_sf */

        case 7:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1486; /* *vsx_ext_HI_ufl_sf */

        case 8:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          *pnum_clobbers = 2;
          return 1465; /* *vsx_extract_si_unsfloat_if */

        case 9:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            {
              *pnum_clobbers = 2;
              return 1467; /* *vsx_extract_si_unsfloat_kf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1492; /* *vsx_ext_SI_ufl_kf */

        case 10:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1484; /* *vsx_ext_QI_ufl_kf */

        case 11:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1488; /* *vsx_ext_HI_ufl_kf */

        case 12:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            {
              *pnum_clobbers = 2;
              return 1469; /* *vsx_extract_si_unsfloat_tf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1493; /* *vsx_ext_SI_ufl_tf */

        case 13:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1485; /* *vsx_ext_QI_ufl_tf */

        case 14:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1489; /* *vsx_ext_HI_ufl_tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_138 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_SFmode)
          && gpc_reg_operand (operands[1], E_DFmode)
          && 
#line 5278 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return 319; /* *truncdfsf2_fpr */
      if (pnum_clobbers == NULL
          || !vsx_register_operand (operands[0], E_SFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1023; /* trunckfsf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1024; /* trunctfsf2_hw */

        default:
          return -1;
        }

    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DFmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_IFmode:
              if (gpc_reg_operand (operands[1], E_IFmode))
                {
                  if ((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 604; /* truncifdf2_internal1 */
                  if ((
#line 8994 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 606; /* truncifdf2_internal2 */
                }
              break;

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode))
                {
                  if ((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 605; /* trunctfdf2_internal1 */
                  if ((
#line 8994 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 607; /* trunctfdf2_internal2 */
                }
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15244 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1021; /* trunckfdf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15244 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1022; /* trunctfdf2_hw */

        default:
          return -1;
        }

    case E_SDmode:
      if (!gpc_reg_operand (operands[0], E_SDmode)
          || GET_MODE (x3) != E_SDmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DDmode:
          if (!gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 80 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2275; /* truncddsd2 */

        case E_TDmode:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 165 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2284; /* trunctdsd2 */

        default:
          return -1;
        }

    case E_DDmode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 154 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      *pnum_clobbers = 1;
      return 2283; /* trunctddd2 */

    default:
      return -1;
    }
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  operands[4] = x8;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x6, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (pattern544 (x7, 
E_SImode) != 0
          || !
#line 3756 "../../gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (SImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)))
        return -1;
      return 198; /* *andsi3_imm_dot_shifted */

    case E_DImode:
      if (pattern544 (x7, 
E_DImode) != 0
          || !(
#line 3756 "../../gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (DImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 199; /* *anddi3_imm_dot_shifted */

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 87:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      if (!input_operand (operands[1], E_SFmode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_V4SFmode)
          || !
#line 7832 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))))
        return -1;
      return 558; /* movsi_from_sf */

    case 86:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_SFmode))
        {
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          if (input_operand (operands[1], E_SImode)
              && 
#line 8385 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))))
            return 575; /* movsf_from_si */
        }
      x6 = XVECEXP (x3, 0, 0);
      if (!lowpart_subreg_operator (x6, E_SImode))
        return -1;
      switch (pattern469 (x6))
        {
        case 0:
          if (!
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
            return -1;
          return 576; /* movsf_from_si2_ashiftrt */

        case 1:
          if (!
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
            return -1;
          return 577; /* movsf_from_si2_lshiftrt */

        default:
          return -1;
        }

    case 30:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_IFmode:
          if (!gpc_reg_operand (operands[1], E_IFmode)
              || !(
#line 9049 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
            return -1;
          return 608; /* fix_trunc_helperif */

        case E_TFmode:
          if (!gpc_reg_operand (operands[1], E_TFmode)
              || !(
#line 9049 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
            return -1;
          return 609; /* fix_trunc_helpertf */

        default:
          return -1;
        }

    case 61:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern445 (x3, 
E_DImode, 
E_IFmode) != 0
              || !
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
            return -1;
          return 637; /* reload_fpr_from_gprdi */

        case E_DFmode:
          if (pattern445 (x3, 
E_DFmode, 
E_IFmode) != 0
              || !
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
            return -1;
          return 638; /* reload_fpr_from_gprdf */

        case E_DDmode:
          if (pattern445 (x3, 
E_DDmode, 
E_IFmode) != 0
              || !
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
            return -1;
          return 639; /* reload_fpr_from_gprdd */

        case E_TImode:
          if (pattern445 (x3, 
E_TImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 651; /* reload_vsx_from_gprti */

        case E_V16QImode:
          if (pattern445 (x3, 
E_V16QImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 652; /* reload_vsx_from_gprv16qi */

        case E_V8HImode:
          if (pattern445 (x3, 
E_V8HImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 653; /* reload_vsx_from_gprv8hi */

        case E_V4SImode:
          if (pattern445 (x3, 
E_V4SImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 654; /* reload_vsx_from_gprv4si */

        case E_V4SFmode:
          if (pattern445 (x3, 
E_V4SFmode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 655; /* reload_vsx_from_gprv4sf */

        case E_V2DImode:
          if (pattern445 (x3, 
E_V2DImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 656; /* reload_vsx_from_gprv2di */

        case E_V2DFmode:
          if (pattern445 (x3, 
E_V2DFmode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 657; /* reload_vsx_from_gprv2df */

        case E_V1TImode:
          if (pattern445 (x3, 
E_V1TImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 658; /* reload_vsx_from_gprv1ti */

        case E_KFmode:
          if (pattern445 (x3, 
E_KFmode, 
E_IFmode) != 0
              || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 659; /* reload_vsx_from_gprkf */

        case E_TFmode:
          if (pattern445 (x3, 
E_TFmode, 
E_IFmode) != 0
              || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 660; /* reload_vsx_from_gprtf */

        case E_SFmode:
          if (pattern445 (x3, 
E_SFmode, 
E_DImode) != 0
              || !
#line 9688 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 662; /* reload_vsx_from_gprsf */

        default:
          return -1;
        }

    case 64:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern446 (x3, 
E_TImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 673; /* reload_gpr_from_vsxti */

        case E_V16QImode:
          if (pattern446 (x3, 
E_V16QImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 674; /* reload_gpr_from_vsxv16qi */

        case E_V8HImode:
          if (pattern446 (x3, 
E_V8HImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 675; /* reload_gpr_from_vsxv8hi */

        case E_V4SImode:
          if (pattern446 (x3, 
E_V4SImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 676; /* reload_gpr_from_vsxv4si */

        case E_V4SFmode:
          if (pattern446 (x3, 
E_V4SFmode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 677; /* reload_gpr_from_vsxv4sf */

        case E_V2DImode:
          if (pattern446 (x3, 
E_V2DImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 678; /* reload_gpr_from_vsxv2di */

        case E_V2DFmode:
          if (pattern446 (x3, 
E_V2DFmode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 679; /* reload_gpr_from_vsxv2df */

        case E_V1TImode:
          if (pattern446 (x3, 
E_V1TImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 680; /* reload_gpr_from_vsxv1ti */

        case E_KFmode:
          if (pattern446 (x3, 
E_KFmode) != 0
              || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 681; /* reload_gpr_from_vsxkf */

        case E_TFmode:
          if (pattern446 (x3, 
E_TFmode) != 0
              || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 682; /* reload_gpr_from_vsxtf */

        case E_SFmode:
          if (pattern445 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 9752 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 683; /* reload_gpr_from_vsxsf */

        default:
          return -1;
        }

    case 2:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern331 (x4, 
E_DImode, 
2, 
USE) != 0)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !
#line 11115 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && TARGET_64BIT))
        return -1;
      return 758; /* load_toc_aix_di */

    case 34:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      return 804; /* stack_protect_setdi */

    case 101:
      if (GET_MODE (x3) != E_CCmode
          || pattern176 (x1, 
SET, 
E_CCmode) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x6 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x6))
        {
        case EQ:
          switch (pattern490 (x1, 
EQ))
            {
            case 0:
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode)
                  && 
#line 2190 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1281; /* *vsx_eq_v4sf_p */
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode)
                  || !
#line 2893 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 2042; /* *altivec_vcmpeqfp_p */

            case 1:
              x8 = XEXP (x4, 1);
              if (pattern549 (x8) != 0
                  || !
#line 2190 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1282; /* *vsx_eq_v2df_p */

            case 2:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V4SImode) != 0
                  || !
#line 2809 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2027; /* altivec_vcmpequw_p */

            case 3:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V8HImode) != 0
                  || !
#line 2809 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2028; /* altivec_vcmpequh_p */

            case 4:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V16QImode) != 0
                  || !
#line 2809 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2029; /* altivec_vcmpequb_p */

            case 5:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V2DImode) != 0
                  || !
#line 2809 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2030; /* altivec_vcmpequd_p */

            case 6:
              if (!altivec_register_operand (operands[1], E_V1TImode)
                  || !altivec_register_operand (operands[2], E_V1TImode)
                  || !altivec_register_operand (operands[0], E_V1TImode))
                return -1;
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V1TImode
                  || !
#line 2821 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2031; /* altivec_vcmpequt_p */

            default:
              return -1;
            }

        case GT:
          switch (pattern490 (x1, 
GT))
            {
            case 0:
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode)
                  && 
#line 2203 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1283; /* *vsx_gt_v4sf_p */
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode)
                  || !
#line 2905 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 2043; /* *altivec_vcmpgtfp_p */

            case 1:
              x8 = XEXP (x4, 1);
              if (pattern549 (x8) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1284; /* *vsx_gt_v2df_p */

            case 2:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V4SImode) != 0
                  || !
#line 2845 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2032; /* *altivec_vcmpgtsw_p */

            case 3:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V8HImode) != 0
                  || !
#line 2845 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2033; /* *altivec_vcmpgtsh_p */

            case 4:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V16QImode) != 0
                  || !
#line 2845 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2034; /* *altivec_vcmpgtsb_p */

            case 5:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V2DImode) != 0
                  || !
#line 2845 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2035; /* *altivec_vcmpgtsd_p */

            case 6:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V1TImode) != 0
                  || !
#line 2857 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2036; /* *altivec_vcmpgtst_p */

            default:
              return -1;
            }

        case GE:
          if (pattern491 (x1, 
GE) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode)
                  && 
#line 2255 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1286; /* *vsx_ge_v4sf_p */
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode)
                  || !
#line 2917 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 2044; /* *altivec_vcmpgefp_p */

            case E_V2DFmode:
              x8 = XEXP (x4, 1);
              if (pattern549 (x8) != 0
                  || !
#line 2255 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1287; /* *vsx_ge_v2df_p */

            default:
              return -1;
            }

        case NE:
          if (pattern491 (x1, 
NE) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              x8 = XEXP (x4, 1);
              if (pattern551 (x8, 
E_V16QImode) != 0
                  || !
#line 5517 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1586; /* *vsx_ne_v16qi_p */

            case E_V8HImode:
              x8 = XEXP (x4, 1);
              if (pattern551 (x8, 
E_V8HImode) != 0
                  || !
#line 5517 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1587; /* *vsx_ne_v8hi_p */

            case E_V4SImode:
              x8 = XEXP (x4, 1);
              if (pattern551 (x8, 
E_V4SImode) != 0
                  || !
#line 5517 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1588; /* *vsx_ne_v4si_p */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 103)
            return -1;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 103)
            return -1;
          x9 = XVECEXP (x6, 0, 0);
          operands[1] = x9;
          x10 = XVECEXP (x6, 0, 1);
          operands[2] = x10;
          x11 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XVECEXP (x8, 0, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_V4SImode:
              if (pattern555 (x8, 
E_V4SImode) != 0
                  || !
#line 5532 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1589; /* *vector_nez_v4si_p */

            case E_V8HImode:
              if (pattern555 (x8, 
E_V8HImode) != 0
                  || !
#line 5532 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1590; /* *vector_nez_v8hi_p */

            case E_V16QImode:
              if (pattern555 (x8, 
E_V16QImode) != 0
                  || !
#line 5532 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1591; /* *vector_nez_v16qi_p */

            default:
              return -1;
            }

        case GTU:
          if (pattern491 (x1, 
GTU) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V4SImode) != 0
                  || !
#line 2869 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2037; /* *altivec_vcmpgtuw_p */

            case E_V8HImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V8HImode) != 0
                  || !
#line 2869 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2038; /* *altivec_vcmpgtuh_p */

            case E_V16QImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V16QImode) != 0
                  || !
#line 2869 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2039; /* *altivec_vcmpgtub_p */

            case E_V2DImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V2DImode) != 0
                  || !
#line 2869 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2040; /* *altivec_vcmpgtud_p */

            case E_V1TImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V1TImode) != 0
                  || !
#line 2881 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2041; /* *altivec_vcmpgtut_p */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 356:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 937 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1809; /* vstrir_p_direct_v8hi */

        case 1:
          if (!
#line 937 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1810; /* vstrir_p_direct_v16qi */

        default:
          return -1;
        }

    case 357:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 989 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1813; /* vstril_p_direct_v8hi */

        case 1:
          if (!
#line 989 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1814; /* vstril_p_direct_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 12:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!gpc_reg_operand (operands[0], E_DFmode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 6542 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
            return -1;
          return 452; /* rs6000_mffscdrn */

        case 2:
          if (GET_MODE (x3) != E_CCmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!cc_reg_operand (operands[0], E_CCmode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!memory_operand (operands[1], E_QImode)
                  || !int_reg_operand (operands[2], E_QImode)
                  || !
#line 273 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1125; /* store_conditionalqi */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode)
                  || !int_reg_operand (operands[2], E_HImode)
                  || !
#line 274 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1126; /* store_conditionalhi */

            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !int_reg_operand (operands[2], E_SImode))
                return -1;
              return 1127; /* store_conditionalsi */

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode)
                  || !int_reg_operand (operands[2], E_DImode)
                  || !
#line 276 "../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1128; /* store_conditionaldi */

            case E_PTImode:
              if (!indexed_or_indirect_operand (operands[1], E_PTImode)
                  || !quad_int_reg_operand (operands[2], E_PTImode)
                  || !
#line 398 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI && quad_int_reg_operand (operands[2], PTImode)))
                return -1;
              return 1129; /* store_conditionalpti */

            default:
              return -1;
            }

        case 28:
          if (pattern251 (x1) != 0
              || !base_reg_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XEXP (x5, 1);
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[2])
              || !
#line 73 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2342; /* *tabort */

        case 31:
          if (pattern252 (x1) != 0
              || !
#line 144 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2347; /* *tbegin */

        case 32:
          if (pattern253 (x1) != 0
              || !
#line 163 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2348; /* *tcheck */

        case 33:
          if (pattern252 (x1) != 0
              || !
#line 184 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2349; /* *tend */

        case 34:
          if (pattern253 (x1) != 0
              || !
#line 203 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2350; /* *trechkpt */

        case 35:
          if (pattern251 (x1) != 0
              || !gpc_reg_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XEXP (x5, 1);
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[2])
              || !
#line 224 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2351; /* *treclaim */

        case 36:
          if (pattern252 (x1) != 0
              || !
#line 245 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2352; /* *tsr */

        case 37:
          if (pattern253 (x1) != 0
              || !
#line 264 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2353; /* *ttest */

        default:
          return -1;
        }

    case 3:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern187 (x5, 
440, 
1) != 0)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_MODE (x8) != E_BLKmode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[0] = x4;
      if (!u5bit_cint_operand (operands[0], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x3, 0, 1);
      operands[1] = x10;
      x11 = XVECEXP (x3, 0, 2);
      operands[2] = x11;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      x9 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x9, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 29:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 98 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2343; /* *tabortwc */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[2], E_DImode)
                  || !(
#line 98 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2344; /* *tabortdc */

            default:
              return -1;
            }

        case 30:
          if (!s5bit_cint_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !
#line 123 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2345; /* *tabortwci */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !(
#line 123 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2346; /* *tabortdci */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      res = recog_160 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_161 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  switch (XINT (x4, 1))
    {
    case 278:
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !
#line 3096 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2060; /* altivec_lvewx */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !
#line 3096 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2061; /* altivec_lvehx */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !
#line 3096 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2062; /* altivec_lvebx */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || !memory_operand (operands[1], E_V4SFmode)
              || !
#line 3105 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2063; /* *altivec_lvesfx */

        default:
          return -1;
        }

    case 282:
      switch (pattern427 ())
        {
        case 0:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2064; /* altivec_lvxl_v4si */

        case 1:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2065; /* altivec_lvxl_v8hi */

        case 2:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2066; /* altivec_lvxl_v16qi */

        case 3:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2067; /* altivec_lvxl_v4sf */

        case 4:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2068; /* altivec_lvxl_v2df */

        case 5:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2069; /* altivec_lvxl_v2di */

        case 6:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2070; /* altivec_lvxl_v1ti */

        case 7:
          if (!(
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2071; /* altivec_lvxl_kf */

        case 8:
          if (!(
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2072; /* altivec_lvxl_tf */

        default:
          return -1;
        }

    case 284:
      switch (pattern427 ())
        {
        case 0:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2073; /* altivec_lvx_v4si_internal */

        case 1:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2074; /* altivec_lvx_v8hi_internal */

        case 2:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2075; /* altivec_lvx_v16qi_internal */

        case 3:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2076; /* altivec_lvx_v4sf_internal */

        case 4:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2077; /* altivec_lvx_v2df_internal */

        case 5:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2078; /* altivec_lvx_v2di_internal */

        case 6:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2079; /* altivec_lvx_v1ti_internal */

        case 7:
          if (!(
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2080; /* altivec_lvx_kf_internal */

        case 8:
          if (!(
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2081; /* altivec_lvx_tf_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case FLOAT:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern297 (x1))
            {
            case 0:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 406; /* *floatqisf2_internal */

            case 1:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 407; /* *floathisf2_internal */

            case 2:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 408; /* *floatqidf2_internal */

            case 3:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 409; /* *floathidf2_internal */

            default:
              return -1;
            }

        case CALL:
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!unspec_tls (operands[2], E_DImode))
            return -1;
          x11 = XEXP (x4, 0);
          operands[3] = x11;
          if (!immediate_operand (operands[3], E_SImode))
            return -1;
          switch (GET_CODE (operands[1]))
            {
            case SYMBOL_REF:
              if (!symbol_ref_operand (operands[1], E_DImode))
                return -1;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != USE)
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              if (pattern474 (x6, 
96) != 0)
                return -1;
              x12 = XEXP (x5, 0);
              operands[4] = x12;
              if (!register_operand (operands[4], E_SImode)
                  || !(
#line 11662 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 782; /* *call_value_nonlocal_sysv_securedi */

            case UNSPEC:
            case REG:
              if (!indirect_call_operand (operands[1], E_DImode))
                return -1;
              switch (pattern475 (x1, pnum_clobbers))
                {
                case 0:
                  x5 = XVECEXP (x1, 0, 2);
                  x12 = XEXP (x5, 0);
                  operands[4] = x12;
                  if (!memory_operand (operands[4], E_DImode))
                    return -1;
                  x6 = XVECEXP (x1, 0, 3);
                  x13 = XEXP (x6, 1);
                  x14 = XVECEXP (x13, 0, 0);
                  operands[5] = x14;
                  if (!const_int_operand (operands[5], E_DImode)
                      || !(
#line 11749 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 786; /* *call_value_indirect_aixdi */

                case 1:
                  x5 = XVECEXP (x1, 0, 2);
                  x15 = XEXP (x5, 1);
                  x16 = XVECEXP (x15, 0, 0);
                  operands[4] = x16;
                  if (!const_int_operand (operands[4], E_DImode)
                      || !(
#line 11806 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 790; /* *call_value_indirect_elfv2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          switch (pattern109 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 818; /* eqsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 838; /* eqsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 828; /* eqdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 848; /* eqdidi2_isel */

            default:
              return -1;
            }

        case NE:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          x11 = XEXP (x4, 0);
          operands[3] = x11;
          x12 = XEXP (x5, 0);
          operands[4] = x12;
          x17 = XEXP (x6, 0);
          operands[5] = x17;
          switch (pattern506 (x3))
            {
            case 0:
              if (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return 819; /* nesisi2_isel */
              break;

            case 1:
              if ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 839; /* nesidi2_isel */
              break;

            case 2:
              if (reg_or_short_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && scratch_operand (operands[5], E_CCmode)
                  && (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 829; /* nedisi2_isel */
              if (scc_eq_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_SImode)
                  && scratch_operand (operands[4], E_SImode)
                  && scratch_operand (operands[5], E_DImode)
                  && (
#line 13248 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 868; /* *nesi3_extdi */
              break;

            case 3:
              if ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 849; /* nedidi2_isel */
              break;

            default:
              break;
            }
          if (!scratch_operand (operands[4], E_DImode)
              || pattern507 (x1) != 0
              || !(
#line 12993 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 860; /* *nedi3 */

        case LT:
          switch (pattern109 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 820; /* ltsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 840; /* ltsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 830; /* ltdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 850; /* ltdidi2_isel */

            default:
              return -1;
            }

        case LTU:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 821; /* ltusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 841; /* ltusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 831; /* ltudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 851; /* ltudidi2_isel */

            default:
              return -1;
            }

        case GT:
          switch (pattern109 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 822; /* gtsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 842; /* gtsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 832; /* gtdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 852; /* gtdidi2_isel */

            default:
              return -1;
            }

        case GTU:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 823; /* gtusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 843; /* gtusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 833; /* gtudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 853; /* gtudidi2_isel */

            default:
              return -1;
            }

        case LE:
          switch (pattern109 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 824; /* lesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 844; /* lesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 834; /* ledisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 854; /* ledidi2_isel */

            default:
              return -1;
            }

        case LEU:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 825; /* leusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 845; /* leusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 835; /* leudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 855; /* leudidi2_isel */

            default:
              return -1;
            }

        case GE:
          switch (pattern109 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 826; /* gesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 846; /* gesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 836; /* gedisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 856; /* gedidi2_isel */

            default:
              return -1;
            }

        case GEU:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 827; /* geusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 847; /* geusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 837; /* geudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 857; /* geudidi2_isel */

            default:
              return -1;
            }

        case NEG:
          if (pattern113 (x1) != 0)
            return -1;
          switch (pattern339 (x1))
            {
            case 0:
              if (!(
#line 13026 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 861; /* *neg_eq_di */

            case 1:
              if (!(
#line 13058 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 862; /* *neg_ne_di */

            default:
              return -1;
            }

        case PLUS:
          if (pattern113 (x1) != 0)
            return -1;
          switch (pattern340 (x1))
            {
            case 0:
              return 863; /* *plus_eq_di */

            case 1:
              return 864; /* *plus_ne_di */

            default:
              return -1;
            }

        case MINUS:
          if (pattern113 (x1) != 0)
            return -1;
          switch (pattern341 (x1))
            {
            case 0:
              return 865; /* *minus_eq_di */

            case 1:
              return 866; /* *minus_ne_di */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          if (pattern114 (x1) != 0)
            return -1;
          x10 = XEXP (x3, 1);
          x18 = XEXP (x10, 0);
          operands[0] = x18;
          x4 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x4, 0);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          if (!scratch_operand (operands[3], E_CCmode))
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x6, 0);
          operands[4] = x17;
          if (!scratch_operand (operands[4], E_DImode))
            return -1;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case EQ:
              x19 = XEXP (x7, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x20 = XEXP (x4, 1);
              x21 = XEXP (x20, 0);
              if (!rtx_equal_p (x21, operands[1]))
                return -1;
              return 909; /* bdz_di */

            case NE:
              x19 = XEXP (x7, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x20 = XEXP (x4, 1);
              x21 = XEXP (x20, 0);
              if (!rtx_equal_p (x21, operands[1]))
                return -1;
              return 910; /* bdnz_di */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return -1;
          x22 = XVECEXP (x10, 0, 0);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern459 (x1))
            {
            case 0:
              if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1535; /* *vsx_reduc_plus_v4sf_scalar */

            case 1:
              if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1536; /* *vsx_reduc_smin_v4sf_scalar */

            case 2:
              if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1537; /* *vsx_reduc_smax_v4sf_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != MEM)
        return -1;
      switch (pattern115 (x1))
        {
        case 0:
          if (!symbol_ref_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (pattern474 (x6, 
96) != 0)
            return -1;
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          if (!register_operand (operands[3], E_SImode)
              || !(
#line 11588 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 779; /* *call_nonlocal_sysv_securedi */

        case 1:
          if (!indirect_call_operand (operands[0], E_DImode))
            return -1;
          switch (pattern475 (x1, pnum_clobbers))
            {
            case 0:
              x5 = XVECEXP (x1, 0, 2);
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              if (!memory_operand (operands[3], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              x13 = XEXP (x6, 1);
              x14 = XVECEXP (x13, 0, 0);
              operands[4] = x14;
              if (!const_int_operand (operands[4], E_DImode)
                  || !(
#line 11728 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 785; /* *call_indirect_aixdi */

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              x15 = XEXP (x5, 1);
              x16 = XVECEXP (x15, 0, 0);
              operands[3] = x16;
              if (!const_int_operand (operands[3], E_DImode)
                  || !(
#line 11770 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 787; /* *call_indirect_elfv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x4) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], TImode)))
            return gen_split_270 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7611 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_279 (insn, operands);

        case E_PTImode:
          if (GET_MODE (x3) != E_PTImode
              || GET_MODE (x4) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], PTImode)))
            return gen_split_271 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7611 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_280 (insn, operands);

        case E_V16QImode:
          if (pattern300 (x3, 
E_V16QImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_V8HImode:
          if (pattern300 (x3, 
E_V8HImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_273 (insn, operands);

        case E_V4SImode:
          if (pattern300 (x3, 
E_V4SImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_274 (insn, operands);

        case E_V4SFmode:
          if (pattern300 (x3, 
E_V4SFmode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_275 (insn, operands);

        case E_V2DImode:
          if (pattern300 (x3, 
E_V2DImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_276 (insn, operands);

        case E_V2DFmode:
          if (pattern300 (x3, 
E_V2DFmode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_277 (insn, operands);

        case E_V1TImode:
          if (pattern300 (x3, 
E_V1TImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_278 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!vlogical_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !vlogical_operand (operands[1], E_TImode)
              || !
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
            return NULL;
          return gen_split_281 (insn, operands);

        case E_PTImode:
          if (!vlogical_operand (operands[0], E_PTImode)
              || GET_MODE (x3) != E_PTImode
              || !vlogical_operand (operands[1], E_PTImode)
              || !
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
            return NULL;
          return gen_split_282 (insn, operands);

        case E_V16QImode:
          if (!vlogical_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !vlogical_operand (operands[1], E_V16QImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_283 (insn, operands);

        case E_V8HImode:
          if (!vlogical_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !vlogical_operand (operands[1], E_V8HImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_284 (insn, operands);

        case E_V4SImode:
          if (!vlogical_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !vlogical_operand (operands[1], E_V4SImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_285 (insn, operands);

        case E_V4SFmode:
          if (!vlogical_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !vlogical_operand (operands[1], E_V4SFmode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_286 (insn, operands);

        case E_V2DImode:
          if (!vlogical_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !vlogical_operand (operands[1], E_V2DImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_287 (insn, operands);

        case E_V2DFmode:
          if (!vlogical_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vlogical_operand (operands[1], E_V2DFmode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_288 (insn, operands);

        case E_V1TImode:
          if (!vlogical_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !vlogical_operand (operands[1], E_V1TImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_289 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || !logical_const_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (!boolean_or_operator (x3, E_SImode))
    return NULL;
  operands[3] = x3;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!logical_const_operand (operands[2], E_SImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != COMPARE
      || GET_MODE (x8) != E_CCmode)
    return NULL;
  x9 = XEXP (x7, 0);
  operands[4] = x9;
  if (!cc_reg_operand (operands[4], E_CCmode))
    return NULL;
  x10 = XEXP (x8, 0);
  operands[5] = x10;
  if (!gpc_reg_operand (operands[5], E_SImode))
    return NULL;
  x11 = XEXP (x8, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != IF_THEN_ELSE)
    return NULL;
  x14 = XEXP (x13, 0);
  if (!equality_operator (x14, E_VOIDmode))
    return NULL;
  operands[6] = x14;
  x15 = XEXP (x14, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x16 = XEXP (x12, 0);
  if (GET_CODE (x16) != PC)
    return NULL;
  x17 = XEXP (x13, 1);
  operands[7] = x17;
  x18 = XEXP (x13, 2);
  operands[8] = x18;
  x19 = XEXP (x14, 0);
  if (!rtx_equal_p (x19, operands[4])
      || !
#line 12677 "../../gcc/config/rs6000/rs6000.md"
(peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[4])
   && REGNO (operands[0]) != REGNO (operands[5])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_13 (insn, operands);
}
