/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      if (XWINT (x2, 0) != 0L
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      return pattern9 (x1); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern11 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern11 (x3); /* [-1, 1] */
}

int
pattern24 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x3, 0);
  return pattern32 (x6); /* [-1, 1] */
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern38 (x3); /* [-1, 1] */

    case NOT:
      res = pattern40 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern68 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[2], E_DImode))
    return -1;
  return pattern67 (); /* [-1, 2] */
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x5) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !scratch_operand (operands[2], E_DImode))
                return -1;
              return 0;

            case E_DImode:
              return 1;

            default:
              return -1;
            }

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x5) != E_DFmode
              || !scratch_operand (operands[2], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              return 2;

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_KFmode:
          res = pattern68 (x5, 
E_KFmode);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        case E_TFmode:
          res = pattern68 (x5, 
E_TFmode);
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          res = pattern70 (x5, 
E_SFmode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        case E_DFmode:
          res = pattern70 (x5, 
E_DFmode);
          if (res >= 0)
            return res + 14; /* [14, 15] */
          return -1;

        default:
          return -1;
        }

    case VEC_SELECT:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 16; /* [16, 27] */
      return -1;

    default:
      return -1;
    }
}

int
pattern106 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern37 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern37 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!vsx_register_operand (operands[0], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[2] = x6;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern163 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_1_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern141 (x3, 
E_V1TImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (operands[1]))
    {
    case SYMBOL_REF:
      return 0;

    case UNSPEC:
    case REG:
      return 1;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern196 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern196 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern208 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern207 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern207 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V16QImode
      || !altivec_register_operand (operands[0], E_V16QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern244 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      return pattern234 (x6); /* [-1, 23] */

    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          res = pattern239 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        case NOT:
          res = pattern243 (x6);
          if (res >= 0)
            return res + 48; /* [48, 71] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 3
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 96
      || GET_MODE (x8) != E_DImode)
    return -1;
  return 0;
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern266 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern281 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !scc_rev_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 98)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 98)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  return 0;
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern296 (x4, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern296 (x4, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern312 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern319 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern336 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_DImode))
    return -1;
  switch (GET_CODE (x8))
    {
    case EQ:
      x13 = XEXP (x8, 0);
      operands[1] = x13;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x14 = XEXP (x8, 1);
      operands[2] = x14;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case NE:
      x13 = XEXP (x8, 0);
      operands[1] = x13;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x14 = XEXP (x8, 1);
      operands[2] = x14;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern363 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern371 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern388 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern383 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern380 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern377 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern397 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern399 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern405 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern403 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern403 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern404 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern404 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern404 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern404 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern404 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern404 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern404 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern404 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern404 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern404 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern425 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern449 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern448 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern448 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern458 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 102
      || GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!vfloat_operand (operands[1], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern465 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern471 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern483 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x3) != SIGN_EXTEND)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], i1))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!gpc_reg_operand (operands[2], i1))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_CODE (x3) != ZERO_EXTEND)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], i1))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!gpc_reg_operand (operands[2], i1))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern498 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern496 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern496 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern497 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern497 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern497 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern497 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern497 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern497 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern497 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern497 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern497 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern497 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern520 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern533 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[5], i1)
      || !const_int_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern544 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern551 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern560 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  x12 = XEXP (x9, 1);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x4, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x5, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern309 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5618 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 358; /* *setnbc_cc_si */

        case 1:
          if (!
#line 5618 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 360; /* *setnbc_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern309 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5618 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 359; /* *setnbc_cc_di */

        case 1:
          if (!(
#line 5618 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 361; /* *setnbc_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      res = recog_10 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_CODE (x3))
    {
    case GE:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern406 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 366; /* *fselsfsf4 */

            case 1:
              if (!
#line 5652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 368; /* *fselsfdf4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern406 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 367; /* *fseldfsf4 */

            case 1:
              if (!
#line 5652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 369; /* *fseldfdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case UNLE:
    case UNLT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      x8 = XEXP (x2, 2);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern479 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 374; /* *movsfsfcc_invert_p9 */

            case 1:
              if (!
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 376; /* *movsfdfcc_invert_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern479 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 375; /* *movdfsfcc_invert_p9 */

            case 1:
              if (!
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 377; /* *movdfdfcc_invert_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern480 (x2, 
E_KFmode) != 0
              || !(
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 384; /* *movkfcc_invert_p10 */

        case E_TFmode:
          if (pattern480 (x2, 
E_TFmode) != 0
              || !(
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 385; /* *movtfcc_invert_p10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case AND:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern464 (x2, 
E_V4SImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V4SImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1755; /* altivec_vselv4si */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V4SImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                return -1;
              return 1765; /* altivec_vselv4si2 */

            case E_V8HImode:
              if (pattern464 (x2, 
E_V8HImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V8HImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1756; /* altivec_vselv8hi */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V8HImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                return -1;
              return 1766; /* altivec_vselv8hi2 */

            case E_V16QImode:
              if (pattern464 (x2, 
E_V16QImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V16QImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1757; /* altivec_vselv16qi */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V16QImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                return -1;
              return 1767; /* altivec_vselv16qi2 */

            case E_V4SFmode:
              if (pattern464 (x2, 
E_V4SFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V4SFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1758; /* altivec_vselv4sf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                return -1;
              return 1768; /* altivec_vselv4sf2 */

            case E_V2DFmode:
              if (pattern464 (x2, 
E_V2DFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V2DFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1759; /* altivec_vselv2df */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V2DFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                return -1;
              return 1769; /* altivec_vselv2df2 */

            case E_V2DImode:
              if (pattern464 (x2, 
E_V2DImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V2DImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1760; /* altivec_vselv2di */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V2DImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                return -1;
              return 1770; /* altivec_vselv2di2 */

            case E_V1TImode:
              if (pattern464 (x2, 
E_V1TImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V1TImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1761; /* altivec_vselv1ti */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V1TImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                return -1;
              return 1771; /* altivec_vselv1ti2 */

            case E_TImode:
              if (pattern464 (x2, 
E_TImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_TImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1762; /* altivec_vselti */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_TImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                return -1;
              return 1772; /* altivec_vselti2 */

            case E_KFmode:
              if (pattern464 (x2, 
E_KFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_KFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && (
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1763; /* altivec_vselkf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_KFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !(
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 1773; /* altivec_vselkf2 */

            case E_TFmode:
              if (pattern464 (x2, 
E_TFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_TFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && (
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1764; /* altivec_vseltf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_TFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !(
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 1774; /* altivec_vseltf2 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern49 (x2, 
E_SImode) != 0
                  || !
#line 1213 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2474; /* *fuse_andc_or */

            case E_DImode:
              if (pattern49 (x2, 
E_DImode) != 0
                  || !(
#line 1213 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2475; /* *fuse_andc_or */

            case E_V4SImode:
              if (pattern50 (x2, 
E_V4SImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2958; /* *fuse_vandc_vor */

            case E_V8HImode:
              if (pattern50 (x2, 
E_V8HImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2959; /* *fuse_vandc_vor */

            case E_V16QImode:
              if (pattern50 (x2, 
E_V16QImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2960; /* *fuse_vandc_vor */

            case E_V4SFmode:
              if (pattern50 (x2, 
E_V4SFmode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2961; /* *fuse_vandc_vor */

            case E_V2DFmode:
              if (pattern50 (x2, 
E_V2DFmode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2962; /* *fuse_vandc_vor */

            case E_V2DImode:
              if (pattern50 (x2, 
E_V2DImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2963; /* *fuse_vandc_vor */

            case E_V1TImode:
              if (pattern50 (x2, 
E_V1TImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2964; /* *fuse_vandc_vor */

            case E_TImode:
              if (pattern50 (x2, 
E_TImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2965; /* *fuse_vandc_vor */

            case E_KFmode:
              if (pattern50 (x2, 
E_KFmode) != 0
                  || !(
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2966; /* *fuse_vandc_vor */

            case E_TFmode:
              if (pattern50 (x2, 
E_TFmode) != 0
                  || !(
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2967; /* *fuse_vandc_vor */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (pattern53 (x2))
            {
            case 0:
              if (!
#line 1393 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2494; /* *fuse_andc_orc */

            case 1:
              if (!(
#line 1393 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2495; /* *fuse_andc_orc */

            case 2:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3038; /* *fuse_vandc_vorc */

            case 3:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3039; /* *fuse_vandc_vorc */

            case 4:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3040; /* *fuse_vandc_vorc */

            case 5:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3041; /* *fuse_vandc_vorc */

            case 6:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3042; /* *fuse_vandc_vorc */

            case 7:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3043; /* *fuse_vandc_vorc */

            case 8:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3044; /* *fuse_vandc_vorc */

            case 9:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3045; /* *fuse_vandc_vorc */

            case 10:
              if (!(
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3046; /* *fuse_vandc_vorc */

            case 11:
              if (!(
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3047; /* *fuse_vandc_vorc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x3, 0);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (pattern48 (x2))
        {
        case 0:
          if (!
#line 1267 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2480; /* *fuse_nor_or */

        case 1:
          if (!(
#line 1267 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2481; /* *fuse_nor_or */

        case 2:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2988; /* *fuse_vnor_vor */

        case 3:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2989; /* *fuse_vnor_vor */

        case 4:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2990; /* *fuse_vnor_vor */

        case 5:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2991; /* *fuse_vnor_vor */

        case 6:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2992; /* *fuse_vnor_vor */

        case 7:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2993; /* *fuse_vnor_vor */

        case 8:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2994; /* *fuse_vnor_vor */

        case 9:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2995; /* *fuse_vnor_vor */

        case 10:
          if (!(
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2996; /* *fuse_vnor_vor */

        case 11:
          if (!(
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2997; /* *fuse_vnor_vor */

        case 12:
          if (!
#line 1447 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2500; /* *fuse_nor_orc */

        case 13:
          if (!(
#line 1447 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2501; /* *fuse_nor_orc */

        case 14:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3068; /* *fuse_vnor_vorc */

        case 15:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3069; /* *fuse_vnor_vorc */

        case 16:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3070; /* *fuse_vnor_vorc */

        case 17:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3071; /* *fuse_vnor_vorc */

        case 18:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3072; /* *fuse_vnor_vorc */

        case 19:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3073; /* *fuse_vnor_vorc */

        case 20:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3074; /* *fuse_vnor_vorc */

        case 21:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3075; /* *fuse_vnor_vorc */

        case 22:
          if (!(
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3076; /* *fuse_vnor_vorc */

        case 23:
          if (!(
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3077; /* *fuse_vnor_vorc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 641; /* p8_xxpermdi_ti */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 642; /* p8_xxpermdi_v16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 643; /* p8_xxpermdi_v8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 644; /* p8_xxpermdi_v4si */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 645; /* p8_xxpermdi_v4sf */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 646; /* p8_xxpermdi_v2di */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 647; /* p8_xxpermdi_v2df */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 648; /* p8_xxpermdi_v1ti */

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !(
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 649; /* p8_xxpermdi_kf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !(
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 650; /* p8_xxpermdi_tf */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_0_to_1_operand (operands[1], E_QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[2], E_DDmode)
          || !
#line 294 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      return 2305; /* dfp_denbcd_dd */

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_TDmode:
          if (!gpc_reg_operand (operands[2], E_TDmode)
              || !
#line 294 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2306; /* dfp_denbcd_td */

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode)
              || !
#line 304 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2307; /* dfp_denbcd_v16qi_inst */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2330; /* crypto_vpmsumb */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2331; /* crypto_vpmsumh */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2332; /* crypto_vpmsumw */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2333; /* crypto_vpmsumd */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_0_to_12_operand (operands[2], E_QImode)
      || !
#line 6041 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
    return -1;
  return 1621; /* extract4b */
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_VOIDmode)
      || !
#line 14137 "../../gcc/config/rs6000/rs6000.md"
(REG_P (operands[0])
   && CR_REGNO_P (REGNO (operands[0]))
   && CONST_INT_P (operands[2])
   && INTVAL (operands[2]) == 1 << (7 - (REGNO (operands[0]) - CR0_REGNO))))
    return -1;
  return 928; /* *mtcrfsi */
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x2) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 5088 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1538; /* vsx_sign_extend_v2di_v1ti */

    case E_V4SImode:
      switch (pattern320 (x2, 
E_V4SImode))
        {
        case 0:
          if (!
#line 5099 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1539; /* vsx_sign_extend_v16qi_v4si */

        case 1:
          if (!
#line 5108 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1543; /* vsx_sign_extend_v8hi_v4si */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 5099 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1540; /* vsx_sign_extend_v16qi_v2di */

        case E_V8HImode:
          if (!vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 5108 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1544; /* vsx_sign_extend_v8hi_v2di */

        case E_V4SImode:
          if (!vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 5116 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1547; /* vsx_sign_extend_v4si_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern212 (x2))
    {
    case 0:
      if (!
#line 6840 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 472; /* floorsf2 */

    case 1:
      if (!
#line 6840 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 473; /* floordf2 */

    case 2:
      if (!(
#line 15447 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1069; /* floorkf2 */

    case 3:
      if (!(
#line 15447 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1070; /* floortf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2339 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1309; /* vsx_floorv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2589 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1994; /* *altivec_vrfim */

    case 5:
      if (!
#line 2339 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1310; /* vsx_floorv2df2 */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6859 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_VSX))
        return -1;
      return 476; /* *xsrdpisf2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6859 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_VSX))
        return -1;
      return 477; /* *xsrdpidf2 */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode
      || !vsx_register_operand (operands[0], E_DFmode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15593 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1095; /* trunckfdf2_odd */

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15593 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1096; /* trunctfdf2_odd */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_1_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 111 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2340; /* crypto_vshasigmaw */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 111 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2341; /* crypto_vshasigmad */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 11:
      if (pattern128 (x1) != 0
          || !(
#line 177 "../../gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2; /* load_macho_picbase_di */

    case 12:
      if (pattern128 (x1) != 0
          || !(
#line 193 "../../gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 3; /* reload_macho_picbase_di */

    case 90:
      if (pattern129 (x1) != 0
          || !
#line 2556 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_64BIT))
        return -1;
      return 132; /* cfuged */

    case 91:
      if (pattern129 (x1) != 0
          || !
#line 2565 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 133; /* cntlzdm */

    case 92:
      if (pattern129 (x1) != 0
          || !
#line 2574 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 134; /* cnttzdm */

    case 93:
      if (pattern130 (x1) != 0
          || !
#line 2583 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 135; /* pdepd */

    case 94:
      if (pattern130 (x1) != 0
          || !
#line 2592 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 136; /* pextd */

    case 51:
      return recog_59 (x1, insn, pnum_clobbers);

    case 99:
      switch (pattern132 (x1))
        {
        case 0:
          if (!
#line 5535 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 338; /* fmaxsf3 */

        case 1:
          if (!
#line 5535 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 340; /* fmaxdf3 */

        default:
          return -1;
        }

    case 100:
      switch (pattern132 (x1))
        {
        case 0:
          if (!
#line 5535 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 339; /* fminsf3 */

        case 1:
          if (!
#line 5535 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 341; /* fmindf3 */

        default:
          return -1;
        }

    case 4:
      return recog_58 (x1, insn, pnum_clobbers);

    case 59:
      return recog_40 (x1, insn, pnum_clobbers);

    case 63:
      return recog_32 (x1, insn, pnum_clobbers);

    case 14:
      return recog_49 (x1, insn, pnum_clobbers);

    case 20:
      if (pattern133 (x1) != 0)
        return -1;
      return 741; /* tls_dtprel_64 */

    case 21:
      if (pattern133 (x1) != 0)
        return -1;
      return 742; /* tls_dtprel_ha_64 */

    case 22:
      if (pattern133 (x1) != 0)
        return -1;
      return 743; /* tls_dtprel_lo_64 */

    case 23:
      if (pattern133 (x1) != 0)
        return -1;
      return 744; /* tls_got_dtprel_64 */

    case 24:
      if (pattern133 (x1) != 0)
        return -1;
      return 747; /* tls_tprel_64 */

    case 25:
      if (pattern133 (x1) != 0)
        return -1;
      return 748; /* tls_tprel_ha_64 */

    case 26:
      if (pattern133 (x1) != 0)
        return -1;
      return 749; /* tls_tprel_lo_64 */

    case 27:
      return recog_50 (x1, insn, pnum_clobbers);

    case 29:
      if (pattern133 (x1) != 0)
        return -1;
      return 754; /* tls_tls_pcrel_64 */

    case 28:
      if (pattern133 (x1) != 0)
        return -1;
      return 755; /* tls_tls_64 */

    case 18:
      return recog_57 (x1, insn, pnum_clobbers);

    case 70:
      return recog_48 (x1, insn, pnum_clobbers);

    case 71:
      return recog_39 (x1, insn, pnum_clobbers);

    case 78:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15489 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1077; /* addkf3_odd */

        case 1:
          if (!(
#line 15489 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1078; /* addtf3_odd */

        default:
          return -1;
        }

    case 79:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15500 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1079; /* subkf3_odd */

        case 1:
          if (!(
#line 15500 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1080; /* subtf3_odd */

        default:
          return -1;
        }

    case 80:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1081; /* mulkf3_odd */

        case 1:
          if (!(
#line 15511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1082; /* multf3_odd */

        default:
          return -1;
        }

    case 81:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15522 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1083; /* divkf3_odd */

        case 1:
          if (!(
#line 15522 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1084; /* divtf3_odd */

        default:
          return -1;
        }

    case 75:
      if (pattern136 (x1) != 0
          || !
#line 15691 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return -1;
      return 1101; /* *cmprb_internal */

    case 76:
      if (pattern136 (x1) != 0
          || !
#line 15778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return -1;
      return 1104; /* *cmprb2_internal */

    case 77:
      return recog_56 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern137 (x1, 
E_V2DImode) != 0
          || !
#line 1728 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1234; /* vsx_mul_v2di */

    case 130:
      if (pattern137 (x1, 
E_V2DImode) != 0
          || !
#line 1783 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1237; /* vsx_div_v2di */

    case 131:
      if (pattern137 (x1, 
E_V2DImode) != 0
          || !
#line 1830 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1238; /* vsx_udiv_v2di */

    case 132:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1887 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1239; /* vsx_div_v1ti */

    case 133:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1896 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1240; /* vsx_udiv_v1ti */

    case 134:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1905 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1241; /* vsx_dives_v1ti */

    case 135:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1914 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1242; /* vsx_diveu_v1ti */

    case 136:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1923 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1243; /* vsx_mods_v1ti */

    case 137:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1932 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1244; /* vsx_modu_v1ti */

    case 121:
      return recog_38 (x1, insn, pnum_clobbers);

    case 104:
      return recog_55 (x1, insn, pnum_clobbers);

    case 188:
      return recog_35 (x1, insn, pnum_clobbers);

    case 144:
      return recog_54 (x1, insn, pnum_clobbers);

    case 145:
      return recog_33 (x1, insn, pnum_clobbers);

    case 128:
      return recog_43 (x1, insn, pnum_clobbers);

    case 129:
      return recog_42 (x1, insn, pnum_clobbers);

    case 149:
      return recog_34 (x1, insn, pnum_clobbers);

    case 148:
      return recog_46 (x1, insn, pnum_clobbers);

    case 157:
      return recog_53 (x1, insn, pnum_clobbers);

    case 158:
      return recog_41 (x1, insn, pnum_clobbers);

    case 177:
      if (pattern138 (x1, 
E_V16QImode) != 0
          || !
#line 5887 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1597; /* vcmpnezb */

    case 179:
      if (pattern138 (x1, 
E_V8HImode) != 0
          || !
#line 5923 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1600; /* vcmpnezh */

    case 181:
      if (pattern138 (x1, 
E_V4SImode) != 0
          || !
#line 5943 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1602; /* vcmpnezw */

    case 182:
      return recog_52 (x1, insn, pnum_clobbers);

    case 200:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 6497 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1649; /* dives_v2di */

        case 1:
          if (!
#line 6497 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1650; /* dives_v4si */

        default:
          return -1;
        }

    case 201:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 6507 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1651; /* diveu_v2di */

        case 1:
          if (!
#line 6507 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1652; /* diveu_v4si */

        default:
          return -1;
        }

    case 218:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 528 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1711; /* altivec_vaddcuw */

    case 248:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 572 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1723; /* altivec_vsubcuw */

    case 219:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 600 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1730; /* uavgv4si3_ceil */

        case 1:
          if (!
#line 600 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1731; /* uavgv8hi3_ceil */

        case 2:
          if (!
#line 600 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1732; /* uavgv16qi3_ceil */

        default:
          return -1;
        }

    case 220:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 609 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1733; /* avgv4si3_ceil */

        case 1:
          if (!
#line 609 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1734; /* avgv8hi3_ceil */

        case 2:
          if (!
#line 609 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1735; /* avgv16qi3_ceil */

        default:
          return -1;
        }

    case 209:
      if (pattern143 (x1, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 618 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1736; /* altivec_vcmpbfp */

    case 331:
      switch (pattern144 (x1))
        {
        case 0:
          if (!
#line 1535 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1867; /* p8_vmrgew_v4sf_direct */

        case 1:
          if (!
#line 1535 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1868; /* p8_vmrgew_v4si_direct */

        default:
          return -1;
        }

    case 332:
      switch (pattern144 (x1))
        {
        case 0:
          if (!
#line 1544 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1869; /* p8_vmrgow_v4sf_direct */

        case 1:
          if (!
#line 1544 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1870; /* p8_vmrgow_v4si_direct */

        default:
          return -1;
        }

    case 221:
      if (pattern145 (x1) != 0
          || !
#line 1761 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1871; /* altivec_vmuleub */

    case 229:
      if (pattern145 (x1) != 0
          || !
#line 1770 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1872; /* altivec_vmuloub */

    case 222:
      if (pattern145 (x1) != 0
          || !
#line 1779 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1873; /* altivec_vmulesb */

    case 230:
      if (pattern145 (x1) != 0
          || !
#line 1788 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1874; /* altivec_vmulosb */

    case 223:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1797 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1875; /* altivec_vmuleuh */

    case 231:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1806 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1876; /* altivec_vmulouh */

    case 224:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1815 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1877; /* altivec_vmulesh */

    case 232:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1824 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1878; /* altivec_vmulosh */

    case 225:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1833 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1879; /* altivec_vmuleuw */

    case 227:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1842 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1880; /* altivec_vmuleud */

    case 233:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1851 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1881; /* altivec_vmulouw */

    case 235:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1860 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1882; /* altivec_vmuloud */

    case 226:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1869 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1883; /* altivec_vmulesw */

    case 228:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1878 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1884; /* altivec_vmulesd */

    case 234:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1887 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1885; /* altivec_vmulosw */

    case 236:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1896 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1886; /* altivec_vmulosd */

    case 237:
      if (pattern143 (x1, 
E_V4SImode, 
E_V8HImode) != 0
          || !
#line 1906 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1887; /* altivec_vpkpx */

    case 238:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1920 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1888; /* altivec_vpksdss */

        case 1:
          if (!
#line 1920 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1889; /* altivec_vpkswss */

        case 2:
          if (!
#line 1920 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1890; /* altivec_vpkshss */

        default:
          return -1;
        }

    case 239:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1934 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1891; /* altivec_vpksdus */

        case 1:
          if (!
#line 1934 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1892; /* altivec_vpkswus */

        case 2:
          if (!
#line 1934 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1893; /* altivec_vpkshus */

        default:
          return -1;
        }

    case 240:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1948 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1894; /* altivec_vpkudus */

        case 1:
          if (!
#line 1948 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1895; /* altivec_vpkuwus */

        case 2:
          if (!
#line 1948 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1896; /* altivec_vpkuhus */

        default:
          return -1;
        }

    case 241:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1962 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1897; /* altivec_vpkudum */

        case 1:
          if (!
#line 1962 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1898; /* altivec_vpkuwum */

        case 2:
          if (!
#line 1962 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1899; /* altivec_vpkuhum */

        default:
          return -1;
        }

    case 242:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1976 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1900; /* altivec_vpkudum_direct */

        case 1:
          if (!
#line 1976 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1901; /* altivec_vpkuwum_direct */

        case 2:
          if (!
#line 1976 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1902; /* altivec_vpkuhum_direct */

        default:
          return -1;
        }

    case 347:
      return recog_47 (x1, insn, pnum_clobbers);

    case 244:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2079 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1914; /* altivec_vsl */

    case 245:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2088 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1915; /* altivec_vslo */

    case 309:
      if (pattern148 (x1, 
E_V16QImode) != 0
          || !
#line 2097 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1916; /* vslv */

    case 310:
      if (pattern148 (x1, 
E_V16QImode) != 0
          || !
#line 2106 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1917; /* vsrv */

    case 246:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2166 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1935; /* altivec_vsr */

    case 247:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2175 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1936; /* altivec_vsro */

    case 330:
      return recog_36 (x1, insn, pnum_clobbers);

    case 257:
      if (pattern149 (x1) != 0
          || !
#line 2598 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1995; /* altivec_vcfux */

    case 258:
      if (pattern149 (x1) != 0
          || !
#line 2607 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1996; /* altivec_vcfsx */

    case 334:
      if (pattern140 (x1, 
E_V1TImode) != 0
          || !
#line 4442 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2174; /* altivec_vaddcuq */

    case 337:
      if (pattern140 (x1, 
E_V1TImode) != 0
          || !
#line 4459 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2176; /* altivec_vsubcuq */

    case 340:
      return recog_45 (x1, insn, pnum_clobbers);

    case 341:
      if (pattern148 (x1, 
E_V2DImode) != 0
          || !
#line 4529 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2183; /* altivec_vbpermd */

    case 348:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4636 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2196; /* vcfuged */

    case 349:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4645 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2197; /* vclzdm */

    case 350:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4654 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2198; /* vctzdm */

    case 352:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4663 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2199; /* vpdepd */

    case 353:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4672 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2200; /* vpextd */

    case 354:
      if (pattern150 (x1) != 0
          || !
#line 4690 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2202; /* vclrlb */

    case 355:
      if (pattern150 (x1) != 0
          || !
#line 4704 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2203; /* vclrrb */

    case 361:
      return recog_51 (x1, insn, pnum_clobbers);

    case 415:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2214; /* mma_xvi4ger8 */

    case 417:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2215; /* mma_xvi8ger4 */

    case 411:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2216; /* mma_xvi16ger2 */

    case 413:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2217; /* mma_xvi16ger2s */

    case 396:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2218; /* mma_xvf16ger2 */

    case 391:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2219; /* mma_xvbf16ger2 */

    case 401:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2220; /* mma_xvf32ger */

    case 406:
      if (pattern151 (x1, 
E_OOmode) != 0
          || !
#line 506 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2238; /* mma_xvf64ger */

    case 424:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_0_to_3_operand (operands[1], E_QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern365 (x2))
        {
        case 0:
          if (!
#line 284 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2303; /* dfp_ddedpd_dd */

        case 1:
          if (!
#line 284 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2304; /* dfp_ddedpd_td */

        default:
          return -1;
        }

    case 425:
      return recog_37 (x1, insn, pnum_clobbers);

    case 426:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern365 (x2))
        {
        case 0:
          if (!
#line 335 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2310; /* dfp_diex_dd */

        case 1:
          if (!
#line 335 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2311; /* dfp_diex_td */

        default:
          return -1;
        }

    case 428:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 385 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2314; /* dfp_dscli_dd */

        case 1:
          if (!
#line 385 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2315; /* dfp_dscli_td */

        default:
          return -1;
        }

    case 430:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 395 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2316; /* dfp_dscri_dd */

        case 1:
          if (!
#line 395 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2317; /* dfp_dscri_td */

        default:
          return -1;
        }

    case 432:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2322; /* crypto_vcipher_v16qi */

        case 1:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2326; /* crypto_vcipher_v2di */

        default:
          return -1;
        }

    case 433:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2323; /* crypto_vncipher_v16qi */

        case 1:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2327; /* crypto_vncipher_v2di */

        default:
          return -1;
        }

    case 434:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2324; /* crypto_vcipherlast_v16qi */

        case 1:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2328; /* crypto_vcipherlast_v2di */

        default:
          return -1;
        }

    case 435:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2325; /* crypto_vncipherlast_v16qi */

        case 1:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2329; /* crypto_vncipherlast_v2di */

        default:
          return -1;
        }

    case 439:
      return recog_44 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = recog_17 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
    case XOR:
      res = recog_23 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern312 (
E_SImode) != 0)
            return -1;
          return 215; /* *boolsi3 */

        case E_DImode:
          if (pattern312 (
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 216; /* *booldi3 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern358 (x4, 
E_SImode) != 0)
                return -1;
              return 221; /* *boolcsi3 */

            case E_DImode:
              if (pattern358 (x4, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 222; /* *boolcdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && 
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 514; /* *boolcti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !
#line 7488 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 523; /* *boolcti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && 
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 515; /* *boolcpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !
#line 7488 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 524; /* *boolcpti3_internal2 */

            case E_V16QImode:
              if (pattern359 (x4, 
E_V16QImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 516; /* *boolcv16qi3_internal1 */

            case E_V8HImode:
              if (pattern359 (x4, 
E_V8HImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 517; /* *boolcv8hi3_internal1 */

            case E_V4SImode:
              if (pattern359 (x4, 
E_V4SImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 518; /* *boolcv4si3_internal1 */

            case E_V4SFmode:
              if (pattern359 (x4, 
E_V4SFmode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 519; /* *boolcv4sf3_internal1 */

            case E_V2DImode:
              if (pattern359 (x4, 
E_V2DImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 520; /* *boolcv2di3_internal1 */

            case E_V2DFmode:
              if (pattern359 (x4, 
E_V2DFmode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 521; /* *boolcv2df3_internal1 */

            case E_V1TImode:
              if (pattern359 (x4, 
E_V1TImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 522; /* *boolcv1ti3_internal1 */

            default:
              return -1;
            }

        case NOT:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern361 (x2, 
E_SImode) != 0)
                return -1;
              return 227; /* *boolccsi3 */

            case E_DImode:
              if (pattern361 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 228; /* *boolccdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode
                  || GET_MODE (x5) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && 
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 525; /* *boolccti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !
#line 7549 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 534; /* *boolccti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode
                  || GET_MODE (x5) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && 
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 526; /* *boolccpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !
#line 7549 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 535; /* *boolccpti3_internal2 */

            case E_V16QImode:
              if (pattern362 (x2, 
E_V16QImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 527; /* *boolccv16qi3_internal1 */

            case E_V8HImode:
              if (pattern362 (x2, 
E_V8HImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 528; /* *boolccv8hi3_internal1 */

            case E_V4SImode:
              if (pattern362 (x2, 
E_V4SImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 529; /* *boolccv4si3_internal1 */

            case E_V4SFmode:
              if (pattern362 (x2, 
E_V4SFmode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 530; /* *boolccv4sf3_internal1 */

            case E_V2DImode:
              if (pattern362 (x2, 
E_V2DImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 531; /* *boolccv2di3_internal1 */

            case E_V2DFmode:
              if (pattern362 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 532; /* *boolccv2df3_internal1 */

            case E_V1TImode:
              if (pattern362 (x2, 
E_V1TImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 533; /* *boolccv1ti3_internal1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[0], E_HImode)
          && memory_operand (operands[1], E_HImode))
        return 142; /* bswaphi2_load */
      if (!gpc_reg_operand (operands[1], E_HImode))
        return -1;
      if (memory_operand (operands[0], E_HImode))
        return 144; /* bswaphi2_store */
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_HImode))
        return -1;
      *pnum_clobbers = 1;
      return 146; /* bswaphi2_reg */

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (gpc_reg_operand (operands[0], E_SImode)
          && memory_operand (operands[1], E_SImode))
        return 143; /* bswapsi2_load */
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      if (memory_operand (operands[0], E_SImode))
        return 145; /* bswapsi2_store */
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return 147; /* bswapsi2_reg */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DImode)
          && memory_operand (operands[1], E_DImode)
          && 
#line 2780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX))
        return 148; /* bswapdi2_load */
      if (gpc_reg_operand (operands[1], E_DImode))
        {
          if (memory_operand (operands[0], E_DImode)
              && 
#line 2787 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX))
            return 149; /* bswapdi2_store */
          if (gpc_reg_operand (operands[0], E_DImode))
            {
              if (
#line 2794 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR))
                return 150; /* bswapdi2_brd */
              if (pnum_clobbers != NULL
                  && 
#line 2806 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX && !TARGET_P9_VECTOR))
                {
                  *pnum_clobbers = 2;
                  return 151; /* bswapdi2_reg */
                }
            }
        }
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_DImode)
          || !reg_or_mem_operand (operands[1], E_DImode))
        return -1;
      if (
#line 2816 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX
   && (REG_P (operands[0]) || REG_P (operands[1]))
   && !(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))
   && !(MEM_P (operands[1]) && MEM_VOLATILE_P (operands[1]))))
        {
          *pnum_clobbers = 2;
          return 152; /* *bswapdi2_64bit */
        }
      if (!
#line 2978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && (REG_P (operands[0]) || REG_P (operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 153; /* bswapdi2_32bit */

    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V1TImode)
          || !
#line 6154 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1623; /* p9_xxbrq_v1ti */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 6174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1624; /* p9_xxbrd_v2di */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 6194 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1625; /* p9_xxbrw_v4si */

    case E_V8HImode:
      if (!vsx_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !vsx_register_operand (operands[1], E_V8HImode)
          || !
#line 6254 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1626; /* p9_xxbrh_v8hi */

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern19 (x3, 
E_SImode) != 0)
            return -1;
          return 179; /* *divsi3 */

        case E_DImode:
          if (pattern19 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 180; /* *divdi3 */

        case E_TImode:
          if (pattern1 (x3, 
E_TImode) != 0
              || !
#line 3441 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
            return -1;
          return 187; /* divti3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5123 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 307; /* *divsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5123 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 308; /* *divdf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15050 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 993; /* divkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15050 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 994; /* divtf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1773 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1235; /* *vsx_divv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1773 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1236; /* *vsx_divv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6516 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1653; /* divv2di3 */

        case E_V4SImode:
          if (pattern2 (x3, 
E_V4SImode) != 0
              || !
#line 6516 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1654; /* divv4si3 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 201 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2291; /* divdd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 201 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2292; /* divtd3 */

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern311 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 181; /* divsi3_sra */

        case E_DImode:
          if (pattern311 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 182; /* divdi3_sra */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 44:
      if (GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern187 (x4, 
43, 
2) != 0)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!gpc_reg_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 1730 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DLMZB))
        return -1;
      return 64; /* dlmzb */

    case 1:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 96
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[0] = x7;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x8, 0);
      operands[1] = x12;
      x4 = XVECEXP (x1, 0, 1);
      if (!rtx_equal_p (x4, operands[1])
          || !
#line 11189 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_LINK_STACK && TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2))
        return -1;
      return 760; /* load_toc_v4_PIC_1b_normal */

    case 35:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_CCEQmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!cc_reg_operand (operands[0], E_CCEQmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!memory_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[4] = x9;
      if (!scratch_operand (operands[4], E_DImode))
        return -1;
      *pnum_clobbers = 1;
      return 805; /* stack_protect_testdi */

    case 145:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (pattern330 (x1))
        {
        case 0:
          if (!
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1397; /* *vsx_extract_v2df_var_load */

        case 1:
          if (!
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1398; /* *vsx_extract_v2di_var_load */

        case 2:
          if (!
#line 3762 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1402; /* *vsx_extract_v4sf_var_load */

        case 3:
          if (!
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1425; /* *vsx_extract_v16qi_var_load */

        case 4:
          if (!
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1426; /* *vsx_extract_v8hi_var_load */

        case 5:
          if (!
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1427; /* *vsx_extract_v4si_var_load */

        default:
          return -1;
        }

    case 177:
      if (pattern224 (x1, 
E_V16QImode, 
177) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!altivec_register_operand (operands[2], E_V16QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!altivec_register_operand (operands[0], E_V16QImode))
        return -1;
      x5 = XEXP (x4, 1);
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 5903 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1598; /* vcmpnezb_p */

    case 249:
      if (pattern225 (x1, 
E_V16QImode) != 0
          || !
#line 2235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1945; /* altivec_vsum4ubs */

    case 250:
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern286 (x4, 
E_SImode, 
282) != 0
          || pattern255 (x1, 
E_V4SImode, 
E_SImode, 
109) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !
#line 2245 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1946; /* altivec_vsum4shs */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !
#line 2245 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1947; /* altivec_vsum4sbs */

        default:
          return -1;
        }

    case 251:
      if (pattern225 (x1, 
E_V4SImode) != 0
          || !
#line 2278 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1948; /* altivec_vsum2sws_direct */

    case 333:
      if (pattern225 (x1, 
E_V4SImode) != 0
          || !
#line 2310 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1949; /* altivec_vsumsws_direct */

    case 259:
      if (pattern226 (x1) != 0
          || !
#line 2617 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1997; /* altivec_vctuxs */

    case 260:
      if (pattern226 (x1) != 0
          || !
#line 2627 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1998; /* altivec_vctsxs */

    case 209:
      if (pattern224 (x1, 
E_V4SFmode, 
209) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x5 = XEXP (x4, 1);
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 2930 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode)))
        return -1;
      return 2045; /* altivec_vcmpbfp_p */

    case 441:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern286 (x4, 
E_DImode, 
442) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!base_reg_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!pcrel_external_address (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      if (!gpc_reg_operand (operands[3], E_DImode)
          || !
#line 111 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && reg_or_subregno (operands[0]) != reg_or_subregno (operands[3])))
        return -1;
      return 3191; /* pcrel_opt_ld_addr */

    case 445:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!pcrel_external_address (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[3]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[3], E_QImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3221; /* *pcrel_opt_st_addrqi */

        case E_HImode:
          if (!gpc_reg_operand (operands[3], E_HImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3222; /* *pcrel_opt_st_addrhi */

        case E_SImode:
          if (!gpc_reg_operand (operands[3], E_SImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3223; /* *pcrel_opt_st_addrsi */

        case E_DImode:
          if (!gpc_reg_operand (operands[3], E_DImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3224; /* *pcrel_opt_st_addrdi */

        case E_TImode:
          if (!gpc_reg_operand (operands[3], E_TImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3225; /* *pcrel_opt_st_addrti */

        case E_SFmode:
          if (!gpc_reg_operand (operands[3], E_SFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3226; /* *pcrel_opt_st_addrsf */

        case E_DFmode:
          if (!gpc_reg_operand (operands[3], E_DFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3227; /* *pcrel_opt_st_addrdf */

        case E_KFmode:
          if (!gpc_reg_operand (operands[3], E_KFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3228; /* *pcrel_opt_st_addrkf */

        case E_V1TImode:
          if (!gpc_reg_operand (operands[3], E_V1TImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3229; /* *pcrel_opt_st_addrv1ti */

        case E_V2DImode:
          if (!gpc_reg_operand (operands[3], E_V2DImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3230; /* *pcrel_opt_st_addrv2di */

        case E_V4SImode:
          if (!gpc_reg_operand (operands[3], E_V4SImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3231; /* *pcrel_opt_st_addrv4si */

        case E_V8HImode:
          if (!gpc_reg_operand (operands[3], E_V8HImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3232; /* *pcrel_opt_st_addrv8hi */

        case E_V16QImode:
          if (!gpc_reg_operand (operands[3], E_V16QImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3233; /* *pcrel_opt_st_addrv16qi */

        case E_V2DFmode:
          if (!gpc_reg_operand (operands[3], E_V2DFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3234; /* *pcrel_opt_st_addrv2df */

        case E_V4SFmode:
          if (!gpc_reg_operand (operands[3], E_V4SFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3235; /* *pcrel_opt_st_addrv4sf */

        case E_TFmode:
          if (!gpc_reg_operand (operands[3], E_TFmode)
              || !(
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 95 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
            return -1;
          return 3236; /* *pcrel_opt_st_addrtf */

        default:
          return -1;
        }

    case 446:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      if (!base_reg_operand (operands[3], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!d_form_memory (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !gpc_reg_operand (operands[1], E_QImode)
              || !
#line 313 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3237; /* *pcrel_opt_stqi */

        case E_HImode:
          if (!d_form_memory (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !gpc_reg_operand (operands[1], E_HImode)
              || !
#line 313 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3238; /* *pcrel_opt_sthi */

        case E_SImode:
          if (!d_form_memory (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode)
              || !
#line 313 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3239; /* *pcrel_opt_stsi */

        case E_DImode:
          if (!d_form_memory (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 326 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT && TARGET_POWERPC64))
            return -1;
          return 3240; /* *pcrel_opt_stdi */

        case E_SFmode:
          if (!d_form_memory (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 349 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3241; /* *pcrel_opt_stsf */

        case E_DFmode:
          if (!d_form_memory (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 372 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (TARGET_POWERPC64 || vsx_register_operand (operands[1], DFmode))))
            return -1;
          return 3242; /* *pcrel_opt_stdf */

        case E_TImode:
          if (!d_form_memory (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !gpc_reg_operand (operands[1], E_TImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3243; /* *pcrel_opt_stti */

        case E_KFmode:
          if (!d_form_memory (operands[0], E_KFmode)
              || GET_MODE (x3) != E_KFmode
              || !gpc_reg_operand (operands[1], E_KFmode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3244; /* *pcrel_opt_stkf */

        case E_V1TImode:
          if (!d_form_memory (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !gpc_reg_operand (operands[1], E_V1TImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3245; /* *pcrel_opt_stv1ti */

        case E_V2DImode:
          if (!d_form_memory (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !gpc_reg_operand (operands[1], E_V2DImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3246; /* *pcrel_opt_stv2di */

        case E_V4SImode:
          if (!d_form_memory (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !gpc_reg_operand (operands[1], E_V4SImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3247; /* *pcrel_opt_stv4si */

        case E_V8HImode:
          if (!d_form_memory (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !gpc_reg_operand (operands[1], E_V8HImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3248; /* *pcrel_opt_stv8hi */

        case E_V16QImode:
          if (!d_form_memory (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !gpc_reg_operand (operands[1], E_V16QImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3249; /* *pcrel_opt_stv16qi */

        case E_V2DFmode:
          if (!d_form_memory (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !gpc_reg_operand (operands[1], E_V2DFmode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3250; /* *pcrel_opt_stv2df */

        case E_V4SFmode:
          if (!d_form_memory (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !gpc_reg_operand (operands[1], E_V4SFmode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3251; /* *pcrel_opt_stv4sf */

        case E_TFmode:
          if (!d_form_memory (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !gpc_reg_operand (operands[1], E_TFmode)
              || !(
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 99 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
            return -1;
          return 3252; /* *pcrel_opt_sttf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x8;
      if (vsx_register_operand (operands[1], E_V1TImode)
          && XWINT (x5, 0) == 0L
          && memory_operand (operands[0], E_V1TImode)
          && GET_MODE (x3) == E_V1TImode)
        {
          x9 = XEXP (x6, 0);
          if (rtx_equal_p (x9, operands[1])
              && 
#line 1543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
            return 1220; /* vsx_st_elemrev_v1ti */
        }
      operands[2] = x5;
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern509 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 1389; /* *vsx_extract_di_v2df_load */

        case E_DImode:
          if (pattern509 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !(
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 1390; /* *vsx_extract_di_v2di_load */

        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && scratch_operand (operands[3], E_V4SFmode)
              && 
#line 3692 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1399; /* vsx_extract_v4sf */
          if (!register_operand (operands[0], E_SFmode)
              || !memory_operand (operands[1], E_V4SFmode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 3725 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 1400; /* *vsx_extract_v4sf_di_load */

        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_V4SImode)
              && const_0_to_3_operand (operands[2], E_QImode))
            {
              if (nonimmediate_operand (operands[0], E_SImode)
                  && scratch_operand (operands[3], E_V4SImode))
                {
                  if (
#line 3932 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
                    return 1405; /* vsx_extract_v4si_w1 */
                  if (
#line 4081 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT))
                    return 1416; /* *vsx_extract_v4si_w023 */
                }
              if (gpc_reg_operand (operands[0], E_SImode)
                  && scratch_operand (operands[3], E_SImode)
                  && 
#line 3969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
                return 1409; /* vsx_extract_v4si_p9 */
            }
          if (!register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1421; /* *vsx_extract_v4si_load */

        case E_QImode:
          if (GET_MODE (x3) != E_QImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_V16QImode)
              && const_0_to_15_operand (operands[2], E_QImode))
            {
              if (gpc_reg_operand (operands[0], E_QImode)
                  && scratch_operand (operands[3], E_SImode)
                  && 
#line 3969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
                return 1407; /* vsx_extract_v16qi_p9 */
              if (nonimmediate_operand (operands[0], E_QImode)
                  && scratch_operand (operands[3], E_V16QImode)
                  && 
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
                return 1417; /* *vsx_extract_v16qi_p8 */
            }
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1419; /* *vsx_extract_v16qi_load */

        case E_HImode:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_V8HImode)
              && const_0_to_7_operand (operands[2], E_QImode))
            {
              if (gpc_reg_operand (operands[0], E_HImode)
                  && scratch_operand (operands[3], E_SImode)
                  && 
#line 3969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
                return 1408; /* vsx_extract_v8hi_p9 */
              if (nonimmediate_operand (operands[0], E_HImode)
                  && scratch_operand (operands[3], E_V8HImode)
                  && 
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
                return 1418; /* *vsx_extract_v8hi_p8 */
            }
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1420; /* *vsx_extract_v8hi_load */

        default:
          return -1;
        }

    case PLUS:
      if (pattern426 (x1) != 0
          || !
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1532; /* *vsx_reduc_plus_v2df_scalar */

    case SMIN:
      if (pattern426 (x1) != 0
          || !
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1533; /* *vsx_reduc_smin_v2df_scalar */

    case SMAX:
      if (pattern426 (x1) != 0
          || !
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1534; /* *vsx_reduc_smax_v2df_scalar */

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern73 (x1))
    {
    case 0:
      if (!
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()))
        return -1;
      return 391; /* floatsisf2_lfiwax */

    case 1:
      if (memory_operand (operands[1], E_DImode)
          && scratch_operand (operands[2], E_DImode)
          && 
#line 7048 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS))
        return 492; /* *floatdisf2_mem */
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[2], E_DFmode)
          || !
#line 7068 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS))
        return -1;
      return 493; /* floatdisf2_internal1 */

    case 2:
      if (!
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()))
        return -1;
      return 392; /* floatsidf2_lfiwax */

    case 3:
      if (!
#line 6975 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
        return -1;
      return 488; /* *floatdidf2_mem */

    case 4:
      if (!(
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1055; /* float_kfsi2_hw */

    case 5:
      if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1057; /* floatqikf2 */

    case 6:
      if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1058; /* floathikf2 */

    case 7:
      if (!(
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1056; /* float_tfsi2_hw */

    case 8:
      if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1059; /* floatqitf2 */

    case 9:
      if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1060; /* floathitf2 */

    case 10:
      if (!
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS))
        return -1;
      return 393; /* floatsisf2_lfiwax_mem */

    case 11:
      if (!
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID))
        return -1;
      return 394; /* floatsidf2_lfiwax_mem */

    case 12:
      if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 395; /* floatsisf2_lfiwax_qi_mem_zext */

    case 13:
      if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 396; /* floatsisf2_lfiwax_hi_mem_zext */

    case 14:
      if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 397; /* floatsidf2_lfiwax_qi_mem_zext */

    case 15:
      if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 398; /* floatsidf2_lfiwax_hi_mem_zext */

    case 16:
      if (const_0_to_3_operand (operands[2], E_QImode)
          && scratch_operand (operands[3], E_V4SImode)
          && 
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
        return 1460; /* *vsx_extract_si_float_df */
      if (!const_int_operand (operands[2], E_QImode)
          || !scratch_operand (operands[3], E_SImode)
          || !
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1479; /* *vsx_ext_SI_fl_df */

    case 17:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1471; /* *vsx_ext_QI_fl_df */

    case 18:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1475; /* *vsx_ext_HI_fl_df */

    case 19:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1470; /* *vsx_ext_QI_fl_sf */

    case 20:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1474; /* *vsx_ext_HI_fl_sf */

    case 21:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1478; /* *vsx_ext_SI_fl_sf */

    case 22:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1472; /* *vsx_ext_QI_fl_kf */

    case 23:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1476; /* *vsx_ext_HI_fl_kf */

    case 24:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1480; /* *vsx_ext_SI_fl_kf */

    case 25:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1473; /* *vsx_ext_QI_fl_tf */

    case 26:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1477; /* *vsx_ext_HI_fl_tf */

    case 27:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1481; /* *vsx_ext_SI_fl_tf */

    default:
      return -1;
    }
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
        return -1;
      return 400; /* floatunssisf2_lfiwzx */

    case 1:
      if (!
#line 7129 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
        return -1;
      return 495; /* *floatunsdisf2_mem */

    case 2:
      if (!
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
        return -1;
      return 401; /* floatunssidf2_lfiwzx */

    case 3:
      if (!
#line 7004 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))))
        return -1;
      return 490; /* *floatunsdidf2_mem */

    case 4:
      if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1063; /* floatuns_kfsi2_hw */

    case 5:
      if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1065; /* floatunsqikf2 */

    case 6:
      if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1066; /* floatunshikf2 */

    case 7:
      if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1064; /* floatuns_tfsi2_hw */

    case 8:
      if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1067; /* floatunsqitf2 */

    case 9:
      if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1068; /* floatunshitf2 */

    case 10:
      if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
        return -1;
      return 402; /* floatunssisf2_lfiwzx_mem */

    case 11:
      if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
        return -1;
      return 403; /* floatunssidf2_lfiwzx_mem */

    case 12:
      if (const_0_to_3_operand (operands[2], E_QImode)
          && scratch_operand (operands[3], E_V4SImode)
          && 
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
        return 1461; /* *vsx_extract_si_unsfloat_df */
      if (!const_int_operand (operands[2], E_QImode)
          || !scratch_operand (operands[3], E_SImode)
          || !
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1491; /* *vsx_ext_SI_ufl_df */

    case 13:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1483; /* *vsx_ext_QI_ufl_df */

    case 14:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1487; /* *vsx_ext_HI_ufl_df */

    case 15:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1482; /* *vsx_ext_QI_ufl_sf */

    case 16:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1486; /* *vsx_ext_HI_ufl_sf */

    case 17:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1490; /* *vsx_ext_SI_ufl_sf */

    case 18:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1484; /* *vsx_ext_QI_ufl_kf */

    case 19:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1488; /* *vsx_ext_HI_ufl_kf */

    case 20:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1492; /* *vsx_ext_SI_ufl_kf */

    case 21:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1485; /* *vsx_ext_QI_ufl_tf */

    case 22:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1489; /* *vsx_ext_HI_ufl_tf */

    case 23:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1493; /* *vsx_ext_SI_ufl_tf */

    default:
      return -1;
    }
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTEND:
      return recog_127 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_119 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_136 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_125 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_131 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_133 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_118 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern0 (x1))
        {
        case 0:
          return 122; /* clzsi2 */

        case 1:
          if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 123; /* clzdi2 */

        case 2:
          if (!
#line 4370 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2152; /* *p8v_clzv4si2 */

        case 3:
          if (!
#line 4370 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2153; /* *p8v_clzv8hi2 */

        case 4:
          if (!
#line 4370 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2154; /* *p8v_clzv16qi2 */

        case 5:
          if (!
#line 4370 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2155; /* *p8v_clzv2di2 */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 2490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CTZ))
            return -1;
          return 124; /* ctzsi2_hw */

        case 1:
          if (!(
#line 2490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CTZ) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 125; /* ctzdi2_hw */

        case 2:
          if (!
#line 4392 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2159; /* *p9v_ctzv4si2 */

        case 3:
          if (!
#line 4392 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2160; /* *p9v_ctzv8hi2 */

        case 4:
          if (!
#line 4392 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2161; /* *p9v_ctzv16qi2 */

        case 5:
          if (!
#line 4392 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2162; /* *p9v_ctzv2di2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 2530 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
            return -1;
          return 128; /* popcntdsi2 */

        case 1:
          if (!(
#line 2530 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 129; /* popcntddi2 */

        case 2:
          if (!
#line 4400 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2163; /* *p8v_popcountv4si2 */

        case 3:
          if (!
#line 4400 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2164; /* *p8v_popcountv8hi2 */

        case 4:
          if (!
#line 4400 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2165; /* *p8v_popcountv16qi2 */

        case 5:
          if (!
#line 4400 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2166; /* *p8v_popcountv2di2 */

        default:
          return -1;
        }

    case BSWAP:
      return recog_134 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_145 (x1, insn, pnum_clobbers);

    case UDIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern19 (x2, 
E_SImode) != 0)
            return -1;
          return 176; /* udivsi3 */

        case E_DImode:
          if (pattern19 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 177; /* udivdi3 */

        case E_TImode:
          if (pattern1 (x2, 
E_TImode) != 0
              || !
#line 3343 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
            return -1;
          return 178; /* udivti3 */

        case E_V2DImode:
          if (pattern2 (x2, 
E_V2DImode) != 0
              || !
#line 6525 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1655; /* udivv2di3 */

        case E_V4SImode:
          if (pattern2 (x2, 
E_V4SImode) != 0
              || !
#line 6525 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1656; /* udivv4si3 */

        default:
          return -1;
        }

    case DIV:
      return recog_142 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case EQ:
        case GT:
        case LT:
        case GTU:
        case LTU:
        case UNORDERED:
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case NE:
        case GE:
        case LE:
        case GEU:
        case LEU:
        case ORDERED:
        case UNLE:
        case UNLT:
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNLE:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!extra_insn_branch_comparison_operator (x4, E_VOIDmode)
          || pattern28 (x1) != 0
          || !
#line 13342 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
        return -1;
      return 890; /* *cbranch_2insn */

    case AND:
    case IOR:
    case XOR:
      return recog_128 (x1, insn, pnum_clobbers);

    case EQ:
    case GT:
    case LT:
    case GTU:
    case LTU:
    case UNORDERED:
      return recog_130 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_144 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern124 (x2, pnum_clobbers))
            {
            case 0:
              return 271; /* ashlsi3 */

            case 1:
              if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 272; /* ashldi3 */

            case 2:
              if (!
#line 2114 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 1918; /* *altivec_vslw */

            case 3:
              if (!
#line 2114 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 1919; /* *altivec_vslh */

            case 4:
              if (!
#line 2114 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 1920; /* *altivec_vslb */

            case 5:
              if (!
#line 2114 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 1921; /* *altivec_vsld */

            case 6:
              if (!
#line 2122 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 1922; /* altivec_vslq_v1ti */

            case 7:
              if (!
#line 2122 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 1923; /* altivec_vslq_ti */

            case 8:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 1937; /* *altivec_v4si_ashift_const */

            case 9:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 1940; /* *altivec_v2di_ashift_const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!reg_or_mem_operand (operands[1], E_SImode)
              || !u6bit_cint_operand (operands[2], E_DImode)
              || !
#line 4707 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 278; /* ashdi3_extswsli */

        default:
          return -1;
        }

    case LSHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern124 (x2, pnum_clobbers))
        {
        case 0:
          return 281; /* lshrsi3 */

        case 1:
          if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 282; /* lshrdi3 */

        case 2:
          if (!
#line 2131 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1924; /* *altivec_vsrw */

        case 3:
          if (!
#line 2131 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1925; /* *altivec_vsrh */

        case 4:
          if (!
#line 2131 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1926; /* *altivec_vsrb */

        case 5:
          if (!
#line 2131 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1927; /* *altivec_vsrd */

        case 6:
          if (!
#line 2139 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1928; /* altivec_vsrq_v1ti */

        case 7:
          if (!
#line 2139 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1929; /* altivec_vsrq_ti */

        case 8:
          if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
            return -1;
          *pnum_clobbers = 1;
          return 1939; /* *altivec_v4si_lshiftrt_const */

        case 9:
          if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
            return -1;
          *pnum_clobbers = 1;
          return 1942; /* *altivec_v2di_lshiftrt_const */

        default:
          return -1;
        }

    case ASHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern121 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 288; /* ashrsi3 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern121 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              *pnum_clobbers = 1;
              return 289; /* ashrdi3 */

            case E_V4SImode:
              if (pattern3 (x2, 
E_V4SImode) != 0
                  || !
#line 2148 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 1930; /* *altivec_vsraw */

            case E_V8HImode:
              if (pattern3 (x2, 
E_V8HImode) != 0
                  || !
#line 2148 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 1931; /* *altivec_vsrah */

            case E_V16QImode:
              if (pattern3 (x2, 
E_V16QImode) != 0
                  || !
#line 2148 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 1932; /* *altivec_vsrab */

            case E_V2DImode:
              if (pattern3 (x2, 
E_V2DImode) != 0
                  || !
#line 2148 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 1933; /* *altivec_vsrad */

            case E_V1TImode:
              if (pattern2 (x2, 
E_V1TImode) != 0
                  || !
#line 2156 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 1934; /* altivec_vsraq */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case VEC_DUPLICATE:
          switch (pattern123 (x2, pnum_clobbers))
            {
            case 0:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 1938; /* *altivec_v4si_ashiftrt_const */

            case 1:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 1941; /* *altivec_v2di_ashiftrt_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      return recog_135 (x1, insn, pnum_clobbers);

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5133 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GPOPT))
            return -1;
          return 309; /* *sqrtsf2_internal */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 5133 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GPOPT))
            return -1;
          return 310; /* *sqrtdf2_internal */

        case E_KFmode:
          if (!altivec_register_operand (operands[0], E_KFmode)
              || GET_MODE (x2) != E_KFmode
              || !altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15059 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 995; /* sqrtkf2 */

        case E_TFmode:
          if (!altivec_register_operand (operands[0], E_TFmode)
              || GET_MODE (x2) != E_TFmode
              || !altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15059 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 996; /* sqrttf2 */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 2023 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1260; /* *vsx_sqrtv4sf2 */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2023 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1261; /* *vsx_sqrtv2df2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      return recog_132 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_138 (x1, insn, pnum_clobbers);

    case COPYSIGN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern19 (x2, 
E_SFmode) != 0
              || !
#line 5455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_CMPB || VECTOR_UNIT_VSX_P (SFmode))))
            return -1;
          return 324; /* copysignsf3_fcpsgn */

        case E_DFmode:
          if (pattern19 (x2, 
E_DFmode) != 0
              || !
#line 5455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_CMPB || VECTOR_UNIT_VSX_P (DFmode))))
            return -1;
          return 325; /* copysigndf3_fcpsgn */

        case E_KFmode:
          if (pattern1 (x2, 
E_KFmode) != 0)
            return -1;
          if ((
#line 15102 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 997; /* copysignkf3_hard */
          if (pnum_clobbers == NULL
              || !(
#line 15113 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 999; /* copysignkf3_soft */

        case E_TFmode:
          if (pattern1 (x2, 
E_TFmode) != 0)
            return -1;
          if ((
#line 15102 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 998; /* copysigntf3_hard */
          if (pnum_clobbers == NULL
              || !(
#line 15113 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1000; /* copysigntf3_soft */

        case E_V4SFmode:
          if (pattern2 (x2, 
E_V4SFmode) != 0
              || !
#line 2265 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1288; /* vsx_copysignv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x2, 
E_V2DFmode) != 0
              || !
#line 2265 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1289; /* vsx_copysignv2df3 */

        default:
          return -1;
        }

    case SMIN:
      return recog_140 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_139 (x1, insn, pnum_clobbers);

    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      return recog_143 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_121 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_124 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_120 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_122 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_126 (x1, insn, pnum_clobbers);

    case LO_SUM:
      return recog_146 (x1, insn, pnum_clobbers);

    case UNSPEC:
    case PLUS:
      switch (GET_CODE (x2))
        {
        case PLUS:
          res = recog_31 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSPEC:
          res = recog_106 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern65 ())
        {
        case 0:
          if ((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return 767; /* *tocrefsi */
          break;

        case 1:
          if ((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return 768; /* *tocrefdi */
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case UNSPEC:
          return recog_107 (x1, insn, pnum_clobbers);

        case PLUS:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case EQ:
              if (pattern165 (x1) != 0)
                return -1;
              *pnum_clobbers = 3;
              return 863; /* *plus_eq_di */

            case NE:
              if (pattern165 (x1) != 0)
                return -1;
              *pnum_clobbers = 3;
              return 864; /* *plus_ne_di */

            case AND:
              switch (pattern41 (x1))
                {
                case 0:
                  if (!
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2524; /* *fuse_and_add */

                case 1:
                  if (!(
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2525; /* *fuse_and_add */

                case 2:
                  if (!
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2528; /* *fuse_nor_add */

                case 3:
                  if (!(
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2529; /* *fuse_nor_add */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern42 (x1))
                {
                case 0:
                  if (!
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2526; /* *fuse_nand_add */

                case 1:
                  if (!(
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2527; /* *fuse_nand_add */

                case 2:
                  if (!
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2530; /* *fuse_or_add */

                case 3:
                  if (!(
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2531; /* *fuse_or_add */

                default:
                  return -1;
                }

            case PLUS:
              switch (pattern120 (x1))
                {
                case 0:
                  if (!
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3188; /* *fuse_add_add */

                case 1:
                  if (!(
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3189; /* *fuse_add_add */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNLE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 871; /* *unlesi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 875; /* *unledi_cc */

        case 2:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1136; /* vector_unlev4sf */

        case 3:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1143; /* vector_unlev2df */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 872; /* *ungesi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 876; /* *ungedi_cc */

        case 2:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1134; /* vector_ungev4sf */

        case 3:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1141; /* vector_ungev2df */

        default:
          return -1;
        }

    case LTGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 877; /* *ltgtsi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 883; /* *ltgtdi_cc */

        case 2:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1144; /* vector_ltgtv4sf */

        case 3:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1148; /* vector_ltgtv2df */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 880; /* *unltsi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 886; /* *unltdi_cc */

        case 2:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1135; /* vector_unltv4sf */

        case 3:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1142; /* vector_unltv2df */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 881; /* *ungtsi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 887; /* *ungtdi_cc */

        case 2:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1133; /* vector_ungtv4sf */

        case 3:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1140; /* vector_ungtv2df */

        default:
          return -1;
        }

    case UNEQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 882; /* *uneqsi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 888; /* *uneqdi_cc */

        case 2:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1145; /* vector_uneqv4sf */

        case 3:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1149; /* vector_uneqv2df */

        default:
          return -1;
        }

    case FMA:
      return recog_137 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
    case VEC_DUPLICATE:
      return recog_129 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_123 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_141 (x1, insn, pnum_clobbers);

    case MOD:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 6534 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1657; /* modv2di3 */

        case 1:
          if (!
#line 6534 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1658; /* modv4si3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 6543 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1659; /* umodv2di3 */

        case 1:
          if (!
#line 6543 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1660; /* umodv4si3 */

        default:
          return -1;
        }

    case US_MULT:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ASHIFTRT)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != ASHIFTRT)
        return -1;
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern285 (x2))
        {
        case 0:
          if (!
#line 6568 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1663; /* umulv2di3_highpart */

        case 1:
          if (!
#line 6568 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1664; /* umulv4si3_highpart */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 1073 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1824; /* umaxv4si3 */

        case 1:
          if (!
#line 1073 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1825; /* umaxv8hi3 */

        case 2:
          if (!
#line 1073 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1826; /* umaxv16qi3 */

        case 3:
          if (!
#line 1073 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1827; /* umaxv2di3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 1097 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1833; /* uminv4si3 */

        case 1:
          if (!
#line 1097 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1834; /* uminv8hi3 */

        case 2:
          if (!
#line 1097 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1835; /* uminv16qi3 */

        case 3:
          if (!
#line 1097 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1836; /* uminv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case DIV:
      switch (pattern117 (x1, 
MOD))
        {
        case 0:
          if (!
#line 3539 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_1 (insn, operands);

        case 1:
          if (!(
#line 3539 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_2 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern117 (x1, 
UMOD))
        {
        case 0:
          if (!
#line 3561 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_3 (insn, operands);

        case 1:
          if (!(
#line 3561 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_4 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CCmode)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x2, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!int_reg_operand (operands[1], E_SImode)
              || !int_reg_operand (operands[0], E_SImode)
              || !(
#line 8059 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        case E_DImode:
          if (!int_reg_operand (operands[1], E_DImode)
              || !int_reg_operand (operands[0], E_DImode)
              || !(
#line 8059 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_6 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case HIGH:
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_SImode)
              && pattern347 (x2, 
E_SImode) == 0)
            {
              if ((
#line 8074 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 8074 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && ((
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_8 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (peep2_current_count >= 3)
            {
              res = peephole2_1 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          if (!fusion_gpr_addis (operands[1], E_SImode))
            return NULL;
          switch (pattern348 (x2, 
E_SImode))
            {
            case 0:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_14 (insn, operands);

            case 1:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_15 (insn, operands);

            case 2:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_16 (insn, operands);

            case 3:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_17 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_DImode)
              && pattern347 (x2, 
E_DImode) == 0
              && (
#line 8074 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (fusion_gpr_addis (operands[1], E_DImode))
            {
              switch (pattern348 (x2, 
E_DImode))
                {
                case 0:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_18 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_19 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_20 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 3:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_21 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DImode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DImode)
              && simple_offsettable_mem_operand (operands[2], E_DImode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_26 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_27 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DImode)
              || !altivec_register_operand (operands[2], E_DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_32 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_33 (insn, operands);

        case E_DFmode:
          operands[0] = x5;
          if (pattern258 (x3, 
E_DFmode) == 0
              && 
#line 10545 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_11 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DFmode)
              && simple_offsettable_mem_operand (operands[2], E_DFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_22 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_23 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DFmode)
              || !altivec_register_operand (operands[2], E_DFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_28 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_29 (insn, operands);

        case E_SFmode:
          operands[0] = x5;
          if (pattern258 (x3, 
E_SFmode) == 0
              && 
#line 10554 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_12 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_SFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_SFmode)
              && simple_offsettable_mem_operand (operands[2], E_SFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_24 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_25 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_SFmode)
              || !altivec_register_operand (operands[2], E_SFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_30 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_31 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != ROTATE)
        return NULL;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!int_reg_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || GET_MODE (x8) != E_V1TImode)
            return NULL;
          if (memory_operand (operands[1], E_V1TImode)
              && int_reg_operand (operands[2], E_V1TImode)
              && 
#line 1095 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_34 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!int_reg_operand (operands[1], E_V1TImode)
              || !memory_operand (operands[2], E_V1TImode)
              || !
#line 1107 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_36 (insn, operands);

        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x8) != E_TImode)
            return NULL;
          if (int_reg_operand (operands[0], E_TImode))
            {
              if (memory_operand (operands[1], E_TImode)
                  && int_reg_operand (operands[2], E_TImode)
                  && 
#line 1095 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_35 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (int_reg_operand (operands[1], E_TImode)
                  && memory_operand (operands[2], E_TImode)
                  && 
#line 1107 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_37 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!vsx_register_operand (operands[0], E_TImode)
              || !vsx_register_operand (operands[1], E_TImode)
              || !vsx_register_operand (operands[2], E_TImode)
              || !
#line 1121 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_38 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!int_reg_operand (operands[2], E_DImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[3] = x6;
      if (!vsx_register_operand (operands[3], E_SImode))
        return NULL;
      x7 = XEXP (x2, 0);
      operands[4] = x7;
      if (!int_reg_operand (operands[4], E_SImode))
        return NULL;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_SImode)
        return NULL;
      x11 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x11) != SET)
        return NULL;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != ASHIFT
          || GET_MODE (x12) != E_DImode)
        return NULL;
      x13 = XEXP (x12, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return NULL;
      x14 = XEXP (x11, 0);
      operands[7] = x14;
      if (!int_reg_operand (operands[7], E_DImode))
        return NULL;
      x15 = XEXP (x12, 0);
      operands[8] = x15;
      if (!int_reg_operand (operands[8], E_DImode))
        return NULL;
      x16 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x16) != SET)
        return NULL;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != UNSPEC
          || XVECLEN (x17, 0) != 1
          || XINT (x17, 1) != 62
          || GET_MODE (x17) != E_SFmode)
        return NULL;
      x18 = XEXP (x16, 0);
      operands[9] = x18;
      if (!vsx_register_operand (operands[9], E_SFmode))
        return NULL;
      x19 = XVECEXP (x17, 0, 0);
      if (!rtx_equal_p (x19, operands[7]))
        return NULL;
      switch (GET_CODE (x8))
        {
        case AND:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_39 (insn, operands);

        case IOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_40 (insn, operands);

        case XOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_41 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
