/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 2L)
        return -1;
      return 0;

    case 1L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern3 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != MEM
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern30 (x2); /* [-1, 1] */
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || pattern34 (x1, 
E_DImode, 
-1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != IF_THEN_ELSE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x6, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XEXP (x6, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XEXP (x1, 0);
  operands[0] = x11;
  if (!gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x12 = XEXP (x3, 0);
  operands[1] = x12;
  if (!cc_reg_operand (operands[1], i1))
    return -1;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  return pattern59 (x3); /* [-1, 23] */
}

int
pattern65 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || !small_toc_ref (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !small_toc_ref (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2DFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT
      || GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_DFmode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x4, 1);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_DFmode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!vfloat_operand (operands[0], E_V2DFmode)
      || pattern79 (x1) != 0)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern101 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern103 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XVECEXP (x4, 0, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[3] = x10;
  x11 = XEXP (x6, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern103 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern103 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern103 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!reg_or_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!scratch_operand (operands[0], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case E_HImode:
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_DImode:
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          res = pattern167 ();
          if (res >= 0)
            return res + 2; /* [2, 4] */
          return -1;

        default:
          return -1;
        }

    case SET:
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x10) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x10) != E_DImode)
            return -1;
          res = pattern167 ();
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern193 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern192 (x1, 
i1); /* [-1, 3] */
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern229 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern233 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[2] = x2;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern181 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern181 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern228 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern228 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern228 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern228 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern228 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern228 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern228 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern228 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern228 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern228 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern230 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern230 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern232 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern232 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern232 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern232 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern232 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern232 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern232 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern232 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern232 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern232 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern269 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern282 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  if (!gpc_reg_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != E_SImode
      || !gpc_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern299 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[1], E_IFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_SImode)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern329 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case EQ:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case NE:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern344 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !non_add_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern356 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_or_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vlogical_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern373 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern375 (x5, 
i1); /* [-1, 0] */
}

int
pattern387 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern385 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern385 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern386 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern386 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern386 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern386 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern386 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern386 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern386 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern386 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern386 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern386 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern402 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern400 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern400 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern401 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern401 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern401 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern401 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern401 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern401 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern401 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern401 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern401 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern401 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern422 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern422 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern423 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern423 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern423 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern423 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern423 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern423 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern423 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern423 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern423 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern423 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern443 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern455 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern466 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern473 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 3
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern479 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[4], i1)
      || !vsx_register_operand (operands[5], i1))
    return -1;
  return pattern478 (); /* [-1, 1] */
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode)
        return -1;
      return 1;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern505 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern512 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_reg_operand (operands[1], E_XOmode)
      || !vsx_register_operand (operands[2], E_OOmode)
      || !vsx_register_operand (operands[3], E_V16QImode)
      || !const_0_to_3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern518 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern529 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern534 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern541 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern548 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode)
          || !scratch_operand (operands[0], E_V1TImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode)
          || !scratch_operand (operands[0], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      switch (XINT (x3, 1))
        {
        case 150:
          if (GET_MODE (x3) != E_DFmode
              || !cc_reg_operand (operands[0], E_CCFPmode)
              || !vsx_register_operand (operands[1], E_DFmode)
              || !vsx_register_operand (operands[2], E_DFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode)
              || !
#line 5305 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1571; /* *xscmpexpdp */

        case 151:
          if (!cc_reg_operand (operands[0], E_CCFPmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !altivec_register_operand (operands[2], E_KFmode)
                  || !(
#line 5339 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1572; /* *xscmpexpqp */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !altivec_register_operand (operands[2], E_TFmode)
                  || !(
#line 5339 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1573; /* *xscmpexpqp */

            default:
              return -1;
            }

        case 152:
          x7 = XEXP (x2, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !u7bit_cint_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_SFmode:
              if (!vsx_register_operand (operands[1], E_SFmode)
                  || !
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (SFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1574; /* *xststdc_sf */

            case E_DFmode:
              if (!vsx_register_operand (operands[1], E_DFmode)
                  || !
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (DFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1575; /* *xststdc_df */

            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (KFmode) || TARGET_FLOAT128_HW)) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1576; /* *xststdc_kf */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (TFmode) || TARGET_FLOAT128_HW)) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1577; /* *xststdc_tf */

            default:
              return -1;
            }

        case 429:
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DDmode:
              if (!gpc_reg_operand (operands[2], E_DDmode)
                  || !
#line 368 "../../gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2312; /* *dfp_sgnfcnc_dd */

            case E_TDmode:
              if (!gpc_reg_operand (operands[2], E_TDmode)
                  || !
#line 368 "../../gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2313; /* *dfp_sgnfcnc_td */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      if (!const_0_to_1_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      if (!zero_constant (operands[4], E_V2DFmode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 342:
          switch (pattern537 ())
            {
            case 0:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2188; /* *bcdadd_test_v1ti */

            case 1:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2190; /* *bcdadd_test_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern537 ())
            {
            case 0:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2189; /* *bcdsub_test_v1ti */

            case 1:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2191; /* *bcdsub_test_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x3, 1) != 343
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!zero_constant (operands[2], E_V2DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1TImode:
          if (!register_operand (operands[1], E_V1TImode)
              || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2204; /* *bcdinvalid_v1ti */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2205; /* *bcdinvalid_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  res = recog_18 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  switch (GET_CODE (x2))
    {
    case IOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          return recog_21 (x1, insn, pnum_clobbers);

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x3;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern397 (x2, 
E_SImode) != 0
                  || !
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)))
                return -1;
              *pnum_clobbers = 1;
              return 259; /* *iorsi_mask */

            case E_DImode:
              if (pattern397 (x2, 
E_DImode) != 0
                  || !(
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 260; /* *iordi_mask */

            default:
              return -1;
            }

        case ASHIFT:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != ZERO_EXTEND
              || GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != UNSPEC
              || XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 87)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x6, 0, 0);
          operands[3] = x9;
          if (!memory_operand (operands[3], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_QImode:
              if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8))
                return -1;
              *pnum_clobbers = 1;
              return 261; /* *rotldi3_insert_sf */

            case E_HImode:
              if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16))
                return -1;
              *pnum_clobbers = 1;
              return 262; /* *rotldi3_insert_sf */

            case E_SImode:
              if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32))
                return -1;
              *pnum_clobbers = 1;
              return 263; /* *rotldi3_insert_sf */

            default:
              return -1;
            }

        case NOT:
          return recog_20 (x1, insn, pnum_clobbers);

        case IOR:
          switch (pattern60 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 1249 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2478; /* *fuse_nand_or */

            case 1:
              if (!(
#line 1249 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2479; /* *fuse_nand_or */

            case 2:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2978; /* *fuse_vnand_vor */

            case 3:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2979; /* *fuse_vnand_vor */

            case 4:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2980; /* *fuse_vnand_vor */

            case 5:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2981; /* *fuse_vnand_vor */

            case 6:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2982; /* *fuse_vnand_vor */

            case 7:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2983; /* *fuse_vnand_vor */

            case 8:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2984; /* *fuse_vnand_vor */

            case 9:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2985; /* *fuse_vnand_vor */

            case 10:
              if (!(
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2986; /* *fuse_vnand_vor */

            case 11:
              if (!(
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2987; /* *fuse_vnand_vor */

            case 12:
              if (!
#line 1429 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2498; /* *fuse_nand_orc */

            case 13:
              if (!(
#line 1429 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2499; /* *fuse_nand_orc */

            case 14:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3058; /* *fuse_vnand_vorc */

            case 15:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3059; /* *fuse_vnand_vorc */

            case 16:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3060; /* *fuse_vnand_vorc */

            case 17:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3061; /* *fuse_vnand_vorc */

            case 18:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3062; /* *fuse_vnand_vorc */

            case 19:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3063; /* *fuse_vnand_vorc */

            case 20:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3064; /* *fuse_vnand_vorc */

            case 21:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3065; /* *fuse_vnand_vorc */

            case 22:
              if (!(
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3066; /* *fuse_vnand_vorc */

            case 23:
              if (!(
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3067; /* *fuse_vnand_vorc */

            case 24:
              if (!
#line 1303 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2484; /* *fuse_orc_or */

            case 25:
              if (!(
#line 1303 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2485; /* *fuse_orc_or */

            case 26:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3008; /* *fuse_vorc_vor */

            case 27:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3009; /* *fuse_vorc_vor */

            case 28:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3010; /* *fuse_vorc_vor */

            case 29:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3011; /* *fuse_vorc_vor */

            case 30:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3012; /* *fuse_vorc_vor */

            case 31:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3013; /* *fuse_vorc_vor */

            case 32:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3014; /* *fuse_vorc_vor */

            case 33:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3015; /* *fuse_vorc_vor */

            case 34:
              if (!(
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3016; /* *fuse_vorc_vor */

            case 35:
              if (!(
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3017; /* *fuse_vorc_vor */

            case 36:
              if (!
#line 1483 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2504; /* *fuse_orc_orc */

            case 37:
              if (!(
#line 1483 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2505; /* *fuse_orc_orc */

            case 38:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3088; /* *fuse_vorc_vorc */

            case 39:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3089; /* *fuse_vorc_vorc */

            case 40:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3090; /* *fuse_vorc_vorc */

            case 41:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3091; /* *fuse_vorc_vorc */

            case 42:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3092; /* *fuse_vorc_vorc */

            case 43:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3093; /* *fuse_vorc_vorc */

            case 44:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3094; /* *fuse_vorc_vorc */

            case 45:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3095; /* *fuse_vorc_vorc */

            case 46:
              if (!(
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3096; /* *fuse_vorc_vorc */

            case 47:
              if (!(
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3097; /* *fuse_vorc_vorc */

            case 48:
              if (!
#line 1285 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2482; /* *fuse_or_or */

            case 49:
              if (!(
#line 1285 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2483; /* *fuse_or_or */

            case 50:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2998; /* *fuse_vor_vor */

            case 51:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2999; /* *fuse_vor_vor */

            case 52:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3000; /* *fuse_vor_vor */

            case 53:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3001; /* *fuse_vor_vor */

            case 54:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3002; /* *fuse_vor_vor */

            case 55:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3003; /* *fuse_vor_vor */

            case 56:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3004; /* *fuse_vor_vor */

            case 57:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3005; /* *fuse_vor_vor */

            case 58:
              if (!(
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3006; /* *fuse_vor_vor */

            case 59:
              if (!(
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3007; /* *fuse_vor_vor */

            case 60:
              if (!
#line 1465 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2502; /* *fuse_or_orc */

            case 61:
              if (!(
#line 1465 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2503; /* *fuse_or_orc */

            case 62:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3078; /* *fuse_vor_vorc */

            case 63:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3079; /* *fuse_vor_vorc */

            case 64:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3080; /* *fuse_vor_vorc */

            case 65:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3081; /* *fuse_vor_vorc */

            case 66:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3082; /* *fuse_vor_vorc */

            case 67:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3083; /* *fuse_vor_vorc */

            case 68:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3084; /* *fuse_vor_vorc */

            case 69:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3085; /* *fuse_vor_vorc */

            case 70:
              if (!(
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3086; /* *fuse_vor_vorc */

            case 71:
              if (!(
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3087; /* *fuse_vor_vorc */

            default:
              return -1;
            }

        case XOR:
          switch (pattern61 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 1321 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2486; /* *fuse_xor_or */

            case 1:
              if (!(
#line 1321 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2487; /* *fuse_xor_or */

            case 2:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3018; /* *fuse_vxor_vor */

            case 3:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3019; /* *fuse_vxor_vor */

            case 4:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3020; /* *fuse_vxor_vor */

            case 5:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3021; /* *fuse_vxor_vor */

            case 6:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3022; /* *fuse_vxor_vor */

            case 7:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3023; /* *fuse_vxor_vor */

            case 8:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3024; /* *fuse_vxor_vor */

            case 9:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3025; /* *fuse_vxor_vor */

            case 10:
              if (!(
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3026; /* *fuse_vxor_vor */

            case 11:
              if (!(
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3027; /* *fuse_vxor_vor */

            case 12:
              if (!
#line 1501 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2506; /* *fuse_xor_orc */

            case 13:
              if (!(
#line 1501 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2507; /* *fuse_xor_orc */

            case 14:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3098; /* *fuse_vxor_vorc */

            case 15:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3099; /* *fuse_vxor_vorc */

            case 16:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3100; /* *fuse_vxor_vorc */

            case 17:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3101; /* *fuse_vxor_vorc */

            case 18:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3102; /* *fuse_vxor_vorc */

            case 19:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3103; /* *fuse_vxor_vorc */

            case 20:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3104; /* *fuse_vxor_vorc */

            case 21:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3105; /* *fuse_vxor_vorc */

            case 22:
              if (!(
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3106; /* *fuse_vxor_vorc */

            case 23:
              if (!(
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3107; /* *fuse_vxor_vorc */

            default:
              return -1;
            }

        case PLUS:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern120 (x1))
            {
            case 0:
              if (!
#line 1339 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2488; /* *fuse_add_or */

            case 1:
              if (!(
#line 1339 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2489; /* *fuse_add_or */

            default:
              return -1;
            }

        case MINUS:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern120 (x1))
            {
            case 0:
              if (!
#line 1357 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2490; /* *fuse_subf_or */

            case 1:
              if (!(
#line 1357 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2491; /* *fuse_subf_or */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_22 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode)
      || !
#line 15834 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC && TARGET_64BIT))
    return -1;
  return 1105; /* *cmpeqb_internal */
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!u6bit_cint_operand (operands[1], E_QImode)
          || !altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !
#line 6455 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1629; /* vec_mtvsrbmi */

    case REG:
    case SUBREG:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!altivec_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1630; /* vec_mtvsr_v16qi */

        case E_V8HImode:
          if (!altivec_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1631; /* vec_mtvsr_v8hi */

        case E_V4SImode:
          if (!altivec_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1632; /* vec_mtvsr_v4si */

        case E_V2DImode:
          if (!altivec_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1633; /* vec_mtvsr_v2di */

        case E_V1TImode:
          if (!altivec_register_operand (operands[0], E_V1TImode)
              || GET_MODE (x2) != E_V1TImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1634; /* vec_mtvsr_v1ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern212 (x2))
    {
    case 0:
      if (!
#line 6830 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 470; /* ceilsf2 */

    case 1:
      if (!
#line 6830 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 471; /* ceildf2 */

    case 2:
      if (!(
#line 15457 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1071; /* ceilkf2 */

    case 3:
      if (!(
#line 15457 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1072; /* ceiltf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2347 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1311; /* vsx_ceilv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2573 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1992; /* altivec_vrfip */

    case 5:
      if (!
#line 2347 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1312; /* vsx_ceilv2df2 */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x2) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1085; /* sqrtkf2_odd */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1086; /* sqrttf2_odd */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_VECTOR:
      switch (pattern301 (x3))
        {
        case 0:
          if (!
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()))
            return -1;
          return 1690; /* sldoi_to_movv4si */

        case 1:
          if (!
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()))
            return -1;
          return 1691; /* sldoi_to_movv8hi */

        case 2:
          if (!
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()))
            return -1;
          return 1692; /* sldoi_to_movv16qi */

        case 3:
          if (!
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1693; /* sldoi_to_movv4sf */

        case 4:
          if (!
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1694; /* sldoi_to_movv2df */

        case 5:
          if (!
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()))
            return -1;
          return 1695; /* sldoi_to_movv2di */

        case 6:
          if (!
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()))
            return -1;
          return 1696; /* sldoi_to_movv1ti */

        case 7:
          if (!
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()))
            return -1;
          return 1697; /* sldoi_to_movti */

        case 8:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 1698; /* sldoi_to_movkf */

        case 9:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 1699; /* sldoi_to_movtf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!immediate_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern141 (x3, 
E_V4SImode) != 0
              || !
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2003; /* altivec_vsldoi_v4si */

        case E_V8HImode:
          if (pattern141 (x3, 
E_V8HImode) != 0
              || !
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2004; /* altivec_vsldoi_v8hi */

        case E_V16QImode:
          if (pattern141 (x3, 
E_V16QImode) != 0
              || !
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2005; /* altivec_vsldoi_v16qi */

        case E_V4SFmode:
          if (pattern141 (x3, 
E_V4SFmode) != 0
              || !
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2006; /* altivec_vsldoi_v4sf */

        case E_V2DFmode:
          if (pattern141 (x3, 
E_V2DFmode) != 0
              || !
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2007; /* altivec_vsldoi_v2df */

        case E_V2DImode:
          if (pattern141 (x3, 
E_V2DImode) != 0
              || !
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2008; /* altivec_vsldoi_v2di */

        case E_V1TImode:
          if (pattern141 (x3, 
E_V1TImode) != 0
              || !
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2009; /* altivec_vsldoi_v1ti */

        case E_TImode:
          if (pattern141 (x3, 
E_TImode) != 0
              || !
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2010; /* altivec_vsldoi_ti */

        case E_KFmode:
          if (pattern141 (x3, 
E_KFmode) != 0
              || !(
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2011; /* altivec_vsldoi_kf */

        case E_TFmode:
          if (pattern141 (x3, 
E_TFmode) != 0
              || !(
#line 2685 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2012; /* altivec_vsldoi_tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      res = recog_111 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case HIGH:
      res = recog_112 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && input_operand (operands[1], E_SImode)
          && 
#line 7743 "../../gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], SImode)
   || gpc_reg_operand (operands[1], SImode)))
        return 557; /* *movsi_internal1 */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && input_operand (operands[1], E_QImode)
          && 
#line 8116 "../../gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], QImode)
   || gpc_reg_operand (operands[1], QImode)))
        return 565; /* *movqi_internal */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && input_operand (operands[1], E_HImode)
          && 
#line 8116 "../../gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], HImode)
   || gpc_reg_operand (operands[1], HImode)))
        return 566; /* *movhi_internal */
      break;

    case E_CCmode:
      if (nonimmediate_operand (operands[0], E_CCmode)
          && general_operand (operands[1], E_CCmode)
          && 
#line 8165 "../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCmode)
   || register_operand (operands[1], CCmode)))
        return 567; /* *movcc_cc */
      break;

    case E_CCUNSmode:
      if (nonimmediate_operand (operands[0], E_CCUNSmode)
          && general_operand (operands[1], E_CCUNSmode)
          && 
#line 8165 "../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCUNSmode)
   || register_operand (operands[1], CCUNSmode)))
        return 568; /* *movcc_ccuns */
      break;

    case E_CCEQmode:
      if (nonimmediate_operand (operands[0], E_CCEQmode)
          && general_operand (operands[1], E_CCEQmode)
          && 
#line 8165 "../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCEQmode)
   || register_operand (operands[1], CCEQmode)))
        return 569; /* *movcc_cceq */
      break;

    case E_CCFPmode:
      if (nonimmediate_operand (operands[0], E_CCFPmode)
          && general_operand (operands[1], E_CCFPmode)
          && 
#line 8165 "../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCFPmode)
   || register_operand (operands[1], CCFPmode)))
        return 570; /* *movcc_ccfp */
      break;

    case E_V4SFmode:
      if (pnum_clobbers != NULL
          && memory_operand (operands[0], E_V4SFmode)
          && immediate_operand (operands[1], E_V4SFmode)
          && 
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])))
        {
          *pnum_clobbers = 1;
          return 1381; /* vsx_stxvd2x4_le_const_v4sf */
        }
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode)
          && 
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
        return 1683; /* *altivec_movv4sf */
      break;

    default:
      break;
    }
  operands[0] = x2;
  switch (pattern31 (x3, 
E_V4SFmode))
    {
    case 0:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2112; /* altivec_stvx_v4sf_2op_di */
      break;

    case 1:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2121; /* altivec_stvx_v4sf_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[3] = x9;
      if (!immediate_operand (operands[3], E_SImode)
          || !
#line 11219 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2))
        return -1;
      return 761; /* load_toc_v4_PIC_2 */

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -16]
          || !register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      x7 = XEXP (x4, 0);
      switch (pattern32 (x7))
        {
        case 0:
          if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 2085; /* altivec_lvx_v4sf_2op_di */

        case 1:
          if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 2094; /* altivec_lvx_v4sf_1op_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  if (XWINT (x4, 0) == 0L
      && vsx_register_operand (operands[0], E_V1TImode)
      && GET_MODE (x2) == E_V1TImode
      && memory_operand (operands[1], E_V1TImode)
      && 
#line 1402 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V1TImode) && !BYTES_BIG_ENDIAN))
    return 1214; /* vsx_ld_elemrev_v1ti */
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      if (const_0_to_1_operand (operands[2], E_QImode))
        {
          if (gpc_reg_operand (operands[0], E_DFmode)
              && gpc_reg_operand (operands[1], E_V2DFmode))
            {
              if (
#line 3573 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)))
                return 1385; /* *vsx_extract_v2df_0 */
              if (
#line 3594 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 0)))
                return 1387; /* *vsx_extract_v2df_1 */
            }
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_DFmode)
              && memory_operand (operands[1], E_V2DFmode)
              && (
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1389; /* *vsx_extract_di_v2df_load */
            }
        }
      if (!memory_operand (operands[0], E_DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !vsx_scalar_64bit (operands[2], E_QImode)
          || !
#line 3631 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)))
        return -1;
      return 1391; /* *vsx_extract_v2df_store */

    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      if (const_0_to_1_operand (operands[2], E_QImode))
        {
          if (gpc_reg_operand (operands[0], E_DImode)
              && gpc_reg_operand (operands[1], E_V2DImode))
            {
              if (
#line 3573 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)))
                return 1386; /* *vsx_extract_v2di_0 */
              if (
#line 3594 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 0)))
                return 1388; /* *vsx_extract_v2di_1 */
            }
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_V2DImode)
              && (
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1390; /* *vsx_extract_di_v2di_load */
            }
        }
      if (!memory_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !vsx_scalar_64bit (operands[2], E_QImode)
          || !
#line 3631 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)))
        return -1;
      return 1392; /* *vsx_extract_v2di_store */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SFmode)
        return -1;
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && u5bit_cint_operand (operands[2], E_QImode)
          && 
#line 3692 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        {
          *pnum_clobbers = 1;
          return 1399; /* vsx_extract_v4sf */
        }
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !const_0_to_3_operand (operands[2], E_QImode)
          || !(
#line 3725 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1400; /* *vsx_extract_v4sf_di_load */

    case E_SImode:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V4SImode))
        {
          if (const_0_to_3_operand (operands[2], E_QImode))
            {
              if (nonimmediate_operand (operands[0], E_SImode)
                  && 
#line 3932 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
                {
                  *pnum_clobbers = 1;
                  return 1405; /* vsx_extract_v4si_w1 */
                }
              if (gpc_reg_operand (operands[0], E_SImode)
                  && 
#line 3969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
                {
                  *pnum_clobbers = 1;
                  return 1409; /* vsx_extract_v4si_p9 */
                }
            }
          if (memory_operand (operands[0], E_SImode)
              && const_int_operand (operands[2], E_QImode)
              && 
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 2;
              return 1415; /* *vsx_extract_v4si_store_p9 */
            }
          if (nonimmediate_operand (operands[0], E_SImode)
              && const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4081 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 1;
              return 1416; /* *vsx_extract_v4si_w023 */
            }
        }
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_QImode)
          || !
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1421; /* *vsx_extract_v4si_load */

    case E_QImode:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_QImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V16QImode))
        {
          if (gpc_reg_operand (operands[0], E_QImode)
              && const_0_to_15_operand (operands[2], E_QImode)
              && 
#line 3969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 1;
              return 1407; /* vsx_extract_v16qi_p9 */
            }
          if (memory_operand (operands[0], E_QImode)
              && const_int_operand (operands[2], E_QImode)
              && 
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 2;
              return 1413; /* *vsx_extract_v16qi_store_p9 */
            }
          if (nonimmediate_operand (operands[0], E_QImode)
              && const_0_to_15_operand (operands[2], E_QImode)
              && 
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
            {
              *pnum_clobbers = 1;
              return 1417; /* *vsx_extract_v16qi_p8 */
            }
        }
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1419; /* *vsx_extract_v16qi_load */

    case E_HImode:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V8HImode))
        {
          if (gpc_reg_operand (operands[0], E_HImode)
              && const_0_to_7_operand (operands[2], E_QImode)
              && 
#line 3969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 1;
              return 1408; /* vsx_extract_v8hi_p9 */
            }
          if (memory_operand (operands[0], E_HImode)
              && const_int_operand (operands[2], E_QImode)
              && 
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 2;
              return 1414; /* *vsx_extract_v8hi_store_p9 */
            }
          if (nonimmediate_operand (operands[0], E_HImode)
              && const_0_to_7_operand (operands[2], E_QImode)
              && 
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
            {
              *pnum_clobbers = 1;
              return 1418; /* *vsx_extract_v8hi_p8 */
            }
        }
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_V8HImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1420; /* *vsx_extract_v8hi_load */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 391; /* floatsisf2_lfiwax */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 7037 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS))
                    return 491; /* floatdisf2_fcfids */
                  if (pnum_clobbers != NULL)
                    {
                      if (memory_operand (operands[1], E_DImode)
                          && 
#line 7048 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS))
                        {
                          *pnum_clobbers = 1;
                          return 492; /* *floatdisf2_mem */
                        }
                      if (gpc_reg_operand (operands[1], E_DImode)
                          && 
#line 7068 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS))
                        {
                          *pnum_clobbers = 1;
                          return 493; /* floatdisf2_internal1 */
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern315 (
E_SFmode))
            {
            case 0:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 406; /* *floatqisf2_internal */

            case 1:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 407; /* *floathisf2_internal */

            default:
              return -1;
            }

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 392; /* floatsidf2_lfiwax */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 6924 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT))
                    return 479; /* floatdidf2 */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 6975 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    {
                      *pnum_clobbers = 1;
                      return 488; /* *floatdidf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern315 (
E_DFmode))
            {
            case 0:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 408; /* *floatqidf2_internal */

            case 1:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 409; /* *floathidf2_internal */

            default:
              return -1;
            }

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_KFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6933 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 480; /* floattikf2 */
          if (!altivec_register_operand (operands[0], E_KFmode))
            return -1;
          switch (pattern316 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15319 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1053; /* float_kfdi2_hw */

            case 1:
              if (!(
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1055; /* float_kfsi2_hw */

            case 2:
              if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1057; /* floatqikf2 */

            case 3:
              if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1058; /* floathikf2 */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_TFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6933 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 481; /* floattitf2 */
          if (!altivec_register_operand (operands[0], E_TFmode))
            return -1;
          switch (pattern316 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15319 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1054; /* float_tfdi2_hw */

            case 1:
              if (!(
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1056; /* float_tfsi2_hw */

            case 2:
              if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1059; /* floatqitf2 */

            case 3:
              if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1060; /* floathitf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SFmode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && 
#line 2278 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1290; /* vsx_floatv4siv4sf2 */
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || !vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 2489 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1326; /* vsx_xvcvsxwsp */

        case E_V2DFmode:
          if (GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DFmode)
              && gpc_reg_operand (operands[1], E_V2DImode)
              && 
#line 2278 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1291; /* vsx_floatv2div2df2 */
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 2496 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1328; /* vsx_xvcvsxddp */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 217 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP && TARGET_POPCNTD))
            return -1;
          return 2295; /* floatdidd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2296; /* floatditd2 */

            case E_TImode:
              if (!gpc_reg_operand (operands[1], E_TImode)
                  || !
#line 232 "../../gcc/config/rs6000/dfp.md"
(TARGET_POWER10))
                return -1;
              return 2297; /* floattitd2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern62 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS))
            return -1;
          *pnum_clobbers = 1;
          return 393; /* floatsisf2_lfiwax_mem */

        case 1:
          if (!
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID))
            return -1;
          *pnum_clobbers = 1;
          return 394; /* floatsidf2_lfiwax_mem */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern317 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 395; /* floatsisf2_lfiwax_qi_mem_zext */

            case 1:
              if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 396; /* floatsisf2_lfiwax_hi_mem_zext */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern317 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 397; /* floatsidf2_lfiwax_qi_mem_zext */

            case 1:
              if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 398; /* floatsidf2_lfiwax_hi_mem_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FIX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (!
#line 6692 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND
   && flag_unsafe_math_optimizations && !flag_trapping_math && TARGET_FRIZ))
                return -1;
              return 457; /* *friz */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || !
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 2;
              return 459; /* *round32df2_fprs */

            default:
              return -1;
            }

        case E_SFmode:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || GET_MODE (x4) != E_SImode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 458; /* *round32sf2_fprs */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || GET_MODE (x4) != E_V2DImode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 3117 "../../gcc/config/rs6000/vsx.md"
(TARGET_HARD_FLOAT
   && VECTOR_UNIT_VSX_P (V2DFmode) && flag_unsafe_math_optimizations
   && !flag_trapping_math && TARGET_FRIZ))
            return -1;
          return 1348; /* *vsx_float_fix_v2df2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern64 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 2631 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1338; /* vsx_xvcvsxwdp_be */

        case 1:
          if (!
#line 2640 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1340; /* vsx_xvcvsxwdp_le */

        case 2:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 1;
              return 1460; /* *vsx_extract_si_float_df */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1479; /* *vsx_ext_SI_fl_df */

        case 3:
          if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1471; /* *vsx_ext_QI_fl_df */

        case 4:
          if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1475; /* *vsx_ext_HI_fl_df */

        case 5:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 2;
              return 1462; /* *vsx_extract_si_float_sf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1478; /* *vsx_ext_SI_fl_sf */

        case 6:
          if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1470; /* *vsx_ext_QI_fl_sf */

        case 7:
          if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1474; /* *vsx_ext_HI_fl_sf */

        case 8:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          *pnum_clobbers = 2;
          return 1464; /* *vsx_extract_si_float_if */

        case 9:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            {
              *pnum_clobbers = 2;
              return 1466; /* *vsx_extract_si_float_kf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1480; /* *vsx_ext_SI_fl_kf */

        case 10:
          if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1472; /* *vsx_ext_QI_fl_kf */

        case 11:
          if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1476; /* *vsx_ext_HI_fl_kf */

        case 12:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            {
              *pnum_clobbers = 2;
              return 1468; /* *vsx_extract_si_float_tf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1481; /* *vsx_ext_SI_fl_tf */

        case 13:
          if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1473; /* *vsx_ext_QI_fl_tf */

        case 14:
          if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1477; /* *vsx_ext_HI_fl_tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 5018 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 295; /* *abssf2_fpr */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 5018 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 296; /* *absdf2_fpr */

    case E_KFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_KFmode)
          && GET_MODE (x3) == E_KFmode
          && register_operand (operands[1], E_KFmode)
          && (
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        {
          *pnum_clobbers = 1;
          return 618; /* ieee_128bit_vsx_abskf2 */
        }
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15132 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1003; /* abskf2_hw */

    case E_TFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_TFmode)
          && GET_MODE (x3) == E_TFmode
          && register_operand (operands[1], E_TFmode)
          && (
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        {
          *pnum_clobbers = 1;
          return 619; /* ieee_128bit_vsx_abstf2 */
        }
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15132 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1004; /* abstf2_hw */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 1991 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1252; /* *vsx_absv4sf2 */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 1991 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1253; /* *vsx_absv2df2 */

    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_DDmode)
          || !
#line 94 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2277; /* absdd2 */

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 118 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2280; /* abstd2 */

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern329 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3132 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1349; /* vsx_concat_v2df */

            case E_V2DImode:
              if (pattern329 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3132 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1350; /* vsx_concat_v2di */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern467 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3181 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1353; /* *vsx_concat_v2df_2 */

            case E_V2DImode:
              if (pattern467 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3181 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1354; /* *vsx_concat_v2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x11 = XVECEXP (x9, 0, 0);
      operands[2] = x11;
      if (!const_0_to_1_operand (operands[2], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern468 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3158 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1351; /* *vsx_concat_v2df_1 */

            case E_V2DImode:
              if (pattern468 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3158 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1352; /* *vsx_concat_v2di_1 */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[3] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[4] = x8;
          if (!const_0_to_1_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern534 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3206 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1355; /* *vsx_concat_v2df_3 */

            case E_V2DImode:
              if (pattern534 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3206 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1356; /* *vsx_concat_v2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET
      || pattern289 (x1, 
E_DImode) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  switch (GET_CODE (x6))
    {
    case LTU:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS
          || GET_MODE (x7) != E_DImode
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      x9 = XEXP (x7, 1);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XEXP (x6, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      return 75; /* adddi3_carry */

    case GEU:
      if (!short_cint_operand (operands[2], E_DImode))
        return -1;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[1])
          || !(
#line 2010 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 76; /* *adddi3_imm_carry_pos */

    case GTU:
      if (!short_cint_operand (operands[2], E_DImode))
        return -1;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[1])
          || !(
#line 2042 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) < 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == -1) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 79; /* *adddi3_imm_carry_neg */

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 77; /* *adddi3_imm_carry_0 */

    case MEM:
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x5, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x8))
            {
            case E_SImode:
              if (pattern545 (x5, 
E_SImode) != 0
                  || !(
#line 10257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 692; /* movdi_si_update */

            case E_DImode:
              if (pattern545 (x5, 
E_DImode) != 0)
                return -1;
              if ((
#line 10257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 693; /* movdi_di_update */
              return 694; /* movdi_update_stack */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern539 (x1, 
E_SImode))
            {
            case 0:
              if (!(
#line 10321 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 699; /* movsi_si_update */

            case 1:
              if (!(
#line 10321 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 700; /* movsi_di_update */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern539 (x1, 
E_HImode))
            {
            case 0:
              if (!(
#line 10406 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 711; /* *movhi_update4 */

            case 1:
              if (!(
#line 10406 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 712; /* *movhi_update4 */

            default:
              return -1;
            }

        case E_QImode:
          switch (pattern539 (x1, 
E_QImode))
            {
            case 0:
              if (!(
#line 10455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 719; /* *movqi_update3 */

            case 1:
              if (!(
#line 10455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 720; /* *movqi_update3 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern539 (x1, 
E_SFmode))
            {
            case 0:
              if ((
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 725; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 731; /* *movsf_update4 */

            case 1:
              if ((
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 726; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 732; /* *movsf_update4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern539 (x1, 
E_DFmode))
            {
            case 0:
              if (!(
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 727; /* *movdf_update2 */

            case 1:
              if (!(
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 728; /* *movdf_update2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern289 (x1, 
E_DImode) != 0)
        return -1;
      return 106; /* *subfdi3_imm_carry_m1 */

    case XOR:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x7 = XEXP (x2, 0);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          x11 = XEXP (x10, 0);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              switch (pattern424 (x3))
                {
                case 0:
                  if (!
#line 691 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2416; /* *fuse_and_eqv */

                case 1:
                  if (!(
#line 691 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2417; /* *fuse_and_eqv */

                case 2:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2708; /* *fuse_vand_veqv */

                case 3:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2709; /* *fuse_vand_veqv */

                case 4:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2710; /* *fuse_vand_veqv */

                case 5:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2711; /* *fuse_vand_veqv */

                case 6:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2712; /* *fuse_vand_veqv */

                case 7:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2713; /* *fuse_vand_veqv */

                case 8:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2714; /* *fuse_vand_veqv */

                case 9:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2715; /* *fuse_vand_veqv */

                case 10:
                  if (!(
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 2716; /* *fuse_vand_veqv */

                case 11:
                  if (!(
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 2717; /* *fuse_vand_veqv */

                default:
                  return -1;
                }

            case NOT:
              x12 = XEXP (x11, 0);
              operands[0] = x12;
              x13 = XEXP (x10, 1);
              switch (GET_CODE (x13))
                {
                case REG:
                case SUBREG:
                  switch (pattern498 (x3))
                    {
                    case 0:
                      if (!
#line 709 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2418; /* *fuse_andc_eqv */

                    case 1:
                      if (!(
#line 709 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2419; /* *fuse_andc_eqv */

                    case 2:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2718; /* *fuse_vandc_veqv */

                    case 3:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2719; /* *fuse_vandc_veqv */

                    case 4:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2720; /* *fuse_vandc_veqv */

                    case 5:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2721; /* *fuse_vandc_veqv */

                    case 6:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2722; /* *fuse_vandc_veqv */

                    case 7:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2723; /* *fuse_vandc_veqv */

                    case 8:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2724; /* *fuse_vandc_veqv */

                    case 9:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2725; /* *fuse_vandc_veqv */

                    case 10:
                      if (!(
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2726; /* *fuse_vandc_veqv */

                    case 11:
                      if (!(
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2727; /* *fuse_vandc_veqv */

                    default:
                      return -1;
                    }

                case NOT:
                  switch (pattern501 (x3))
                    {
                    case 0:
                      if (!
#line 763 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2424; /* *fuse_nor_eqv */

                    case 1:
                      if (!(
#line 763 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2425; /* *fuse_nor_eqv */

                    case 2:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2748; /* *fuse_vnor_veqv */

                    case 3:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2749; /* *fuse_vnor_veqv */

                    case 4:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2750; /* *fuse_vnor_veqv */

                    case 5:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2751; /* *fuse_vnor_veqv */

                    case 6:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2752; /* *fuse_vnor_veqv */

                    case 7:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2753; /* *fuse_vnor_veqv */

                    case 8:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2754; /* *fuse_vnor_veqv */

                    case 9:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2755; /* *fuse_vnor_veqv */

                    case 10:
                      if (!(
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2756; /* *fuse_vnor_veqv */

                    case 11:
                      if (!(
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2757; /* *fuse_vnor_veqv */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != XOR)
            return -1;
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          x14 = XEXP (x11, 1);
          operands[1] = x14;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern519 (x3, 
E_SImode) != 0
                  || !
#line 727 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2420; /* *fuse_eqv_eqv */

            case E_DImode:
              if (pattern519 (x3, 
E_DImode) != 0
                  || !(
#line 727 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2421; /* *fuse_eqv_eqv */

            case E_V4SImode:
              if (pattern520 (x3, 
E_V4SImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2728; /* *fuse_veqv_veqv */

            case E_V8HImode:
              if (pattern520 (x3, 
E_V8HImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2729; /* *fuse_veqv_veqv */

            case E_V16QImode:
              if (pattern520 (x3, 
E_V16QImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2730; /* *fuse_veqv_veqv */

            case E_V4SFmode:
              if (pattern520 (x3, 
E_V4SFmode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2731; /* *fuse_veqv_veqv */

            case E_V2DFmode:
              if (pattern520 (x3, 
E_V2DFmode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2732; /* *fuse_veqv_veqv */

            case E_V2DImode:
              if (pattern520 (x3, 
E_V2DImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2733; /* *fuse_veqv_veqv */

            case E_V1TImode:
              if (pattern520 (x3, 
E_V1TImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2734; /* *fuse_veqv_veqv */

            case E_TImode:
              if (pattern520 (x3, 
E_TImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2735; /* *fuse_veqv_veqv */

            case E_KFmode:
              if (pattern520 (x3, 
E_KFmode) != 0
                  || !(
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2736; /* *fuse_veqv_veqv */

            case E_TFmode:
              if (pattern520 (x3, 
E_TFmode) != 0
                  || !(
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2737; /* *fuse_veqv_veqv */

            default:
              return -1;
            }

        case IOR:
          x11 = XEXP (x10, 0);
          switch (GET_CODE (x11))
            {
            case NOT:
              x12 = XEXP (x11, 0);
              operands[0] = x12;
              x13 = XEXP (x10, 1);
              switch (GET_CODE (x13))
                {
                case NOT:
                  switch (pattern501 (x3))
                    {
                    case 0:
                      if (!
#line 745 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2422; /* *fuse_nand_eqv */

                    case 1:
                      if (!(
#line 745 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2423; /* *fuse_nand_eqv */

                    case 2:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2738; /* *fuse_vnand_veqv */

                    case 3:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2739; /* *fuse_vnand_veqv */

                    case 4:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2740; /* *fuse_vnand_veqv */

                    case 5:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2741; /* *fuse_vnand_veqv */

                    case 6:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2742; /* *fuse_vnand_veqv */

                    case 7:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2743; /* *fuse_vnand_veqv */

                    case 8:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2744; /* *fuse_vnand_veqv */

                    case 9:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2745; /* *fuse_vnand_veqv */

                    case 10:
                      if (!(
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2746; /* *fuse_vnand_veqv */

                    case 11:
                      if (!(
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2747; /* *fuse_vnand_veqv */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (pattern498 (x3))
                    {
                    case 0:
                      if (!
#line 799 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2428; /* *fuse_orc_eqv */

                    case 1:
                      if (!(
#line 799 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2429; /* *fuse_orc_eqv */

                    case 2:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2768; /* *fuse_vorc_veqv */

                    case 3:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2769; /* *fuse_vorc_veqv */

                    case 4:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2770; /* *fuse_vorc_veqv */

                    case 5:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2771; /* *fuse_vorc_veqv */

                    case 6:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2772; /* *fuse_vorc_veqv */

                    case 7:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2773; /* *fuse_vorc_veqv */

                    case 8:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2774; /* *fuse_vorc_veqv */

                    case 9:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2775; /* *fuse_vorc_veqv */

                    case 10:
                      if (!(
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2776; /* *fuse_vorc_veqv */

                    case 11:
                      if (!(
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2777; /* *fuse_vorc_veqv */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern424 (x3))
                {
                case 0:
                  if (!
#line 781 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2426; /* *fuse_or_eqv */

                case 1:
                  if (!(
#line 781 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2427; /* *fuse_or_eqv */

                case 2:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2758; /* *fuse_vor_veqv */

                case 3:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2759; /* *fuse_vor_veqv */

                case 4:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2760; /* *fuse_vor_veqv */

                case 5:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2761; /* *fuse_vor_veqv */

                case 6:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2762; /* *fuse_vor_veqv */

                case 7:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2763; /* *fuse_vor_veqv */

                case 8:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2764; /* *fuse_vor_veqv */

                case 9:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2765; /* *fuse_vor_veqv */

                case 10:
                  if (!(
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 2766; /* *fuse_vor_veqv */

                case 11:
                  if (!(
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 2767; /* *fuse_vor_veqv */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case XOR:
          switch (pattern424 (x3))
            {
            case 0:
              if (!
#line 817 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2430; /* *fuse_xor_eqv */

            case 1:
              if (!(
#line 817 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2431; /* *fuse_xor_eqv */

            case 2:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2778; /* *fuse_vxor_veqv */

            case 3:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2779; /* *fuse_vxor_veqv */

            case 4:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2780; /* *fuse_vxor_veqv */

            case 5:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2781; /* *fuse_vxor_veqv */

            case 6:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2782; /* *fuse_vxor_veqv */

            case 7:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2783; /* *fuse_vxor_veqv */

            case 8:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2784; /* *fuse_vxor_veqv */

            case 9:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2785; /* *fuse_vxor_veqv */

            case 10:
              if (!(
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2786; /* *fuse_vxor_veqv */

            case 11:
              if (!(
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2787; /* *fuse_vxor_veqv */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      return recog_162 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_167 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_169 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_172 (x1, insn, pnum_clobbers);

    case NEG:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case SET:
              if (pattern335 (x1, 
EQ) != 0)
                return -1;
              return 105; /* *subfdi3_imm_carry_0 */

            case CLOBBER:
              switch (pattern294 (x1))
                {
                case 0:
                  if (!(
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return -1;
                  return 614; /* ieee_128bit_vsx_negkf2 */

                case 1:
                  if (!(
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return -1;
                  return 615; /* ieee_128bit_vsx_negtf2 */

                default:
                  return -1;
                }

            case USE:
              switch (pattern295 (x1))
                {
                case 0:
                  if (!(
#line 9318 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return -1;
                  return 616; /* *ieee_128bit_vsx_negkf2_internal */

                case 1:
                  if (!(
#line 9318 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return -1;
                  return 617; /* *ieee_128bit_vsx_negtf2_internal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ABS:
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case CLOBBER:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              if (!scratch_operand (operands[2], E_V16QImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_KFmode:
                  if (pattern452 (x3, 
E_KFmode) != 0
                      || !(
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return -1;
                  return 622; /* *ieee_128bit_vsx_nabskf2 */

                case E_TFmode:
                  if (pattern452 (x3, 
E_TFmode) != 0
                      || !(
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return -1;
                  return 623; /* *ieee_128bit_vsx_nabstf2 */

                default:
                  return -1;
                }

            case USE:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_V16QImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_KFmode:
                  if (pattern452 (x3, 
E_KFmode) != 0
                      || !(
#line 9378 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return -1;
                  return 624; /* *ieee_128bit_vsx_nabskf2_internal */

                case E_TFmode:
                  if (pattern452 (x3, 
E_TFmode) != 0
                      || !(
#line 9378 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return -1;
                  return 625; /* *ieee_128bit_vsx_nabstf2_internal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_166 (x1, insn, pnum_clobbers);

    case BSWAP:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!gpc_reg_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 146; /* bswaphi2_reg */

        case E_DImode:
          if (!reg_or_mem_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !reg_or_mem_operand (operands[1], E_DImode)
              || !
#line 2978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && (REG_P (operands[0]) || REG_P (operands[1]))))
            return -1;
          return 153; /* bswapdi2_32bit */

        default:
          return -1;
        }

    case DIV:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 98)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern453 (x1, 
E_SImode) != 0)
            return -1;
          return 181; /* divsi3_sra */

        case E_DImode:
          if (pattern453 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 182; /* divdi3_sra */

        default:
          return -1;
        }

    case AND:
      return recog_164 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_163 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          if (!reg_or_cint_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 98)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern503 (x1, 
E_SImode) != 0)
                return -1;
              return 288; /* ashrsi3 */

            case E_DImode:
              if (pattern503 (x1, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 289; /* ashrdi3 */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case VEC_DUPLICATE:
          switch (pattern84 (x1))
            {
            case 0:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
                return -1;
              return 1938; /* *altivec_v4si_ashiftrt_const */

            case 1:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
                return -1;
              return 1941; /* *altivec_v2di_ashiftrt_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ASHIFTRT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || pattern289 (x1, 
E_SImode) != 0)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x5, 1);
          operands[2] = x10;
          if (!reg_or_cint_operand (operands[2], E_SImode)
              || !
#line 4906 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 290; /* *ashrsi3_64 */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case SYMBOL_REF:
          if (GET_CODE (x5) == MEM)
            {
              res = recog_158 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x5;
          if (!input_operand (operands[1], E_DImode)
              || pattern259 (x1, 
E_TImode, 
E_DImode, 
98) != 0
              || !
#line 5133 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && TARGET_POWER10))
            return -1;
          return 1548; /* extendditi2 */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 3
              || XINT (x5, 1) != 444)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          switch (pattern390 (x1))
            {
            case 0:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  if (!d_form_memory (operands[1], E_SImode)
                      || !(
#line 170 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3199; /* *pcrel_opt_ldsi_di_gpr */

                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !(
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3203; /* *pcrel_opt_ldhi_di_gpr */

                default:
                  return -1;
                }

            case 1:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x5) != E_HImode
                  || !d_form_memory (operands[1], E_HImode)
                  || !
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3201; /* *pcrel_opt_ldhi_si_gpr */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_178 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_173 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_177 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_176 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_175 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_170 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_171 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_DFmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          switch (pattern342 (x1))
            {
            case 0:
              if (!(
#line 8912 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 600; /* extenddfif2_fprs */

            case 1:
              if (!(
#line 8912 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return -1;
              return 601; /* extenddftf2_fprs */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 3
              || XINT (x5, 1) != 444
              || GET_MODE (x5) != E_SFmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || !vsx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          x11 = XVECEXP (x5, 0, 0);
          operands[1] = x11;
          if (!d_form_memory (operands[1], E_SFmode))
            return -1;
          x12 = XVECEXP (x5, 0, 1);
          operands[2] = x12;
          if (!vsx_register_operand (operands[2], E_DImode))
            return -1;
          x13 = XVECEXP (x5, 0, 2);
          operands[3] = x13;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[4] = x8;
          if (!base_reg_operand (operands[4], E_DImode)
              || !
#line 241 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3210; /* *pcrel_opt_ldsf_df */

        default:
          return -1;
        }

    case ABS:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          switch (pattern294 (x1))
            {
            case 0:
              if (!(
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 618; /* ieee_128bit_vsx_abskf2 */

            case 1:
              if (!(
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 619; /* ieee_128bit_vsx_abstf2 */

            default:
              return -1;
            }

        case USE:
          switch (pattern295 (x1))
            {
            case 0:
              if (!(
#line 9346 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 620; /* *ieee_128bit_vsx_abskf2_internal */

            case 1:
              if (!(
#line 9346 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 621; /* *ieee_128bit_vsx_abstf2_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          if (REGNO (x4) != 96
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 2)
            return -1;
          operands[0] = x3;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x14 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x14, operands[0])
              || !
#line 11151 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_LINK_STACK && TARGET_ELF && DEFAULT_ABI == ABI_V4
   && (flag_pic == 2 || (flag_pic && TARGET_SECURE_PLT))))
            return -1;
          return 759; /* load_toc_v4_PIC_1_normal */

        case SUBREG:
        case MEM:
          operands[0] = x4;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          operands[1] = x3;
          x8 = XEXP (x6, 0);
          switch (pattern298 (x8))
            {
            case 0:
              if (!
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])))
                return -1;
              return 1381; /* vsx_stxvd2x4_le_const_v4sf */

            case 1:
              if (!
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SImode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SImode)
   && const_vec_duplicate_p (operands[1])))
                return -1;
              return 1382; /* vsx_stxvd2x4_le_const_v4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM)
        return -1;
      if (pnum_clobbers != NULL)
        {
          switch (pattern189 (x1))
            {
            case 0:
              if (current_file_function_operand (operands[1], E_DImode)
                  && (
#line 11512 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 776; /* *call_value_localdi */
                }
              if (symbol_ref_operand (operands[1], E_DImode)
                  && unspec_tls (operands[2], E_DImode))
                {
                  if ((
#line 11637 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 781; /* *call_value_nonlocal_sysvdi */
                    }
                  if ((
#line 11705 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 784; /* *call_value_nonlocal_aixdi */
                    }
                }
              break;

            case 1:
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (indirect_call_operand (operands[1], E_DImode)
                      && unspec_tls (operands[2], E_DImode))
                    {
                      if ((
#line 11609 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 780; /* *call_value_indirect_nonlocal_sysvdi */
                        }
                      if ((
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 792; /* *call_value_indirect_pcreldi */
                        }
                    }
                  break;

                case E_SImode:
                  if (indirect_call_operand (operands[1], E_SImode)
                      && unspec_tls (operands[2], E_SImode)
                      && (
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 791; /* *call_value_indirect_pcrelsi */
                    }
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SIMPLE_RETURN)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!call_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!(
#line 12080 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 800; /* *sibcall_value_aixdi */

    case COPYSIGN:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_KFmode:
          if (pattern425 (x3, 
E_KFmode) != 0
              || !(
#line 15113 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 999; /* copysignkf3_soft */

        case E_TFmode:
          if (pattern425 (x3, 
E_TFmode) != 0
              || !(
#line 15113 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1000; /* copysigntf3_soft */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!vsx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (pattern429 ())
            {
            case 0:
              if (!(
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1023; /* trunckfsf2_hw */

            case 1:
              if (!(
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1024; /* trunctfsf2_hw */

            default:
              return -1;
            }

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !scratch_operand (operands[2], E_TDmode)
              || !
#line 154 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2283; /* trunctddd2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_168 (x1, insn, pnum_clobbers);

    case SMIN:
      if (pattern80 (x1) != 0
          || !
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1527; /* vsx_reduc_smin_v2df */

    case SMAX:
      if (pattern80 (x1) != 0
          || !
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1528; /* vsx_reduc_smax_v2df */

    case US_PLUS:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 537 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1712; /* altivec_vadduws */

        case 1:
          if (!
#line 537 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1713; /* altivec_vadduhs */

        case 2:
          if (!
#line 537 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1714; /* altivec_vaddubs */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 546 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1715; /* altivec_vaddsws */

        case 1:
          if (!
#line 546 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1716; /* altivec_vaddshs */

        case 2:
          if (!
#line 546 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1717; /* altivec_vaddsbs */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 581 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1724; /* altivec_vsubuws */

        case 1:
          if (!
#line 581 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1725; /* altivec_vsubuhs */

        case 2:
          if (!
#line 581 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1726; /* altivec_vsububs */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 590 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1727; /* altivec_vsubsws */

        case 1:
          if (!
#line 590 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1728; /* altivec_vsubshs */

        case 2:
          if (!
#line 590 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1729; /* altivec_vsubsbs */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern85 (x1))
        {
        case 0:
          if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
            return -1;
          return 1937; /* *altivec_v4si_ashift_const */

        case 1:
          if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
            return -1;
          return 1940; /* *altivec_v2di_ashift_const */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern85 (x1))
        {
        case 0:
          if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
            return -1;
          return 1939; /* *altivec_v4si_lshiftrt_const */

        case 1:
          if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
            return -1;
          return 1942; /* *altivec_v2di_lshiftrt_const */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      return recog_174 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_165 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (XINT (x2, 1))
        {
        case 85:
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (gpc_reg_operand (operands[1], E_KFmode)
                  && ((
#line 5356 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 5360 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[1], KFmode))))
                return gen_split_153 (insn, operands);
              if (!memory_operand (operands[1], E_KFmode)
                  || !((
#line 5375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 5377 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_155 (insn, operands);

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode)
                  && ((
#line 5356 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 5360 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[1], TFmode))))
                return gen_split_154 (insn, operands);
              if (!memory_operand (operands[1], E_TFmode)
                  || !((
#line 5375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 5377 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_156 (insn, operands);

            default:
              return NULL;
            }

        case 15:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !((
#line 10622 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10624 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
            return NULL;
          return gen_split_392 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      operands[2] = x4;
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[0], E_SImode)
              || !got_no_const_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !
#line 7707 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
    && flag_pic == 1
    && reload_completed))
            return NULL;
          return gen_split_290 (insn, operands);

        case 14:
          if (GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || !rs6000_tls_symbol_ref (operands[1], E_DImode)
              || !gpc_reg_operand (operands[2], E_DImode)
              || !((
#line 10575 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10577 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
            return NULL;
          return gen_split_391 (insn, operands);

        case 23:
          if (pattern345 (x2) != 0
              || !((
#line 10688 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10690 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
            return NULL;
          return gen_split_393 (insn, operands);

        case 27:
          if (pattern345 (x2) != 0
              || !((
#line 10768 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10770 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
            return NULL;
          return gen_split_394 (insn, operands);

        case 70:
          if (GET_MODE (x2) != E_DFmode
              || !nonimmediate_operand (operands[0], E_DFmode))
            return NULL;
          switch (pattern412 ())
            {
            case 0:
              if (((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14883 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_478 (insn, operands);
              if (!((
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14906 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_481 (insn, operands);

            case 1:
              if (((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14883 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_479 (insn, operands);
              if (!((
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14906 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_482 (insn, operands);

            default:
              return NULL;
            }

        case 71:
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern146 (x2, 
E_DFmode, 
E_TFmode) != 0)
                return NULL;
              if (((
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14942 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_484 (insn, operands);
              if (!((
#line 14964 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14966 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_487 (insn, operands);

            case E_IFmode:
              if (pattern146 (x2, 
E_DFmode, 
E_IFmode) != 0
                  || !((
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14942 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_485 (insn, operands);

            case E_TDmode:
              if (pattern146 (x2, 
E_DImode, 
E_TDmode) != 0
                  || !((
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14942 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_486 (insn, operands);

            default:
              return NULL;
            }

        case 138:
          if (pattern346 (x2) != 0
              || !
#line 1730 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_585 (insn, operands);

        case 130:
          if (pattern346 (x2) != 0
              || !
#line 1785 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_586 (insn, operands);

        case 131:
          if (pattern346 (x2) != 0
              || !
#line 1832 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_587 (insn, operands);

        case 361:
          if (GET_MODE (x2) != E_OOmode
              || !vsx_register_operand (operands[0], E_OOmode)
              || !mma_assemble_input_operand (operands[1], E_V16QImode)
              || !mma_assemble_input_operand (operands[2], E_V16QImode)
              || !(
#line 382 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA) && 
#line 384 "../../gcc/config/rs6000/mma.md"
( reload_completed)))
            return NULL;
          return gen_split_722 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      if (XINT (x2, 1) != 263)
        return NULL;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (pattern301 (x2))
        {
        case 0:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_704 (insn, operands);

        case 1:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_705 (insn, operands);

        case 2:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_706 (insn, operands);

        case 3:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_707 (insn, operands);

        case 4:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_708 (insn, operands);

        case 5:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_709 (insn, operands);

        case 6:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_710 (insn, operands);

        case 7:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_711 (insn, operands);

        case 8:
          if (!((
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_712 (insn, operands);

        case 9:
          if (!((
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_713 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
