/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT
      || !vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  return pattern6 (x3, 
E_V4SFmode); /* [-1, 1] */
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != COMPARE
      || GET_MODE (x3) != E_CCFPmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x2, 0);
  operands[0] = x13;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x14 = XEXP (x3, 0);
  operands[1] = x14;
  x15 = XEXP (x3, 1);
  operands[2] = x15;
  x16 = XEXP (x4, 0);
  operands[3] = x16;
  if (!scratch_operand (operands[3], E_DFmode))
    return -1;
  x17 = XEXP (x5, 0);
  operands[4] = x17;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  x18 = XEXP (x6, 0);
  operands[5] = x18;
  if (!scratch_operand (operands[5], E_DFmode))
    return -1;
  x19 = XEXP (x7, 0);
  operands[6] = x19;
  if (!scratch_operand (operands[6], E_DFmode))
    return -1;
  x20 = XEXP (x8, 0);
  operands[7] = x20;
  if (!scratch_operand (operands[7], E_DFmode))
    return -1;
  x21 = XEXP (x9, 0);
  operands[8] = x21;
  if (!scratch_operand (operands[8], E_DFmode))
    return -1;
  x22 = XEXP (x10, 0);
  operands[9] = x22;
  if (!scratch_operand (operands[9], E_DFmode))
    return -1;
  x23 = XEXP (x11, 0);
  operands[10] = x23;
  if (!scratch_operand (operands[10], E_DFmode))
    return -1;
  x24 = XEXP (x12, 0);
  operands[11] = x24;
  switch (GET_MODE (operands[1]))
    {
    case E_IFmode:
      return pattern17 (
E_IFmode); /* [-1, 1] */

    case E_TFmode:
      res = pattern17 (
E_TFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern37 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern37 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern55 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern55 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern55 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern55 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern55 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern55 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern55 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern55 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern55 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern55 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 0;

    case E_QImode:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      return 1;

    case E_HImode:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern84 (x1); /* [-1, 1] */
}

int
pattern90 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case FIX:
      return pattern96 (x1); /* [-1, 1] */

    case VEC_SELECT:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 102
      || GET_MODE (x4) != E_V4SFmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!vfloat_operand (operands[0], E_V4SFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!vfloat_operand (operands[1], E_V4SFmode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  if (!scratch_operand (operands[2], E_V4SFmode))
    return -1;
  x11 = XEXP (x7, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern116 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern123 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern122 (x1, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern122 (x1, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern131 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern131 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!altivec_register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern141 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      if (GET_MODE (x5) != E_V2DFmode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 1L
          || !vfloat_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!vfloat_operand (operands[1], E_V2DFmode))
        return -1;
      x13 = XEXP (x9, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x4, 1);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 102
          || GET_MODE (x5) != E_V4SFmode)
        return -1;
      x15 = XVECEXP (x5, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 3L
          || !vfloat_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x4) != E_V4SFmode)
        return -1;
      x14 = XEXP (x4, 1);
      operands[1] = x14;
      if (!vfloat_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern196 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!altivec_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_V4SFmode:
      if (GET_MODE (x1) != E_V4SFmode)
        return -1;
      return 4;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  return pattern233 (x1); /* [-1, 23] */
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern229 (x4, 
i1); /* [-1, 0] */
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          return pattern243 (x6); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern239 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern234 (x6);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern255 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern256 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern256 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern261 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern261 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern262 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern262 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern262 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern262 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern262 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern262 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern262 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern262 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern262 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern262 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern266 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern266 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern287 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 98)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  return 0;
}

int
pattern296 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern305 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern316 (int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!altivec_register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_QImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 2;

    case E_HImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern331 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern339 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return pattern338 (x7); /* [-1, 1] */
}

int
pattern347 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern355 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vlogical_operand (operands[1], i1)
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern380 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern378 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern378 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern379 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern379 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern379 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern379 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern379 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern379 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern379 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern379 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern379 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern379 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern395 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern394 (x1) != 0)
    return -1;
  return 0;
}

int
pattern407 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern413 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern419 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != MULT
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || GET_MODE (x4) != E_SImode)
    return -1;
  x11 = XEXP (x5, 0);
  if (!gpc_reg_operand (x11, E_SImode))
    return -1;
  x12 = XEXP (x4, 1);
  if (GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x7, 0);
  operands[0] = x13;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x8, 1);
  if (GET_MODE (x14) != E_SImode)
    return -1;
  return 0;
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern442 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1)
      || !const_0_to_3_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern450 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern450 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern462 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !reg_or_zero_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[4], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[4], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern469 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  operands[3] = x1;
  if (!gpc_reg_operand (operands[0], E_SFmode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case ASHIFTRT:
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case LSHIFTRT:
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern482 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern490 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      return 0;

    case E_V2DFmode:
      return 1;

    case E_V4SImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V16QImode:
      return 4;

    case E_V2DImode:
      return 5;

    case E_V1TImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern511 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_reg_operand (operands[1], E_XOmode)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !vsx_register_operand (operands[3], E_V16QImode)
      || !const_0_to_15_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern514 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern522 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern532 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern540 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[5], i1)
      || !const_int_operand (operands[6], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern552 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern561 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x5, 0);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  x15 = XEXP (x6, 0);
  operands[2] = x15;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x16 = XEXP (x10, 0);
  x17 = XEXP (x16, 0);
  if (!rtx_equal_p (x17, operands[1]))
    return -1;
  x18 = XEXP (x11, 0);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern462 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 346; /* *isel_reversed_cc_si */

        case 1:
          if (!
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 348; /* *isel_reversed_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern462 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 347; /* *isel_reversed_cc_di */

        case 1:
          if (!(
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 349; /* *isel_reversed_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  operands[4] = x6;
  x7 = XEXP (x3, 2);
  operands[5] = x7;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern479 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 370; /* *movsfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 372; /* *movsfdfcc_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern479 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 371; /* *movdfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 373; /* *movdfdfcc_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern480 (x3, 
E_KFmode) != 0
              || !(
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 382; /* *movkfcc_p10 */

        case E_TFmode:
          if (pattern480 (x3, 
E_TFmode) != 0
              || !(
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 383; /* *movtfcc_p10 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      if (!all_ones_constant (operands[4], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !zero_constant (operands[5], E_V2DImode))
        return -1;
      if (vsx_register_operand (operands[0], E_V2DImode))
        {
          switch (pattern478 ())
            {
            case 0:
              if (
#line 5732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 378; /* *fpmasksf */
              break;

            case 1:
              if (
#line 5732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 379; /* *fpmaskdf */
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[2], E_KFmode)
              || !altivec_register_operand (operands[3], E_KFmode)
              || !(
#line 5837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 386; /* *fpmaskkf */

        case E_TFmode:
          if (!altivec_register_operand (operands[2], E_TFmode)
              || !altivec_register_operand (operands[3], E_TFmode)
              || !(
#line 5837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 387; /* *fpmasktf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x4;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x10 = XEXP (x5, 0);
      operands[5] = x10;
      x11 = XEXP (x5, 1);
      operands[6] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern533 (x2, 
E_SImode) != 0
              || !
#line 4281 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
            return -1;
          return 245; /* *rotlsi3_insert */

        case E_DImode:
          if (pattern533 (x2, 
E_DImode) != 0
              || !(
#line 4281 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 246; /* *rotldi3_insert */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 1);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              switch (GET_CODE (x10))
                {
                case ASHIFT:
                case ROTATE:
                case LSHIFTRT:
                  operands[4] = x10;
                  operands[5] = x4;
                  operands[6] = x9;
                  x12 = XEXP (x10, 0);
                  operands[1] = x12;
                  x13 = XEXP (x10, 1);
                  operands[2] = x13;
                  if (!const_int_operand (operands[2], E_SImode))
                    return -1;
                  x11 = XEXP (x5, 1);
                  operands[3] = x11;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern540 (x2, 
E_SImode) != 0
                          || !
#line 4299 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
                        return -1;
                      return 247; /* *rotlsi3_insert_2 */

                    case E_DImode:
                      if (pattern540 (x2, 
E_DImode) != 0
                          || !(
#line 4299 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 248; /* *rotldi3_insert_2 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (!gpc_reg_operand (operands[0], E_SImode)
                          || GET_MODE (x2) != E_SImode
                          || GET_MODE (x3) != E_SImode)
                        return -1;
                      operands[1] = x4;
                      if (!gpc_reg_operand (operands[1], E_SImode))
                        return -1;
                      operands[2] = x9;
                      if (!const_int_operand (operands[2], E_SImode)
                          || GET_MODE (x5) != E_SImode)
                        return -1;
                      operands[3] = x10;
                      if (!gpc_reg_operand (operands[3], E_SImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[4] = x11;
                      if (!const_int_operand (operands[4], E_SImode)
                          || !
#line 4375 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)
   && UINTVAL (operands[2]) != 0 && UINTVAL (operands[4]) != 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 256; /* *rotlsi3_insert_5 */

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x2) != E_DImode
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (x4, E_DImode)
                          || !const_int_operand (x9, E_DImode))
                        return -1;
                      operands[2] = x9;
                      operands[1] = x4;
                      if (GET_MODE (x5) == E_DImode)
                        {
                          operands[3] = x10;
                          if (gpc_reg_operand (operands[3], E_DImode))
                            {
                              x11 = XEXP (x5, 1);
                              operands[4] = x11;
                              if (const_int_operand (operands[4], E_DImode)
                                  && 
#line 4389 "../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                                return 257; /* *rotldi3_insert_6 */
                            }
                        }
                      operands[4] = x9;
                      operands[3] = x4;
                      if (GET_MODE (x5) != E_DImode)
                        return -1;
                      operands[1] = x10;
                      if (!gpc_reg_operand (operands[1], E_DImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[2] = x11;
                      if (!const_int_operand (operands[2], E_DImode)
                          || !
#line 4404 "../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 258; /* *rotldi3_insert_7 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern209 (x2))
                {
                case 0:
                  if (!
#line 4313 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
                    return -1;
                  return 249; /* rotlsi3_insert_3 */

                case 1:
                  if (!(
#line 4313 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 250; /* rotldi3_insert_3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (GET_MODE (x5) != E_SImode
                  || !gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              operands[3] = x4;
              if (!gpc_reg_operand (operands[3], E_SImode))
                return -1;
              operands[4] = x9;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x5, 0);
              operands[1] = x10;
              if (!gpc_reg_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 4365 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) + exact_log2 (-UINTVAL (operands[4])) == 32))
                return -1;
              return 255; /* *rotlsi3_insert_4 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              if (GET_CODE (x10) != NOT)
                return -1;
              x6 = XEXP (x1, 0);
              operands[0] = x6;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern463 (x2, 
E_V4SImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V4SImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1775; /* altivec_vselv4si3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V4SImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return -1;
                  return 1785; /* altivec_vselv4si4 */

                case E_V8HImode:
                  if (pattern463 (x2, 
E_V8HImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V8HImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1776; /* altivec_vselv8hi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V8HImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return -1;
                  return 1786; /* altivec_vselv8hi4 */

                case E_V16QImode:
                  if (pattern463 (x2, 
E_V16QImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V16QImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1777; /* altivec_vselv16qi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V16QImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return -1;
                  return 1787; /* altivec_vselv16qi4 */

                case E_V4SFmode:
                  if (pattern463 (x2, 
E_V4SFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V4SFmode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1778; /* altivec_vselv4sf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V4SFmode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return -1;
                  return 1788; /* altivec_vselv4sf4 */

                case E_V2DFmode:
                  if (pattern463 (x2, 
E_V2DFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V2DFmode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1779; /* altivec_vselv2df3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V2DFmode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return -1;
                  return 1789; /* altivec_vselv2df4 */

                case E_V2DImode:
                  if (pattern463 (x2, 
E_V2DImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V2DImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1780; /* altivec_vselv2di3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V2DImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return -1;
                  return 1790; /* altivec_vselv2di4 */

                case E_V1TImode:
                  if (pattern463 (x2, 
E_V1TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V1TImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1781; /* altivec_vselv1ti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V1TImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return -1;
                  return 1791; /* altivec_vselv1ti4 */

                case E_TImode:
                  if (pattern463 (x2, 
E_TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_TImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1782; /* altivec_vselti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_TImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return -1;
                  return 1792; /* altivec_vselti4 */

                case E_KFmode:
                  if (pattern463 (x2, 
E_KFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_KFmode) == 0
                      && (
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1783; /* altivec_vselkf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_KFmode) != 0
                      || !(
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 1793; /* altivec_vselkf4 */

                case E_TFmode:
                  if (pattern463 (x2, 
E_TFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_TFmode) == 0
                      && (
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1784; /* altivec_vseltf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_TFmode) != 0
                      || !(
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 1794; /* altivec_vseltf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              switch (pattern357 (x2))
                {
                case 0:
                  if (!
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2472; /* *fuse_and_or */

                case 1:
                  if (!(
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2473; /* *fuse_and_or */

                case 2:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2948; /* *fuse_vand_vor */

                case 3:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2949; /* *fuse_vand_vor */

                case 4:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2950; /* *fuse_vand_vor */

                case 5:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2951; /* *fuse_vand_vor */

                case 6:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2952; /* *fuse_vand_vor */

                case 7:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2953; /* *fuse_vand_vor */

                case 8:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2954; /* *fuse_vand_vor */

                case 9:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2955; /* *fuse_vand_vor */

                case 10:
                  if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2956; /* *fuse_vand_vor */

                case 11:
                  if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2957; /* *fuse_vand_vor */

                default:
                  return -1;
                }

            case NOT:
              if (pnum_clobbers == NULL)
                return -1;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              operands[0] = x4;
              operands[1] = x9;
              switch (pattern58 (x2))
                {
                case 0:
                  if (!
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2492; /* *fuse_and_orc */

                case 1:
                  if (!(
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2493; /* *fuse_and_orc */

                case 2:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3028; /* *fuse_vand_vorc */

                case 3:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3029; /* *fuse_vand_vorc */

                case 4:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3030; /* *fuse_vand_vorc */

                case 5:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3031; /* *fuse_vand_vorc */

                case 6:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3032; /* *fuse_vand_vorc */

                case 7:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3033; /* *fuse_vand_vorc */

                case 8:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3034; /* *fuse_vand_vorc */

                case 9:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3035; /* *fuse_vand_vorc */

                case 10:
                  if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3036; /* *fuse_vand_vorc */

                case 11:
                  if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3037; /* *fuse_vand_vorc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_19 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1367; /* xxgenpcvm_v16qi_internal */

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1368; /* xxgenpcvm_v8hi_internal */

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !altivec_register_operand (operands[1], E_V4SImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1369; /* xxgenpcvm_v4si_internal */

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !altivec_register_operand (operands[1], E_V2DImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1370; /* xxgenpcvm_v2di_internal */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !vsx_register_operand (operands[2], E_DFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1245; /* *vsx_tdivdf3_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !vsx_register_operand (operands[2], E_V4SFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1246; /* *vsx_tdivv4sf3_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !vsx_register_operand (operands[2], E_V2DFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1247; /* *vsx_tdivv2df3_internal */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 4510 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2181; /* altivec_vbpermq */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 4520 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2182; /* altivec_vbpermq2 */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_OOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_OOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!mma_assemble_input_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!mma_assemble_input_operand (operands[2], E_V16QImode)
      || !
#line 382 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
    return -1;
  return 2209; /* *vsx_assemble_pair */
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_V2DImode)
      || !
#line 3646 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
    return -1;
  return 1393; /* vsx_vslo_v2df */
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6820 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 468; /* btruncsf2 */

    case E_DFmode:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DFmode)
          && gpc_reg_operand (operands[1], E_DFmode)
          && 
#line 6820 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return 469; /* btruncdf2 */
      if (!vsx_register_operand (operands[0], E_DFmode)
          || !vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2331 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1306; /* *vsx_b2truncdf2 */

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x2) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1073; /* btrunckf2 */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1074; /* btrunctf2 */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2331 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1307; /* *vsx_b2truncv4sf2 */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2331 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1308; /* *vsx_b2truncv2df2 */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!input_operand (operands[1], E_SFmode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || !
#line 7832 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))))
        return -1;
      *pnum_clobbers = 1;
      return 558; /* movsi_from_sf */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 7938 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      return 560; /* *movsi_from_df */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || !fusion_addis_mem_combo_load (operands[1], E_QImode)
          || !
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 962; /* *fusion_gpr_load_qi */

    case E_HImode:
      if (!base_reg_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !fusion_addis_mem_combo_load (operands[1], E_HImode)
          || !
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 963; /* *fusion_gpr_load_hi */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode
      || !vsx_register_operand (operands[0], E_V4SFmode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2455 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1322; /* vsx_xscvdpspn */

    case E_SFmode:
      if (!vsx_register_operand (operands[1], E_SFmode)
          || !
#line 2471 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1324; /* vsx_xscvdpspn_scalar */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern413 (x3, 
E_V4SImode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1671; /* xxblend_v4si */

    case E_V8HImode:
      if (pattern413 (x3, 
E_V8HImode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1672; /* xxblend_v8hi */

    case E_V16QImode:
      if (pattern413 (x3, 
E_V16QImode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1673; /* xxblend_v16qi */

    case E_V4SFmode:
      if (pattern413 (x3, 
E_V4SFmode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1674; /* xxblend_v4sf */

    case E_V2DFmode:
      if (pattern413 (x3, 
E_V2DFmode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1675; /* xxblend_v2df */

    case E_V2DImode:
      if (pattern414 (x3) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1676; /* xxblend_v2di */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 82:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern438 (x2, 
E_KFmode) != 0
                  || !(
#line 15544 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1087; /* fmakf4_odd */

            case E_TFmode:
              if (pattern438 (x2, 
E_TFmode) != 0
                  || !(
#line 15544 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1088; /* fmatf4_odd */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern439 (x2, 
E_KFmode) != 0
                  || !(
#line 15557 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1089; /* *fmskf4_odd */

            case E_TFmode:
              if (pattern439 (x2, 
E_TFmode) != 0
                  || !(
#line 15557 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1090; /* *fmstf4_odd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 194:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1428; /* vextractlv16qi_internal */

        case 1:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1429; /* vextractlv8hi_internal */

        case 2:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1430; /* vextractlv4si_internal */

        case 3:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1431; /* vextractlv2di_internal */

        default:
          return -1;
        }

    case 195:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1432; /* vextractrv16qi_internal */

        case 1:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1433; /* vextractrv8hi_internal */

        case 2:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1434; /* vextractrv4si_internal */

        case 3:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1435; /* vextractrv2di_internal */

        default:
          return -1;
        }

    case 196:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1436; /* vinsertvl_internal_v16qi */

        case 1:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1444; /* vinsertgl_internal_v16qi */

        case 2:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1437; /* vinsertvl_internal_v8hi */

        case 3:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1445; /* vinsertgl_internal_v8hi */

        case 4:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1438; /* vinsertvl_internal_v4si */

        case 5:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1446; /* vinsertgl_internal_v4si */

        case 6:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1439; /* vinsertvl_internal_v2di */

        case 7:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1447; /* vinsertgl_internal_v2di */

        default:
          return -1;
        }

    case 197:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1440; /* vinsertvr_internal_v16qi */

        case 1:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1448; /* vinsertgr_internal_v16qi */

        case 2:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1441; /* vinsertvr_internal_v8hi */

        case 3:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1449; /* vinsertgr_internal_v8hi */

        case 4:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1442; /* vinsertvr_internal_v4si */

        case 5:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1450; /* vinsertgr_internal_v4si */

        case 6:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1443; /* vinsertvr_internal_v2di */

        case 7:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1451; /* vinsertgr_internal_v2di */

        default:
          return -1;
        }

    case 198:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern440 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1452; /* vreplace_elt_v4si_inst */

        case E_V4SFmode:
          if (pattern440 (x2, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1453; /* vreplace_elt_v4sf_inst */

        case E_V2DImode:
          if (pattern440 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1454; /* vreplace_elt_v2di_inst */

        case E_V2DFmode:
          if (pattern440 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1455; /* vreplace_elt_v2df_inst */

        default:
          return -1;
        }

    case 199:
      return recog_99 (x1, insn, pnum_clobbers);

    case 123:
      return recog_94 (x1, insn, pnum_clobbers);

    case 126:
      return recog_96 (x1, insn, pnum_clobbers);

    case 160:
      if (pattern156 (x1) != 0
          || !
#line 5738 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1592; /* *lxvl */

    case 161:
      if (pattern156 (x1) != 0
          || !
#line 5748 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1593; /* lxvll */

    case 165:
      if (pattern157 (x1) != 0
          || !
#line 5777 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1594; /* stxvll */

    case 164:
      if (pattern157 (x1) != 0
          || !
#line 5834 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1595; /* *stxvl */

    case 183:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vsx_register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode)
          || !
#line 6073 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1622; /* *insert4b_internal */

    case 206:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!u1bit_cint_operand (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!s32bit_cint_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 6659 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1669; /* xxsplti32dx_v4si_inst */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 6688 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1670; /* xxsplti32dx_v4sf_inst */

        default:
          return -1;
        }

    case 207:
      return recog_98 (x1, insn, pnum_clobbers);

    case 202:
      if (pattern158 (x1, 
E_V2DImode) != 0
          || !
#line 6788 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1679; /* vmsumcud */

    case 263:
      return recog_93 (x1, insn, pnum_clobbers);

    case 358:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1797; /* vsldb_v16qi */

        case 1:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1799; /* vsldb_v8hi */

        case 2:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1801; /* vsldb_v4si */

        case 3:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1803; /* vsldb_v2di */

        case 4:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1805; /* vsldb_v1ti */

        default:
          return -1;
        }

    case 359:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1798; /* vsrdb_v16qi */

        case 1:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1800; /* vsrdb_v8hi */

        case 2:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1802; /* vsrdb_v4si */

        case 3:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1804; /* vsrdb_v2di */

        case 4:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1806; /* vsrdb_v1ti */

        default:
          return -1;
        }

    case 210:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 1011 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1816; /* altivec_vmsumuhm */

        case 1:
          if (!
#line 1011 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1817; /* altivec_vmsumubm */

        default:
          return -1;
        }

    case 211:
      if (pattern158 (x1, 
E_V2DImode) != 0
          || !
#line 1021 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1818; /* altivec_vmsumudm */

    case 212:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 1031 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1819; /* altivec_vmsummhm */

        case 1:
          if (!
#line 1031 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1820; /* altivec_vmsummbm */

        default:
          return -1;
        }

    case 213:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V4SImode)
          || !
#line 1041 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1821; /* altivec_vmsumshm */

    case 346:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern414 (x2) != 0
              || !
#line 2008 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1908; /* altivec_vrldmi */

        case E_V4SImode:
          if (pattern413 (x2, 
E_V4SImode) != 0
              || !
#line 2008 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1909; /* altivec_vrlwmi */

        case E_V1TImode:
          if (pattern131 (x2, 
E_V1TImode) != 0
              || !vsx_register_operand (operands[3], E_V1TImode)
              || !
#line 2036 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1910; /* altivec_vrlqmi_inst */

        default:
          return -1;
        }

    case 253:
      return recog_95 (x1, insn, pnum_clobbers);

    case 255:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1972; /* *altivec_vperm_v4si_uns_internal */

        case 1:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1973; /* *altivec_vperm_v8hi_uns_internal */

        case 2:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1974; /* *altivec_vperm_v16qi_uns_internal */

        case 3:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1975; /* *altivec_vperm_v4sf_uns_internal */

        case 4:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1976; /* *altivec_vperm_v2df_uns_internal */

        case 5:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1977; /* *altivec_vperm_v2di_uns_internal */

        case 6:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1978; /* *altivec_vperm_v1ti_uns_internal */

        case 7:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1979; /* *altivec_vperm_ti_uns_internal */

        case 8:
          if (!(
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 1980; /* *altivec_vperm_kf_uns_internal */

        case 9:
          if (!(
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 1981; /* *altivec_vperm_tf_uns_internal */

        default:
          return -1;
        }

    case 254:
      return recog_102 (x1, insn, pnum_clobbers);

    case 321:
      if (pattern162 (x1, 
E_V4SImode, 
E_V8HImode) != 0
          || !
#line 3837 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2142; /* vperm_v8hiv4si */

    case 322:
      if (pattern162 (x1, 
E_V8HImode, 
E_V16QImode) != 0
          || !
#line 3850 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2143; /* vperm_v16qiv8hi */

    case 335:
      if (pattern158 (x1, 
E_V1TImode) != 0
          || !
#line 4469 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2177; /* altivec_vaddeuqm */

    case 336:
      if (pattern158 (x1, 
E_V1TImode) != 0
          || !
#line 4479 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2178; /* altivec_vaddecuq */

    case 338:
      if (pattern158 (x1, 
E_V1TImode) != 0
          || !
#line 4489 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2179; /* altivec_vsubeuqm */

    case 339:
      if (pattern158 (x1, 
E_V1TImode) != 0
          || !
#line 4499 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2180; /* altivec_vsubecuq */

    case 342:
      switch (pattern163 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2184; /* bcdadd_v1ti */

        case 1:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2186; /* bcdadd_v16qi */

        default:
          return -1;
        }

    case 343:
      switch (pattern163 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2185; /* bcdsub_v1ti */

        case 1:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2187; /* bcdsub_v16qi */

        default:
          return -1;
        }

    case 345:
      if (pnum_clobbers == NULL
          || pattern148 (x1, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_1_operand (operands[3], E_QImode)
          || !
#line 4763 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      *pnum_clobbers = 1;
      return 2206; /* bcdshift_v16qi */

    case 416:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2221; /* mma_xvi4ger8pp */

    case 418:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2222; /* mma_xvi8ger4pp */

    case 419:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2223; /* mma_xvi8ger4spp */

    case 412:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2224; /* mma_xvi16ger2pp */

    case 414:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2225; /* mma_xvi16ger2spp */

    case 400:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2226; /* mma_xvf16ger2pp */

    case 399:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2227; /* mma_xvf16ger2pn */

    case 398:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2228; /* mma_xvf16ger2np */

    case 397:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2229; /* mma_xvf16ger2nn */

    case 395:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2230; /* mma_xvbf16ger2pp */

    case 394:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2231; /* mma_xvbf16ger2pn */

    case 393:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2232; /* mma_xvbf16ger2np */

    case 392:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2233; /* mma_xvbf16ger2nn */

    case 405:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2234; /* mma_xvf32gerpp */

    case 404:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2235; /* mma_xvf32gerpn */

    case 403:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2236; /* mma_xvf32gernp */

    case 402:
      if (pattern164 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2237; /* mma_xvf32gernn */

    case 410:
      if (pattern164 (x1, 
E_OOmode) != 0
          || !
#line 516 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2239; /* mma_xvf64gerpp */

    case 409:
      if (pattern164 (x1, 
E_OOmode) != 0
          || !
#line 516 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2240; /* mma_xvf64gerpn */

    case 408:
      if (pattern164 (x1, 
E_OOmode) != 0
          || !
#line 516 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2241; /* mma_xvf64gernp */

    case 407:
      if (pattern164 (x1, 
E_OOmode) != 0
          || !
#line 516 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2242; /* mma_xvf64gernn */

    case 431:
      return recog_101 (x1, insn, pnum_clobbers);

    case 438:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern413 (x2, 
E_V16QImode) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2334; /* crypto_vpermxor_v16qi */

        case E_V8HImode:
          if (pattern413 (x2, 
E_V8HImode) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2335; /* crypto_vpermxor_v8hi */

        case E_V4SImode:
          if (pattern413 (x2, 
E_V4SImode) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2336; /* crypto_vpermxor_v4si */

        case E_V2DImode:
          if (pattern414 (x2) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2337; /* crypto_vpermxor_v2di */

        default:
          return -1;
        }

    case 437:
      return recog_100 (x1, insn, pnum_clobbers);

    case 444:
      return recog_97 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case MULT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[3] = x3;
          if (!gpc_reg_operand (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x6))
            {
            case ASHIFTRT:
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x9 = XEXP (x6, 0);
              if (!gpc_reg_operand (x9, E_SImode))
                return -1;
              switch (GET_CODE (x7))
                {
                case SIGN_EXTEND:
                  operands[2] = x9;
                  x10 = XEXP (x7, 0);
                  operands[1] = x10;
                  if (!gpc_reg_operand (operands[1], E_HImode)
                      || !
#line 1478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 47; /* *nmacchw */

                case ASHIFTRT:
                  x11 = XEXP (x7, 1);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x9;
                  x10 = XEXP (x7, 0);
                  operands[2] = x10;
                  if (!gpc_reg_operand (operands[2], E_SImode)
                      || !
#line 1513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 49; /* *nmachhw */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x7) != SIGN_EXTEND)
                return -1;
              x9 = XEXP (x6, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x10 = XEXP (x7, 0);
              operands[2] = x10;
              if (!gpc_reg_operand (operands[2], E_HImode)
                  || !
#line 1542 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 51; /* *nmaclhw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern199 (x2, 
E_SImode) != 0)
                return -1;
              return 94; /* *subfsi3 */

            case E_DImode:
              if (pattern199 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 95; /* *subfdi3 */

            case E_SFmode:
              if (pattern200 (x2, 
E_SFmode) != 0
                  || !
#line 5079 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 303; /* *subsf3_fpr */

            case E_DFmode:
              if (pattern200 (x2, 
E_DFmode) != 0
                  || !
#line 5079 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 304; /* *subdf3_fpr */

            case E_KFmode:
              if (pattern201 (x2, 
E_KFmode) != 0
                  || !(
#line 15030 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 989; /* subkf3 */

            case E_TFmode:
              if (pattern201 (x2, 
E_TFmode) != 0
                  || !(
#line 15030 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 990; /* subtf3 */

            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              operands[1] = x3;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode))
                {
                  operands[2] = x4;
                  if (vsx_register_operand (operands[2], E_V4SFmode)
                      && 
#line 1710 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                    return 1230; /* *vsx_subv4sf3 */
                }
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode))
                return -1;
              operands[2] = x4;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !
#line 563 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 1722; /* *altivec_subv4sf3 */

            case E_V2DFmode:
              if (!vsx_register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode)
                return -1;
              operands[1] = x3;
              if (!vsx_register_operand (operands[1], E_V2DFmode))
                return -1;
              operands[2] = x4;
              if (!vsx_register_operand (operands[2], E_V2DFmode)
                  || !
#line 1710 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1231; /* *vsx_subv2df3 */

            case E_V4SImode:
              if (pattern202 (x2, 
E_V4SImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 1718; /* subv4si3 */

            case E_V8HImode:
              if (pattern202 (x2, 
E_V8HImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 1719; /* subv8hi3 */

            case E_V16QImode:
              if (pattern202 (x2, 
E_V16QImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 1720; /* subv16qi3 */

            case E_V2DImode:
              if (pattern202 (x2, 
E_V2DImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 1721; /* subv2di3 */

            case E_V1TImode:
              if (pattern202 (x2, 
E_V1TImode) != 0
                  || !
#line 4450 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
                return -1;
              return 2175; /* subv1ti3 */

            case E_DDmode:
              if (pattern200 (x2, 
E_DDmode) != 0
                  || !
#line 185 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2287; /* subdd3 */

            case E_TDmode:
              if (pattern200 (x2, 
E_TDmode) != 0
                  || !
#line 185 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2288; /* subtd3 */

            default:
              return -1;
            }

        case EQ:
          if (pattern36 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 865; /* *minus_eq_di */

        case NE:
          if (pattern36 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 866; /* *minus_ne_di */

        case AND:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              switch (pattern304 (x2))
                {
                case 0:
                  if (!
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2540; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2541; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern306 (x2))
                {
                case 0:
                  if (!
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2544; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2545; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case NOT:
              switch (pattern306 (x2))
                {
                case 0:
                  if (!
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2542; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2543; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern304 (x2))
                {
                case 0:
                  if (!
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2546; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2547; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern307 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 100; /* subfsi3_imm */

        case E_DImode:
          if (pattern307 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 101; /* subfdi3_imm */

        default:
          return -1;
        }

    case UMAX:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != UMIN)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x12 = XEXP (x3, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern399 (x2, 
E_V4SImode) != 0
              || !
#line 4384 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2156; /* uabdv4si3 */

        case E_V8HImode:
          if (pattern399 (x2, 
E_V8HImode) != 0
              || !
#line 4384 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2157; /* uabdv8hi3 */

        case E_V16QImode:
          if (pattern399 (x2, 
E_V16QImode) != 0
              || !
#line 4384 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2158; /* uabdv16qi3 */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern41 (x1))
        {
        case 0:
          if (!
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2532; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2533; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2536; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2537; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2534; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2535; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2538; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2539; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern324 (x3, 
E_SFmode) != 0
              || !
#line 14466 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 947; /* *fmasf4_fpr */

        case E_DFmode:
          if (pattern324 (x3, 
E_DFmode) != 0
              || !
#line 14466 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 948; /* *fmadf4_fpr */

        case E_KFmode:
          if (pattern325 (x3, 
E_KFmode) != 0
              || !(
#line 15155 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1007; /* fmakf4_hw */

        case E_TFmode:
          if (pattern325 (x3, 
E_TFmode) != 0
              || !(
#line 15155 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1008; /* fmatf4_hw */

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && vsx_register_operand (operands[2], E_V4SFmode)
              && vsx_register_operand (operands[3], E_V4SFmode)
              && 
#line 2082 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1267; /* *vsx_fmav4sf4 */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !register_operand (operands[2], E_V4SFmode)
              || !register_operand (operands[3], E_V4SFmode)
              || !
#line 765 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1795; /* *altivec_fmav4sf4 */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !vsx_register_operand (operands[2], E_V2DFmode)
              || !vsx_register_operand (operands[3], E_V2DFmode)
              || !
#line 2094 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1268; /* *vsx_fmav2df4 */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern326 (x3, 
E_SFmode) != 0
              || !
#line 14490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 949; /* *fmssf4_fpr */

        case E_DFmode:
          if (pattern326 (x3, 
E_DFmode) != 0
              || !
#line 14490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 950; /* *fmsdf4_fpr */

        case E_KFmode:
          if (pattern327 (x3, 
E_KFmode) != 0
              || !(
#line 15167 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1009; /* *fmskf4_hw */

        case E_TFmode:
          if (pattern327 (x3, 
E_TFmode) != 0
              || !(
#line 15167 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1010; /* *fmstf4_hw */

        case E_V4SFmode:
          if (pattern328 (x3, 
E_V4SFmode) != 0
              || !
#line 2107 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1269; /* *vsx_fmsv4sf4 */

        case E_V2DFmode:
          if (pattern328 (x3, 
E_V2DFmode) != 0
              || !
#line 2107 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1270; /* *vsx_fmsv2df4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (pattern127 (x3, 
E_DImode) == 0)
        {
          switch (XVECLEN (x5, 0))
            {
            case 2:
              switch (XINT (x5, 1))
                {
                case 14:
                  x6 = XVECEXP (x5, 0, 0);
                  operands[2] = x6;
                  if (rs6000_tls_symbol_ref (operands[2], E_DImode))
                    {
                      x7 = XVECEXP (x5, 0, 1);
                      operands[3] = x7;
                      if (gpc_reg_operand (operands[3], E_DImode)
                          && (
#line 10607 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return 736; /* *tls_gd_low64 */
                    }
                  break;

                case 23:
                  x6 = XVECEXP (x5, 0, 0);
                  operands[3] = x6;
                  if (gpc_reg_operand (operands[3], E_DImode))
                    {
                      x7 = XVECEXP (x5, 0, 1);
                      operands[2] = x7;
                      if (rs6000_tls_symbol_ref (operands[2], E_DImode)
                          && (
#line 10720 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return 746; /* *tls_got_dtprel_low64 */
                    }
                  break;

                case 27:
                  x6 = XVECEXP (x5, 0, 0);
                  operands[3] = x6;
                  if (gpc_reg_operand (operands[3], E_DImode))
                    {
                      x7 = XVECEXP (x5, 0, 1);
                      operands[2] = x7;
                      if (rs6000_tls_symbol_ref (operands[2], E_DImode)
                          && (
#line 10800 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return 753; /* *tls_got_tprel_low64 */
                    }
                  break;

                default:
                  break;
                }
              break;

            case 1:
              if (XINT (x5, 1) == 15)
                {
                  x6 = XVECEXP (x5, 0, 0);
                  operands[2] = x6;
                  if (gpc_reg_operand (operands[2], E_DImode)
                      && (
#line 10652 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 740; /* *tls_ld_low64 */
                }
              break;

            default:
              break;
            }
        }
      break;

    case CONST:
      x8 = XEXP (x5, 0);
      if (GET_CODE (x8) == MINUS
          && GET_MODE (x8) == E_SImode
          && gpc_reg_operand (operands[0], E_SImode)
          && GET_MODE (x3) == E_SImode
          && gpc_reg_operand (operands[1], E_SImode))
        {
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (symbol_ref_operand (operands[2], E_SImode))
            {
              x10 = XEXP (x8, 1);
              operands[3] = x10;
              if (symbol_ref_operand (operands[3], E_SImode)
                  && 
#line 11241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_SECURE_PLT && DEFAULT_ABI == ABI_V4 && flag_pic))
                return 763; /* load_toc_v4_PIC_3c */
            }
        }
      break;

    default:
      break;
    }
  if (!gpc_reg_operand (operands[1], E_DImode)
      || !gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  operands[2] = x5;
  if (!
#line 11324 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL))
    return -1;
  return 766; /* *largetoc_low */
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!altivec_register_operand (operands[3], E_V2DImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_V2DImode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  if (!altivec_register_operand (operands[1], E_V2DImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!altivec_register_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_V2DImode)
      || !
#line 3049 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
    return -1;
  return 3190; /* *fuse_vaddudm_vaddudm */
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!cc_reg_operand (operands[1], E_CCmode)
              || !(
#line 13540 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 903; /* indirect_jumpdi_nospec */

        case USE:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!(
#line 13647 "../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 904; /* tablejumpdi_insn_normal */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) == SET)
        {
          res = recog_159 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x3;
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1)
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (XINT (x5, 1))
        {
        case 279:
          switch (pattern472 ())
            {
            case 0:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2100; /* altivec_stvx_v4si_internal */

            case 1:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2101; /* altivec_stvx_v8hi_internal */

            case 2:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2102; /* altivec_stvx_v16qi_internal */

            case 3:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2103; /* altivec_stvx_v4sf_internal */

            case 4:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2104; /* altivec_stvx_v2df_internal */

            case 5:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2105; /* altivec_stvx_v2di_internal */

            case 6:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2106; /* altivec_stvx_v1ti_internal */

            case 7:
              if (!(
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2107; /* altivec_stvx_kf_internal */

            case 8:
              if (!(
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2108; /* altivec_stvx_tf_internal */

            default:
              return -1;
            }

        case 280:
          switch (pattern472 ())
            {
            case 0:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2127; /* altivec_stvxl_v4si */

            case 1:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2128; /* altivec_stvxl_v8hi */

            case 2:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2129; /* altivec_stvxl_v16qi */

            case 3:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2130; /* altivec_stvxl_v4sf */

            case 4:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2131; /* altivec_stvxl_v2df */

            case 5:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2132; /* altivec_stvxl_v2di */

            case 6:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2133; /* altivec_stvxl_v1ti */

            case 7:
              if (!(
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2134; /* altivec_stvxl_kf */

            case 8:
              if (!(
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2135; /* altivec_stvxl_tf */

            default:
              return -1;
            }

        case 305:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4280 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2148; /* altivec_stvlx */

        case 306:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4289 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2149; /* altivec_stvlxl */

        case 307:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4298 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2150; /* altivec_stvrx */

        case 308:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4307 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2151; /* altivec_stvrxl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          switch (pattern391 (x5))
            {
            case 0:
              if (!
#line 1519 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2508; /* *fuse_and_xor */

            case 1:
              if (!(
#line 1519 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2509; /* *fuse_and_xor */

            case 2:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3108; /* *fuse_vand_vxor */

            case 3:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3109; /* *fuse_vand_vxor */

            case 4:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3110; /* *fuse_vand_vxor */

            case 5:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3111; /* *fuse_vand_vxor */

            case 6:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3112; /* *fuse_vand_vxor */

            case 7:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3113; /* *fuse_vand_vxor */

            case 8:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3114; /* *fuse_vand_vxor */

            case 9:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3115; /* *fuse_vand_vxor */

            case 10:
              if (!(
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3116; /* *fuse_vand_vxor */

            case 11:
              if (!(
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3117; /* *fuse_vand_vxor */

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern235 (x5, 
E_SImode) != 0
                      || !
#line 1537 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2510; /* *fuse_andc_xor */

                case E_DImode:
                  if (pattern235 (x5, 
E_DImode) != 0
                      || !(
#line 1537 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2511; /* *fuse_andc_xor */

                case E_V4SImode:
                  if (pattern236 (x5, 
E_V4SImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3118; /* *fuse_vandc_vxor */

                case E_V8HImode:
                  if (pattern236 (x5, 
E_V8HImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3119; /* *fuse_vandc_vxor */

                case E_V16QImode:
                  if (pattern236 (x5, 
E_V16QImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3120; /* *fuse_vandc_vxor */

                case E_V4SFmode:
                  if (pattern236 (x5, 
E_V4SFmode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3121; /* *fuse_vandc_vxor */

                case E_V2DFmode:
                  if (pattern236 (x5, 
E_V2DFmode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3122; /* *fuse_vandc_vxor */

                case E_V2DImode:
                  if (pattern236 (x5, 
E_V2DImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3123; /* *fuse_vandc_vxor */

                case E_V1TImode:
                  if (pattern236 (x5, 
E_V1TImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3124; /* *fuse_vandc_vxor */

                case E_TImode:
                  if (pattern236 (x5, 
E_TImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3125; /* *fuse_vandc_vxor */

                case E_KFmode:
                  if (pattern236 (x5, 
E_KFmode) != 0
                      || !(
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3126; /* *fuse_vandc_vxor */

                case E_TFmode:
                  if (pattern236 (x5, 
E_TFmode) != 0
                      || !(
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3127; /* *fuse_vandc_vxor */

                default:
                  return -1;
                }

            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern183 (x5, 
E_SImode) != 0
                      || !
#line 1591 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2516; /* *fuse_nor_xor */

                case E_DImode:
                  if (pattern183 (x5, 
E_DImode) != 0
                      || !(
#line 1591 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2517; /* *fuse_nor_xor */

                case E_V4SImode:
                  if (pattern240 (x5, 
E_V4SImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3148; /* *fuse_vnor_vxor */

                case E_V8HImode:
                  if (pattern240 (x5, 
E_V8HImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3149; /* *fuse_vnor_vxor */

                case E_V16QImode:
                  if (pattern240 (x5, 
E_V16QImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3150; /* *fuse_vnor_vxor */

                case E_V4SFmode:
                  if (pattern240 (x5, 
E_V4SFmode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3151; /* *fuse_vnor_vxor */

                case E_V2DFmode:
                  if (pattern240 (x5, 
E_V2DFmode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3152; /* *fuse_vnor_vxor */

                case E_V2DImode:
                  if (pattern240 (x5, 
E_V2DImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3153; /* *fuse_vnor_vxor */

                case E_V1TImode:
                  if (pattern240 (x5, 
E_V1TImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3154; /* *fuse_vnor_vxor */

                case E_TImode:
                  if (pattern240 (x5, 
E_TImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3155; /* *fuse_vnor_vxor */

                case E_KFmode:
                  if (pattern240 (x5, 
E_KFmode) != 0
                      || !(
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3156; /* *fuse_vnor_vxor */

                case E_TFmode:
                  if (pattern240 (x5, 
E_TFmode) != 0
                      || !(
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3157; /* *fuse_vnor_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != XOR)
        return -1;
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x13 = XEXP (x9, 1);
      operands[1] = x13;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern504 (x5, 
E_SImode) != 0
              || !
#line 1555 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2512; /* *fuse_eqv_xor */

        case E_DImode:
          if (pattern504 (x5, 
E_DImode) != 0
              || !(
#line 1555 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2513; /* *fuse_eqv_xor */

        case E_V4SImode:
          if (pattern505 (x5, 
E_V4SImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3128; /* *fuse_veqv_vxor */

        case E_V8HImode:
          if (pattern505 (x5, 
E_V8HImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3129; /* *fuse_veqv_vxor */

        case E_V16QImode:
          if (pattern505 (x5, 
E_V16QImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3130; /* *fuse_veqv_vxor */

        case E_V4SFmode:
          if (pattern505 (x5, 
E_V4SFmode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3131; /* *fuse_veqv_vxor */

        case E_V2DFmode:
          if (pattern505 (x5, 
E_V2DFmode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3132; /* *fuse_veqv_vxor */

        case E_V2DImode:
          if (pattern505 (x5, 
E_V2DImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3133; /* *fuse_veqv_vxor */

        case E_V1TImode:
          if (pattern505 (x5, 
E_V1TImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3134; /* *fuse_veqv_vxor */

        case E_TImode:
          if (pattern505 (x5, 
E_TImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3135; /* *fuse_veqv_vxor */

        case E_KFmode:
          if (pattern505 (x5, 
E_KFmode) != 0
              || !(
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3136; /* *fuse_veqv_vxor */

        case E_TFmode:
          if (pattern505 (x5, 
E_TFmode) != 0
              || !(
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3137; /* *fuse_veqv_vxor */

        default:
          return -1;
        }

    case IOR:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern183 (x5, 
E_SImode) != 0
                      || !
#line 1573 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2514; /* *fuse_nand_xor */

                case E_DImode:
                  if (pattern183 (x5, 
E_DImode) != 0
                      || !(
#line 1573 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2515; /* *fuse_nand_xor */

                case E_V4SImode:
                  if (pattern240 (x5, 
E_V4SImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3138; /* *fuse_vnand_vxor */

                case E_V8HImode:
                  if (pattern240 (x5, 
E_V8HImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3139; /* *fuse_vnand_vxor */

                case E_V16QImode:
                  if (pattern240 (x5, 
E_V16QImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3140; /* *fuse_vnand_vxor */

                case E_V4SFmode:
                  if (pattern240 (x5, 
E_V4SFmode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3141; /* *fuse_vnand_vxor */

                case E_V2DFmode:
                  if (pattern240 (x5, 
E_V2DFmode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3142; /* *fuse_vnand_vxor */

                case E_V2DImode:
                  if (pattern240 (x5, 
E_V2DImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3143; /* *fuse_vnand_vxor */

                case E_V1TImode:
                  if (pattern240 (x5, 
E_V1TImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3144; /* *fuse_vnand_vxor */

                case E_TImode:
                  if (pattern240 (x5, 
E_TImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3145; /* *fuse_vnand_vxor */

                case E_KFmode:
                  if (pattern240 (x5, 
E_KFmode) != 0
                      || !(
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3146; /* *fuse_vnand_vxor */

                case E_TFmode:
                  if (pattern240 (x5, 
E_TFmode) != 0
                      || !(
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3147; /* *fuse_vnand_vxor */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern235 (x5, 
E_SImode) != 0
                      || !
#line 1627 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2520; /* *fuse_orc_xor */

                case E_DImode:
                  if (pattern235 (x5, 
E_DImode) != 0
                      || !(
#line 1627 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2521; /* *fuse_orc_xor */

                case E_V4SImode:
                  if (pattern236 (x5, 
E_V4SImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3168; /* *fuse_vorc_vxor */

                case E_V8HImode:
                  if (pattern236 (x5, 
E_V8HImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3169; /* *fuse_vorc_vxor */

                case E_V16QImode:
                  if (pattern236 (x5, 
E_V16QImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3170; /* *fuse_vorc_vxor */

                case E_V4SFmode:
                  if (pattern236 (x5, 
E_V4SFmode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3171; /* *fuse_vorc_vxor */

                case E_V2DFmode:
                  if (pattern236 (x5, 
E_V2DFmode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3172; /* *fuse_vorc_vxor */

                case E_V2DImode:
                  if (pattern236 (x5, 
E_V2DImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3173; /* *fuse_vorc_vxor */

                case E_V1TImode:
                  if (pattern236 (x5, 
E_V1TImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3174; /* *fuse_vorc_vxor */

                case E_TImode:
                  if (pattern236 (x5, 
E_TImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3175; /* *fuse_vorc_vxor */

                case E_KFmode:
                  if (pattern236 (x5, 
E_KFmode) != 0
                      || !(
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3176; /* *fuse_vorc_vxor */

                case E_TFmode:
                  if (pattern236 (x5, 
E_TFmode) != 0
                      || !(
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3177; /* *fuse_vorc_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern391 (x5))
            {
            case 0:
              if (!
#line 1609 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2518; /* *fuse_or_xor */

            case 1:
              if (!(
#line 1609 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2519; /* *fuse_or_xor */

            case 2:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3158; /* *fuse_vor_vxor */

            case 3:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3159; /* *fuse_vor_vxor */

            case 4:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3160; /* *fuse_vor_vxor */

            case 5:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3161; /* *fuse_vor_vxor */

            case 6:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3162; /* *fuse_vor_vxor */

            case 7:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3163; /* *fuse_vor_vxor */

            case 8:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3164; /* *fuse_vor_vxor */

            case 9:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3165; /* *fuse_vor_vxor */

            case 10:
              if (!(
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3166; /* *fuse_vor_vxor */

            case 11:
              if (!(
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3167; /* *fuse_vor_vxor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      switch (pattern391 (x5))
        {
        case 0:
          if (!
#line 1645 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2522; /* *fuse_xor_xor */

        case 1:
          if (!(
#line 1645 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2523; /* *fuse_xor_xor */

        case 2:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3178; /* *fuse_vxor_vxor */

        case 3:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3179; /* *fuse_vxor_vxor */

        case 4:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3180; /* *fuse_vxor_vxor */

        case 5:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3181; /* *fuse_vxor_vxor */

        case 6:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3182; /* *fuse_vxor_vxor */

        case 7:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3183; /* *fuse_vxor_vxor */

        case 8:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3184; /* *fuse_vxor_vxor */

        case 9:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3185; /* *fuse_vxor_vxor */

        case 10:
          if (!(
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3186; /* *fuse_vxor_vxor */

        case 11:
          if (!(
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3187; /* *fuse_vxor_vxor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_179 (x1, insn, pnum_clobbers);

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM)
        return -1;
      if (pnum_clobbers != NULL)
        {
          switch (pattern115 (x1))
            {
            case 0:
              if (current_file_function_operand (operands[0], E_DImode)
                  && (
#line 11491 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 775; /* *call_localdi */
                }
              if (symbol_ref_operand (operands[0], E_DImode))
                {
                  if ((
#line 11567 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 778; /* *call_nonlocal_sysvdi */
                    }
                  if ((
#line 11688 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 783; /* *call_nonlocal_aixdi */
                    }
                }
              break;

            case 1:
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (indirect_call_operand (operands[0], E_DImode))
                    {
                      if ((
#line 11539 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 777; /* *call_indirect_nonlocal_sysvdi */
                        }
                      if ((
#line 11786 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 789; /* *call_indirect_pcreldi */
                        }
                    }
                  break;

                case E_SImode:
                  if (indirect_call_operand (operands[0], E_SImode)
                      && (
#line 11786 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 788; /* *call_indirect_pcrelsi */
                    }
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SIMPLE_RETURN)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!call_operand (operands[0], E_DImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!(
#line 12066 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 799; /* *sibcall_aixdi */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[0] = x7;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      switch (XINT (x2, 1))
        {
        case 4:
          if (!register_operand (operands[0], E_DImode)
              || !scratch_operand (operands[1], E_DImode))
            return -1;
          return 941; /* eh_set_lr_di */

        case 5:
          if (GET_MODE (x2) != E_BLKmode
              || !scratch_operand (operands[1], E_CCmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode))
                return -1;
              return 1111; /* loadsync_qi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode))
                return -1;
              return 1112; /* loadsync_hi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 1113; /* loadsync_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 111 "../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1114; /* loadsync_di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !
#line 112 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
                return -1;
              return 1115; /* loadsync_ti */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_186 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_180 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_181 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          if (pattern16 (x1) == 0
              && 
#line 6081 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFID && TARGET_HARD_FLOAT))
            return 404; /* *floatsidf2_internal */
          break;

        case 5:
          res = recog_182 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_183 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 10:
          switch (pattern18 (x1))
            {
            case 0:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return 812; /* *cmpif_internal2 */
              break;

            case 1:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 813; /* *cmpif_internal2 */
              break;

            case 2:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return 814; /* *cmptf_internal2 */
              break;

            case 3:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 815; /* *cmptf_internal2 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 1)
        {
          res = recog_184 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 4
          && any_parallel_operand (operands[0], E_VOIDmode))
        {
          res = recog_185 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) < 5
          || !any_parallel_operand (operands[0], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x2) != USE)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x5))
        {
        case RETURN:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern331 (x6, 
E_DImode, 
96, 
CLOBBER) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x7) != USE)
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!symbol_ref_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[2] = x9;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          switch (REGNO (x3))
            {
            case 11:
              switch (pattern546 ())
                {
                case 0:
                  return 933; /* *return_and_restore_gpregs_di_r11 */

                case 1:
                  return 936; /* *return_and_restore_fpregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern546 ())
                {
                case 0:
                  return 934; /* *return_and_restore_gpregs_di_r12 */

                case 1:
                  return 937; /* *return_and_restore_fpregs_di_r12 */

                default:
                  return -1;
                }

            case 1:
              switch (pattern546 ())
                {
                case 0:
                  return 935; /* *return_and_restore_gpregs_di_r1 */

                case 1:
                  return 938; /* *return_and_restore_fpregs_di_r1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CLOBBER:
          x11 = XEXP (x5, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 96
              || GET_MODE (x11) != E_DImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x3) != 0)
            return -1;
          x12 = XEXP (x6, 0);
          operands[1] = x12;
          if (!symbol_ref_operand (operands[1], E_DImode)
              || GET_MODE (x8) != E_DImode)
            return -1;
          switch (REGNO (x8))
            {
            case 11:
              switch (pattern553 (x4))
                {
                case 0:
                  if (!(
#line 461 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1702; /* *save_vregs_di_r11 */

                case 1:
                  if (!(
#line 487 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1704; /* *restore_vregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern553 (x4))
                {
                case 0:
                  if (!(
#line 474 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1703; /* *save_vregs_di_r12 */

                case 1:
                  if (!(
#line 500 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1705; /* *restore_vregs_di_r12 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 15:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 448; /* rs6000_mtfsb0 */

            case 16:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6518 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 449; /* rs6000_mtfsb1 */

            case 0:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 801; /* blockage */

            case 18:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 908; /* speculation_barrier */

            case 4:
              if (pnum_clobbers == NULL)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              *pnum_clobbers = 1;
              return 941; /* eh_set_lr_di */

            case 5:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                  if (XWINT (x5, 0) != 0L)
                    return -1;
                  return 1110; /* isync */

                case REG:
                case SUBREG:
                  if (pnum_clobbers == NULL)
                    return -1;
                  operands[0] = x5;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1111; /* loadsync_qi */

                    case E_HImode:
                      if (!register_operand (operands[0], E_HImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1112; /* loadsync_hi */

                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1113; /* loadsync_si */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 111 "../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1114; /* loadsync_di */

                    case E_TImode:
                      if (!register_operand (operands[0], E_TImode)
                          || !
#line 112 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1115; /* loadsync_ti */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 24:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2951 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2048; /* altivec_dssall */

            case 25:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!immediate_operand (operands[0], E_QImode)
                  || !
#line 2958 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2049; /* altivec_dss */

            default:
              return -1;
            }

        case 2:
          switch (XINT (x1, 1))
            {
            case 17:
              x5 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 0
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 96
                  || GET_MODE (x6) != E_SImode)
                return -1;
              return 945; /* split_stack_return */

            case 13:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14688 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 960; /* rs6000_mtfsf */

            case 14:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14695 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 961; /* rs6000_mtfsf_hi */

            case 96:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!int_reg_operand (operands[0], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!simple_offsettable_mem_operand (operands[1], E_DImode)
                  || !
#line 15858 "../../gcc/config/rs6000/rs6000.md"
(rs6000_rop_protect))
                return -1;
              return 1107; /* hashchk */

            case 39:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!u10bit_cint_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!gpc_reg_operand (operands[0], E_SImode)
                      || !
#line 280 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                    return -1;
                  return 2356; /* htm_mtspr_si */

                case E_DImode:
                  if (!gpc_reg_operand (operands[0], E_DImode)
                      || !(
#line 280 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2357; /* htm_mtspr_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!
#line 13515 "../../gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 900; /* return */

    case SIMPLE_RETURN:
      return 901; /* simple_return */

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          x5 = XVECEXP (x1, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (XINT (x1, 1))
            {
            case 57:
              return 906; /* nop */

            case 58:
              return 907; /* group_ending_nop */

            default:
              return -1;
            }

        case 3:
          x5 = XVECEXP (x1, 0, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          operands[2] = x7;
          if (!immediate_operand (operands[2], E_QImode))
            return -1;
          switch (XINT (x1, 1))
            {
            case 272:
              if (!
#line 2966 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2050; /* altivec_dst */

            case 273:
              if (!
#line 2974 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2051; /* altivec_dstt */

            case 274:
              if (!
#line 2982 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2052; /* altivec_dstst */

            case 275:
              if (!
#line 2990 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2053; /* altivec_dststt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x13 = XEXP (x1, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x1, 0);
      switch (GET_CODE (x14))
        {
        case CONST_INT:
          if (XWINT (x14, 0) != 1L)
            return -1;
          return 913; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[0] = x14;
          if (!ordered_comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          x16 = XEXP (x14, 1);
          operands[2] = x16;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !reg_or_short_operand (operands[2], E_SImode))
                return -1;
              return 914; /* *rs6000.md:13918 */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !reg_or_short_operand (operands[2], E_DImode)
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 915; /* *rs6000.md:13918 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EH_RETURN:
      return 942; /* eh_return_internal */

    case PREFETCH:
      x14 = XEXP (x1, 0);
      operands[0] = x14;
      if (!indexed_or_indirect_address (operands[0], E_VOIDmode))
        return -1;
      x13 = XEXP (x1, 1);
      operands[1] = x13;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x1, 2);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 943; /* prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IOR:
      res = split_10 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern257 (x2))
            {
            case 0:
              return gen_split_86 (insn, operands);

            case 1:
              if (
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return gen_split_88 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case AND:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == ASHIFT)
            {
              switch (pattern209 (x2))
                {
                case 0:
                  if ((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_106 (insn, operands);
                  break;

                case 1:
                  if (((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_108 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case ASHIFT:
          switch (pattern197 (x2))
            {
            case 0:
              if (
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                return gen_split_111 (insn, operands);
              break;

            case 1:
              if ((
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return gen_split_114 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pattern343 (
E_TImode) != 0
          || !
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
        return NULL;
      return gen_split_239 (insn, operands);

    case E_PTImode:
      if (pattern343 (
E_PTImode) != 0
          || !
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
        return NULL;
      return gen_split_240 (insn, operands);

    case E_V16QImode:
      if (pattern343 (
E_V16QImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_241 (insn, operands);

    case E_V8HImode:
      if (pattern343 (
E_V8HImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_242 (insn, operands);

    case E_V4SImode:
      if (pattern343 (
E_V4SImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_243 (insn, operands);

    case E_V4SFmode:
      if (pattern343 (
E_V4SFmode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_244 (insn, operands);

    case E_V2DImode:
      if (pattern343 (
E_V2DImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_245 (insn, operands);

    case E_V2DFmode:
      if (pattern343 (
E_V2DFmode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_246 (insn, operands);

    case E_V1TImode:
      if (pattern343 (
E_V1TImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_247 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_VECTOR:
    case VEC_DUPLICATE:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (gpc_reg_operand (operands[0], E_SImode)
              && const_int_operand (operands[1], E_SImode)
              && 
#line 8013 "../../gcc/config/rs6000/rs6000.md"
(num_insns_constant (operands[1], SImode) > 1))
            return gen_split_295 (insn, operands);
          if (altivec_register_operand (operands[0], E_SImode)
              && xxspltib_constant_split (operands[1], E_SImode)
              && 
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_385 (insn, operands);
          break;

        case E_DImode:
          if (altivec_register_operand (operands[0], E_DImode)
              && xxspltib_constant_split (operands[1], E_DImode)
              && 
#line 8026 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_296 (insn, operands);
          if (gpc_reg_operand (operands[0], E_DImode)
              && const_int_operand (operands[1], E_DImode)
              && 
#line 9838 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
            return gen_split_376 (insn, operands);
          break;

        case E_DFmode:
          if (gpc_reg_operand (operands[0], E_DFmode)
              && const_int_operand (operands[1], E_DFmode)
              && 
#line 8483 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_304 (insn, operands);
          break;

        case E_DDmode:
          if (gpc_reg_operand (operands[0], E_DDmode)
              && const_int_operand (operands[1], E_DDmode)
              && 
#line 8483 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_305 (insn, operands);
          break;

        case E_QImode:
          if (altivec_register_operand (operands[0], E_QImode)
              && xxspltib_constant_split (operands[1], E_QImode)
              && 
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_383 (insn, operands);
          break;

        case E_HImode:
          if (altivec_register_operand (operands[0], E_HImode)
              && xxspltib_constant_split (operands[1], E_HImode)
              && 
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_384 (insn, operands);
          break;

        case E_PTImode:
          if (int_reg_operand (operands[0], E_PTImode)
              && const_scalar_int_operand (operands[1], E_PTImode)
              && 
#line 10063 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (PTImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))))
            return gen_split_388 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) == VEC_DUPLICATE
          && GET_MODE (x3) == E_V4SFmode
          && vsx_register_operand (operands[0], E_V4SFmode))
        {
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (splat_input_operand (operands[1], E_SFmode)
              && (
#line 4832 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 4837 "../../gcc/config/rs6000/vsx.md"
( reload_completed && vsx_register_operand (operands[1], SFmode))))
            return gen_split_658 (insn, operands);
        }
      break;

    case CONST_DOUBLE:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (gpc_reg_operand (operands[0], E_SFmode)
              && const_double_operand (operands[1], E_SFmode)
              && 
#line 8216 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_299 (insn, operands);
          break;

        case E_SDmode:
          if (gpc_reg_operand (operands[0], E_SDmode)
              && const_double_operand (operands[1], E_SDmode)
              && 
#line 8216 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_300 (insn, operands);
          break;

        case E_DFmode:
          if (gpc_reg_operand (operands[0], E_DFmode)
              && const_double_operand (operands[1], E_DFmode))
            {
              if (
#line 8503 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_306 (insn, operands);
              if (
#line 8525 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_308 (insn, operands);
            }
          break;

        case E_DDmode:
          if (gpc_reg_operand (operands[0], E_DDmode)
              && const_double_operand (operands[1], E_DDmode))
            {
              if (
#line 8503 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_307 (insn, operands);
              if (
#line 8525 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_309 (insn, operands);
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  res = split_13 (x1, insn);
  if (res != NULL_RTX)
    return res;
  if (vsx_register_operand (operands[0], E_V1TImode)
      && GET_CODE (x3) == SUBREG
      && known_eq (SUBREG_BYTE (x3), 0)
      && GET_MODE (x3) == E_V1TImode)
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (int_reg_operand (operands[1], E_TImode)
          && 
#line 6769 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && !reload_completed))
        return gen_split_672 (insn, operands);
    }
  operands[1] = x3;
  if (vsx_register_operand (operands[1], E_V1TImode)
      && gpc_reg_operand (operands[0], E_V1TImode)
      && 
#line 6796 "../../gcc/config/rs6000/vsx.md"
(reload_completed
   && TARGET_DIRECT_MOVE_64BIT
   && int_reg_operand (operands[0], V1TImode)
   && vsx_register_operand (operands[1], V1TImode)))
    return gen_split_673 (insn, operands);
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!altivec_register_operand (operands[0], E_DImode)
          || !xxspltib_constant_split (operands[1], E_DImode)
          || !
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_386 (insn, operands);

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V8HImode)
          && (
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_581 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V8HImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && reload_completed))
        return gen_split_675 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V8HImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && reload_completed))
        return gen_split_685 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V8HImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_695 (insn, operands);

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V4SImode)
          && (
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_582 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V4SImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && reload_completed))
        return gen_split_674 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V4SImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && reload_completed))
        return gen_split_684 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V4SImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_694 (insn, operands);

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V2DImode)
          && (
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_583 (insn, operands);
      if (vspltisw_vupkhsw_constant_split (operands[1], E_V2DImode)
          && (
#line 1213 "../../gcc/config/rs6000/vsx.md"
(TARGET_P8_VECTOR && vspltisw_vupkhsw_constant_split (operands[1], V2DImode)) && 
#line 1215 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_584 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V2DImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && reload_completed))
        return gen_split_679 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V2DImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && reload_completed))
        return gen_split_689 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V2DImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_699 (insn, operands);

    default:
      return NULL;
    }
}
