/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return 0;

    case VEC_SELECT:
      res = pattern7 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern2 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern37 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern37 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern49 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern49 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern50 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern50 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern50 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern50 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern50 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern50 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern50 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern50 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern50 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern50 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      res = pattern53 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          return pattern74 (x5, 
E_SFmode); /* [-1, 1] */

        case E_DFmode:
          res = pattern74 (x5, 
E_DFmode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_KFmode:
          res = pattern75 (x5, 
E_KFmode);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        case E_TFmode:
          res = pattern75 (x5, 
E_TFmode);
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case VEC_SELECT:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x7, 0);
  if (!scratch_operand (x9, E_DImode))
    return -1;
  x10 = XEXP (x3, 0);
  switch (GET_CODE (x10))
    {
    case EQ:
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case AND:
          if (GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x10, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XEXP (x8, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 100
              || GET_MODE (x13) != E_CCmode)
            return -1;
          x14 = XEXP (x11, 0);
          operands[1] = x14;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x15 = XEXP (x11, 1);
          operands[2] = x15;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x4, 0);
          operands[3] = x16;
          operands[0] = x9;
          return 0;

        case REG:
        case SUBREG:
          operands[1] = x11;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x4, 0);
          operands[0] = x16;
          operands[3] = x9;
          x13 = XEXP (x8, 0);
          operands[4] = x13;
          if (!scratch_operand (operands[4], E_CCUNSmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NE:
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x16 = XEXP (x4, 0);
      operands[0] = x16;
      operands[3] = x9;
      x13 = XEXP (x8, 0);
      operands[4] = x13;
      if (!scratch_operand (operands[4], E_CCUNSmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1))
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern131 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern131 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern146 (x3, 
E_V2DImode, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern146 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern146 (x3, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V1TImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V1TImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V1TImode))
    return -1;
  return 0;
}

int
pattern164 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_reg_operand (operands[1], E_XOmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vsx_register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern171 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      return pattern169 (x1); /* [-1, 1] */

    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != i1)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      res = pattern170 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!non_update_memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[3], i1))
    return -1;
  return pattern178 (x1); /* [-1, 1] */
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern183 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern183 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS)
    return -1;
  x8 = XEXP (x2, 0);
  operands[3] = x8;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  x10 = XEXP (x5, 1);
  operands[2] = x10;
  x11 = XEXP (x6, 0);
  operands[0] = x11;
  x12 = XEXP (x7, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x7, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  return 0;
}

int
pattern198 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 444)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  return pattern208 (x1); /* [-1, 1] */
}

int
pattern213 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!c32bit_cint_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern229 (x3, 
i1); /* [-1, 0] */
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern250 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XEXP (x4, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[0] = x13;
  x14 = XEXP (x9, 0);
  operands[2] = x14;
  if (!nonimmediate_operand (operands[2], E_DImode))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern268 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern266 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern266 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern267 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern267 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern267 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern267 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern267 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern267 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern267 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern267 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern267 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern267 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!gpc_reg_operand (operands[2], E_HImode)
      || !gpc_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern295 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern293 (x5); /* [-1, 1] */
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[2] = x2;
  if (!u5bit_cint_operand (operands[2], E_QImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !const_vector_each_byte_same (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !const_vector_each_byte_same (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !const_vector_each_byte_same (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!altivec_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !const_vector_each_byte_same (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!altivec_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !const_vector_each_byte_same (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !const_vector_each_byte_same (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!altivec_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !const_vector_each_byte_same (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_TImode:
      if (!altivec_register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !const_vector_each_byte_same (operands[1], E_TImode))
        return -1;
      return 7;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !const_vector_each_byte_same (operands[1], E_KFmode))
        return -1;
      return 8;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !const_vector_each_byte_same (operands[1], E_TFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern345 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode)
      || !gpc_reg_operand (operands[1], E_DImode)
      || !rs6000_tls_symbol_ref (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern351 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern357 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern37 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern37 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern55 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern55 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern55 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern55 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern55 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern55 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern55 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern55 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern55 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern55 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern385 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern390 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern398 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern404 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern412 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_1_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 0;

    case E_IFmode:
      if (!register_operand (operands[1], E_IFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern426 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (XWINT (x13, 0) != 1L
      || pattern394 (x1) != 0)
    return -1;
  return 0;
}

int
pattern441 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern450 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern460 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern472 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!memory_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!memory_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!memory_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!memory_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!memory_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!memory_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!memory_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!memory_operand (operands[0], E_KFmode)
          || !register_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!memory_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern497 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern506 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !scratch_operand (operands[3], E_SImode)
          || !scratch_operand (operands[4], E_SImode)
          || !scratch_operand (operands[5], E_CCmode))
        return -1;
      return pattern106 (); /* [-1, 1] */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !reg_or_short_operand (operands[2], E_DImode)
              || !scratch_operand (operands[3], E_DImode)
              || !scratch_operand (operands[4], E_DImode)
              || !scratch_operand (operands[5], E_CCmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern526 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern539 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern538 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern538 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern549 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], E_V2DFmode)
      || !vsx_register_operand (operands[2], E_V2DFmode)
      || !vsx_register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  return 0;
}

int
pattern559 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x9, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x5, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x6, 0);
  operands[2] = x14;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x11, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LT:
      if (pattern44 (x1, 
E_CCmode, 
GT) == 0
          && 
#line 15710 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1102; /* setb_signed */
      break;

    case LTU:
      if (pattern44 (x1, 
E_CCUNSmode, 
GTU) == 0
          && 
#line 15723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1103; /* setb_unsigned */
      break;

    default:
      break;
    }
  operands[1] = x3;
  if (!scc_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern434 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 342; /* isel_cc_si */

        case 1:
          if (!
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 344; /* isel_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern434 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 343; /* isel_cc_di */

        case 1:
          if (!(
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 345; /* isel_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          switch (pattern409 (x3))
            {
            case 0:
              if (!
#line 403 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2384; /* *fuse_eqv_and */

            case 1:
              if (!(
#line 403 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2385; /* *fuse_eqv_and */

            case 2:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2568; /* *fuse_veqv_vand */

            case 3:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2569; /* *fuse_veqv_vand */

            case 4:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2570; /* *fuse_veqv_vand */

            case 5:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2571; /* *fuse_veqv_vand */

            case 6:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2572; /* *fuse_veqv_vand */

            case 7:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2573; /* *fuse_veqv_vand */

            case 8:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2574; /* *fuse_veqv_vand */

            case 9:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2575; /* *fuse_veqv_vand */

            case 10:
              if (!(
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2576; /* *fuse_veqv_vand */

            case 11:
              if (!(
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2577; /* *fuse_veqv_vand */

            default:
              return -1;
            }

        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern266 (x3, 
E_SImode) != 0
                  || !
#line 583 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2404; /* *fuse_eqv_andc */

            case E_DImode:
              if (pattern266 (x3, 
E_DImode) != 0
                  || !(
#line 583 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2405; /* *fuse_eqv_andc */

            case E_V4SImode:
              if (pattern267 (x3, 
E_V4SImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2648; /* *fuse_veqv_vandc */

            case E_V8HImode:
              if (pattern267 (x3, 
E_V8HImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2649; /* *fuse_veqv_vandc */

            case E_V16QImode:
              if (pattern267 (x3, 
E_V16QImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2650; /* *fuse_veqv_vandc */

            case E_V4SFmode:
              if (pattern267 (x3, 
E_V4SFmode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2651; /* *fuse_veqv_vandc */

            case E_V2DFmode:
              if (pattern267 (x3, 
E_V2DFmode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2652; /* *fuse_veqv_vandc */

            case E_V2DImode:
              if (pattern267 (x3, 
E_V2DImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2653; /* *fuse_veqv_vandc */

            case E_V1TImode:
              if (pattern267 (x3, 
E_V1TImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2654; /* *fuse_veqv_vandc */

            case E_TImode:
              if (pattern267 (x3, 
E_TImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2655; /* *fuse_veqv_vandc */

            case E_KFmode:
              if (pattern267 (x3, 
E_KFmode) != 0
                  || !(
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2656; /* *fuse_veqv_vandc */

            case E_TFmode:
              if (pattern267 (x3, 
E_TFmode) != 0
                  || !(
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2657; /* *fuse_veqv_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern275 (x3))
        {
        case 0:
          if (!
#line 1015 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2452; /* *fuse_and_nor */

        case 1:
          if (!(
#line 1015 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2453; /* *fuse_and_nor */

        case 2:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2868; /* *fuse_vand_vnor */

        case 3:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2869; /* *fuse_vand_vnor */

        case 4:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2870; /* *fuse_vand_vnor */

        case 5:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2871; /* *fuse_vand_vnor */

        case 6:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2872; /* *fuse_vand_vnor */

        case 7:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2873; /* *fuse_vand_vnor */

        case 8:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2874; /* *fuse_vand_vnor */

        case 9:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2875; /* *fuse_vand_vnor */

        case 10:
          if (!(
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2876; /* *fuse_vand_vnor */

        case 11:
          if (!(
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2877; /* *fuse_vand_vnor */

        case 12:
          if (!
#line 1033 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2454; /* *fuse_andc_nor */

        case 13:
          if (!(
#line 1033 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2455; /* *fuse_andc_nor */

        case 14:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2878; /* *fuse_vandc_vnor */

        case 15:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2879; /* *fuse_vandc_vnor */

        case 16:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2880; /* *fuse_vandc_vnor */

        case 17:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2881; /* *fuse_vandc_vnor */

        case 18:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2882; /* *fuse_vandc_vnor */

        case 19:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2883; /* *fuse_vandc_vnor */

        case 20:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2884; /* *fuse_vandc_vnor */

        case 21:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2885; /* *fuse_vandc_vnor */

        case 22:
          if (!(
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2886; /* *fuse_vandc_vnor */

        case 23:
          if (!(
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2887; /* *fuse_vandc_vnor */

        case 24:
          if (!
#line 1087 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2460; /* *fuse_nor_nor */

        case 25:
          if (!(
#line 1087 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2461; /* *fuse_nor_nor */

        case 26:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2908; /* *fuse_vnor_vnor */

        case 27:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2909; /* *fuse_vnor_vnor */

        case 28:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2910; /* *fuse_vnor_vnor */

        case 29:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2911; /* *fuse_vnor_vnor */

        case 30:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2912; /* *fuse_vnor_vnor */

        case 31:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2913; /* *fuse_vnor_vnor */

        case 32:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2914; /* *fuse_vnor_vnor */

        case 33:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2915; /* *fuse_vnor_vnor */

        case 34:
          if (!(
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2916; /* *fuse_vnor_vnor */

        case 35:
          if (!(
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2917; /* *fuse_vnor_vnor */

        default:
          return -1;
        }

    case NOT:
      switch (pattern278 (x3))
        {
        case 0:
          if (!
#line 1051 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2456; /* *fuse_eqv_nor */

        case 1:
          if (!(
#line 1051 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2457; /* *fuse_eqv_nor */

        case 2:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2888; /* *fuse_veqv_vnor */

        case 3:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2889; /* *fuse_veqv_vnor */

        case 4:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2890; /* *fuse_veqv_vnor */

        case 5:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2891; /* *fuse_veqv_vnor */

        case 6:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2892; /* *fuse_veqv_vnor */

        case 7:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2893; /* *fuse_veqv_vnor */

        case 8:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2894; /* *fuse_veqv_vnor */

        case 9:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2895; /* *fuse_veqv_vnor */

        case 10:
          if (!(
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2896; /* *fuse_veqv_vnor */

        case 11:
          if (!(
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2897; /* *fuse_veqv_vnor */

        default:
          return -1;
        }

    case IOR:
      switch (pattern279 (x3))
        {
        case 0:
          if (!
#line 1069 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2458; /* *fuse_nand_nor */

        case 1:
          if (!(
#line 1069 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2459; /* *fuse_nand_nor */

        case 2:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2898; /* *fuse_vnand_vnor */

        case 3:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2899; /* *fuse_vnand_vnor */

        case 4:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2900; /* *fuse_vnand_vnor */

        case 5:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2901; /* *fuse_vnand_vnor */

        case 6:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2902; /* *fuse_vnand_vnor */

        case 7:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2903; /* *fuse_vnand_vnor */

        case 8:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2904; /* *fuse_vnand_vnor */

        case 9:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2905; /* *fuse_vnand_vnor */

        case 10:
          if (!(
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2906; /* *fuse_vnand_vnor */

        case 11:
          if (!(
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2907; /* *fuse_vnand_vnor */

        case 12:
          if (!
#line 1123 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2464; /* *fuse_orc_nor */

        case 13:
          if (!(
#line 1123 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2465; /* *fuse_orc_nor */

        case 14:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2928; /* *fuse_vorc_vnor */

        case 15:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2929; /* *fuse_vorc_vnor */

        case 16:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2930; /* *fuse_vorc_vnor */

        case 17:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2931; /* *fuse_vorc_vnor */

        case 18:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2932; /* *fuse_vorc_vnor */

        case 19:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2933; /* *fuse_vorc_vnor */

        case 20:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2934; /* *fuse_vorc_vnor */

        case 21:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2935; /* *fuse_vorc_vnor */

        case 22:
          if (!(
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2936; /* *fuse_vorc_vnor */

        case 23:
          if (!(
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2937; /* *fuse_vorc_vnor */

        case 24:
          if (!
#line 1105 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2462; /* *fuse_or_nor */

        case 25:
          if (!(
#line 1105 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2463; /* *fuse_or_nor */

        case 26:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2918; /* *fuse_vor_vnor */

        case 27:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2919; /* *fuse_vor_vnor */

        case 28:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2920; /* *fuse_vor_vnor */

        case 29:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2921; /* *fuse_vor_vnor */

        case 30:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2922; /* *fuse_vor_vnor */

        case 31:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2923; /* *fuse_vor_vnor */

        case 32:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2924; /* *fuse_vor_vnor */

        case 33:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2925; /* *fuse_vor_vnor */

        case 34:
          if (!(
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2926; /* *fuse_vor_vnor */

        case 35:
          if (!(
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2927; /* *fuse_vor_vnor */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern280 (x3))
        {
        case 0:
          if (!
#line 1159 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2468; /* *fuse_add_nor */

        case 1:
          if (!(
#line 1159 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2469; /* *fuse_add_nor */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern280 (x3))
        {
        case 0:
          if (!
#line 1177 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2470; /* *fuse_subf_nor */

        case 1:
          if (!(
#line 1177 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2471; /* *fuse_subf_nor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V2DFmode)
          && 
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1395; /* vsx_extract_v2df_var */
        }
      if (!memory_operand (operands[1], E_V2DFmode)
          || !
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1397; /* *vsx_extract_v2df_var_load */

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V4SFmode)
          && 
#line 3745 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1401; /* vsx_extract_v4sf_var */
        }
      if (!memory_operand (operands[1], E_V4SFmode)
          || !
#line 3762 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1402; /* *vsx_extract_v4sf_var_load */

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V16QImode)
          && 
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1422; /* vsx_extract_v16qi_var */
        }
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1425; /* *vsx_extract_v16qi_var_load */

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V8HImode)
          && 
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1423; /* vsx_extract_v8hi_var */
        }
      if (!memory_operand (operands[1], E_V8HImode)
          || !
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1426; /* *vsx_extract_v8hi_var_load */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !
#line 9556 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 631; /* p8_fmrgow_di */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9556 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 632; /* p8_fmrgow_df */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !
#line 9556 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 633; /* p8_fmrgow_dd */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      switch (pattern437 (
E_DImode))
        {
        case 0:
          if (!
#line 5261 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1567; /* xsiexpdp_si */

        case 1:
          if (!(
#line 5261 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1568; /* xsiexpdp_di */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern437 (
E_DFmode))
        {
        case 0:
          if (!
#line 5271 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1569; /* xsiexpdpf_si */

        case 1:
          if (!(
#line 5271 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1570; /* xsiexpdpf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern364 (x3, 
E_SImode) != 0
          || !
#line 2600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB))
        return -1;
      return 137; /* cmpbsi3 */

    case E_DImode:
      if (pattern364 (x3, 
E_DImode) != 0
          || !(
#line 2600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 138; /* cmpbdi3 */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6851 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 474; /* roundsf2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6851 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 475; /* rounddf2 */

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x2) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15477 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1075; /* roundkf2 */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15477 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1076; /* roundtf2 */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (gpc_reg_operand (operands[1], E_KFmode)
          && (
#line 5356 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 320; /* signbitkf2_dm */
      if (!memory_operand (operands[1], E_KFmode)
          || !(
#line 5375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 322; /* signbitkf2_dm_mem */

    case E_TFmode:
      if (gpc_reg_operand (operands[1], E_TFmode)
          && (
#line 5356 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 321; /* signbittf2_dm */
      if (!memory_operand (operands[1], E_TFmode)
          || !(
#line 5375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 323; /* signbittf2_dm_mem */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode
      || !cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2065 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1264; /* *vsx_tsqrtdf2_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2065 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1265; /* *vsx_tsqrtv4sf2_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2065 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1266; /* *vsx_tsqrtv2df2_internal */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern441 (x3, 
E_QImode, 
E_V16QImode) != 0
              || !const_0_to_15_operand (operands[3], E_QImode)
              || !
#line 4592 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1494; /* vsx_set_v16qi_p9 */

        case E_V8HImode:
          if (pattern441 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !const_0_to_7_operand (operands[3], E_QImode)
              || !
#line 4592 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1495; /* vsx_set_v8hi_p9 */

        case E_V4SImode:
          if (pattern442 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 4592 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1496; /* vsx_set_v4si_p9 */

        case E_V4SFmode:
          if (pnum_clobbers == NULL
              || pattern442 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 4616 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 1497; /* vsx_set_v4sf_p9 */

        default:
          return -1;
        }

    case CONST_DOUBLE:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x5;
      if (!zero_fp_constant (operands[2], E_SFmode)
          || !gpc_reg_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_3_operand (operands[3], E_QImode)
          || !
#line 4652 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 1;
      return 1498; /* *vsx_set_v4sf_p9_zero */

    case VEC_SELECT:
      if (GET_MODE (x5) != E_SFmode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1
          || !gpc_reg_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x9 = XVECEXP (x7, 0, 0);
      operands[3] = x9;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      if (!const_0_to_3_operand (operands[4], E_QImode))
        return -1;
      if (
#line 4683 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) == (BYTES_BIG_ENDIAN ? 1 : 2))))
        return 1499; /* *vsx_insert_extract_v4sf_p9 */
      if (pnum_clobbers == NULL
          || !
#line 4712 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
        return -1;
      *pnum_clobbers = 1;
      return 1500; /* *vsx_insert_extract_v4sf_p9_2 */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 899; /* jump */
        }
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      res = recog_110 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && input_operand (operands[1], E_SFmode))
        {
          if (
#line 8257 "../../gcc/config/rs6000/rs6000.md"
((register_operand (operands[0], SFmode)
   || register_operand (operands[1], SFmode))
   && TARGET_HARD_FLOAT
   && (TARGET_ALLOW_SF_SUBREG
       || valid_sf_si_move (operands[0], operands[1], SFmode))))
            return 571; /* movsf_hardfloat */
          if (
#line 8335 "../../gcc/config/rs6000/rs6000.md"
((gpc_reg_operand (operands[0], SFmode)
   || gpc_reg_operand (operands[1], SFmode))
   && TARGET_SOFT_FLOAT))
            return 573; /* *movsf_softfloat */
        }
      break;

    case E_SDmode:
      if (nonimmediate_operand (operands[0], E_SDmode)
          && input_operand (operands[1], E_SDmode))
        {
          if (
#line 8302 "../../gcc/config/rs6000/rs6000.md"
((register_operand (operands[0], SDmode)
   || register_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT))
            return 572; /* movsd_hardfloat */
          if (
#line 8335 "../../gcc/config/rs6000/rs6000.md"
((gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_SOFT_FLOAT))
            return 574; /* *movsd_softfloat */
        }
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && input_operand (operands[1], E_DFmode))
        {
          if (
#line 8575 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 578; /* *movdf_hardfloat32 */
          if (
#line 8620 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 580; /* *movdf_softfloat32 */
          if (
#line 8649 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 582; /* *movdf_hardfloat64 */
          if (
#line 8701 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 584; /* *movdf_softfloat64 */
        }
      break;

    case E_DDmode:
      if (nonimmediate_operand (operands[0], E_DDmode)
          && input_operand (operands[1], E_DDmode))
        {
          if (
#line 8575 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 579; /* *movdd_hardfloat32 */
          if (
#line 8620 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 581; /* *movdd_softfloat32 */
          if (
#line 8649 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 583; /* *movdd_hardfloat64 */
          if (
#line 8701 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 585; /* *movdd_softfloat64 */
        }
      break;

    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if ((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TFmode)
   && (TFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))))
            return 590; /* *movtf_64bit_dm */
          if ((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TFmode)
       || int_reg_operand_not_pseudo (operands[0], TFmode)
       || int_reg_operand_not_pseudo (operands[1], TFmode))
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))))
            return 594; /* *movtf_32bit */
          if ((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
            return 597; /* *movtf_softfloat */
        }
      if (vsx_register_operand (operands[0], E_TFmode)
          && memory_operand (operands[1], E_TFmode)
          && (
#line 1040 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 1170; /* *vsx_le_perm_load_tf */
      if (memory_operand (operands[0], E_TFmode)
          && vsx_register_operand (operands[1], E_TFmode)
          && (
#line 1063 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 1174; /* *vsx_le_perm_store_tf */
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if ((
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && 
#line 70 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return 1193; /* vsx_movtf_64bit */
          if ((
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && 
#line 70 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return 1203; /* *vsx_movtf_32bit */
          if ((
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return 1688; /* *altivec_movtf */
        }
      break;

    case E_IFmode:
      if (nonimmediate_operand (operands[0], E_IFmode)
          && input_operand (operands[1], E_IFmode))
        {
          if ((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (IFmode)
   && (IFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))))
            return 591; /* *movif_64bit_dm */
          if ((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (IFmode)
       || int_reg_operand_not_pseudo (operands[0], IFmode)
       || int_reg_operand_not_pseudo (operands[1], IFmode))
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))))
            return 595; /* *movif_32bit */
          if ((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
            return 598; /* *movif_softfloat */
        }
      break;

    case E_TDmode:
      if (nonimmediate_operand (operands[0], E_TDmode)
          && input_operand (operands[1], E_TDmode))
        {
          if ((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TDmode)
   && (TDmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
            return 592; /* *movtd_64bit_dm */
          if (
#line 8826 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && !WORDS_BIG_ENDIAN
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))))
            return 593; /* *movtd_64bit_nodm */
          if ((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TDmode)
       || int_reg_operand_not_pseudo (operands[0], TDmode)
       || int_reg_operand_not_pseudo (operands[1], TDmode))
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
            return 596; /* *movtd_32bit */
          if ((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
            return 599; /* *movtd_softfloat */
        }
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && input_operand (operands[1], E_DImode))
        {
          if (
#line 9795 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DImode)
       || gpc_reg_operand (operands[1], DImode))))
            return 684; /* *movdi_internal32 */
          if (
#line 9892 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DImode)
       || gpc_reg_operand (operands[1], DImode))))
            return 685; /* *movdi_internal64 */
        }
      if (gpc_reg_operand (operands[0], E_DImode))
        {
          if (pcrel_local_address (operands[1], E_DImode)
              && 
#line 11071 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PCREL))
            return 756; /* *pcrel_local_addr */
          if (pcrel_external_address (operands[1], E_DImode)
              && 
#line 11083 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PCREL))
            return 757; /* *pcrel_extern_addr */
        }
      break;

    case E_TImode:
      if (input_operand (operands[1], E_TImode))
        {
          if (reg_or_mem_operand (operands[0], E_TImode)
              && 
#line 10037 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64
   && (TImode != TImode || VECTOR_MEM_NONE_P (TImode))
   && (gpc_reg_operand (operands[0], TImode)
       || gpc_reg_operand (operands[1], TImode))))
            return 686; /* *movti_string */
          if (nonimmediate_operand (operands[0], E_TImode)
              && 
#line 10050 "../../gcc/config/rs6000/rs6000.md"
((TARGET_POWERPC64 && VECTOR_MEM_NONE_P (TImode)
   && (gpc_reg_operand (operands[0], TImode)
       || gpc_reg_operand (operands[1], TImode)))))
            return 688; /* *movti_ppc64 */
        }
      if (indexed_or_indirect_operand (operands[0], E_TImode)
          && indexed_or_indirect_operand (operands[1], E_TImode)
          && 
#line 427 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && TARGET_VSX
   && !TARGET_P9_VECTOR
   && can_create_pseudo_p ()))
        return 1152; /* *vsx_le_mem_to_mem_mov_ti */
      if (vsx_register_operand (operands[0], E_TImode)
          && memory_operand (operands[1], E_TImode)
          && 
#line 1040 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TImode)))
        return 1171; /* *vsx_le_perm_load_ti */
      if (memory_operand (operands[0], E_TImode)
          && vsx_register_operand (operands[1], E_TImode)
          && 
#line 1063 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return 1175; /* *vsx_le_perm_store_ti */
      if (nonimmediate_operand (operands[0], E_TImode)
          && input_operand (operands[1], E_TImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))))
            return 1194; /* vsx_movti_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))))
            return 1204; /* *vsx_movti_32bit */
          if (
#line 267 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))))
            return 1689; /* *altivec_movti */
        }
      break;

    case E_PTImode:
      if (input_operand (operands[1], E_PTImode))
        {
          if (reg_or_mem_operand (operands[0], E_PTImode)
              && 
#line 10037 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64
   && (PTImode != TImode || VECTOR_MEM_NONE_P (TImode))
   && (gpc_reg_operand (operands[0], PTImode)
       || gpc_reg_operand (operands[1], PTImode))))
            return 687; /* *movpti_string */
          if (nonimmediate_operand (operands[0], E_PTImode)
              && 
#line 10050 "../../gcc/config/rs6000/rs6000.md"
((TARGET_POWERPC64 && VECTOR_MEM_NONE_P (PTImode)
   && (gpc_reg_operand (operands[0], PTImode)
       || gpc_reg_operand (operands[1], PTImode)))))
            return 689; /* *movpti_ppc64 */
        }
      break;

    default:
      break;
    }
  operands[0] = x2;
  switch (pattern31 (x3, 
E_TFmode))
    {
    case 0:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)))))
        return 2117; /* altivec_stvx_tf_2op_di */
      break;

    case 1:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)))))
        return 2126; /* altivec_stvx_tf_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  switch (pattern33 (x1, 
E_TFmode))
    {
    case 0:
      if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
        return -1;
      return 2090; /* altivec_lvx_tf_2op_di */

    case 1:
      if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
        return -1;
      return 2099; /* altivec_lvx_tf_1op_di */

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern8 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_SImode))
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_SImode)
                {
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SFmode:
                      if (gpc_reg_operand (operands[1], E_SFmode)
                          && 
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 414; /* fix_truncsfsi2_stfiwx */
                        }
                      break;

                    case E_DFmode:
                      if (gpc_reg_operand (operands[1], E_DFmode)
                          && 
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 415; /* fix_truncdfsi2_stfiwx */
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6425 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 428; /* *fix_truncsfsi2_p8 */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6425 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 430; /* *fix_truncdfsi2_p8 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers != NULL
              && memory_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                    {
                      *pnum_clobbers = 1;
                      return 436; /* *fix_truncsfsi2_mem */
                    }
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                    {
                      *pnum_clobbers = 1;
                      return 442; /* *fix_truncdfsi2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (altivec_register_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1025; /* fix_kfsi2_hw */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1027; /* fix_tfsi2_hw */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern318 (
E_SImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1045; /* *fix_trunckfsi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1051; /* *fix_trunctfsi2_mem */

            default:
              return -1;
            }

        case E_DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    return 418; /* *fix_truncsfdi2_fctidz */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    return 419; /* *fix_truncdfdi2_fctidz */
                  break;

                case E_DDmode:
                  if (gpc_reg_operand (operands[1], E_DDmode)
                      && 
#line 253 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                    return 2300; /* fixdddi2 */
                  break;

                case E_TDmode:
                  if (gpc_reg_operand (operands[1], E_TDmode)
                      && 
#line 253 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                    return 2301; /* fixtddi2 */
                  break;

                default:
                  break;
                }
            }
          if (!altivec_register_operand (operands[0], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1029; /* fix_kfdi2_hw */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1031; /* fix_tfdi2_hw */

            default:
              return -1;
            }

        case E_QImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_QImode)
                {
                  if (gpc_reg_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 420; /* fix_truncsfqi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 424; /* fix_truncdfqi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 432; /* *fix_truncsfqi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 438; /* *fix_truncdfqi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_QImode)
            return -1;
          if (altivec_register_operand (operands[0], E_QImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1033; /* fix_trunckfqi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1037; /* fix_trunctfqi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern318 (
E_QImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1041; /* *fix_trunckfqi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1047; /* *fix_trunctfqi2_mem */

            default:
              return -1;
            }

        case E_HImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_HImode)
                {
                  if (gpc_reg_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 422; /* fix_truncsfhi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 426; /* fix_truncdfhi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 434; /* *fix_truncsfhi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 440; /* *fix_truncdfhi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_HImode)
            return -1;
          if (altivec_register_operand (operands[0], E_HImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1035; /* fix_trunckfhi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1039; /* fix_trunctfhi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern318 (
E_HImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1043; /* *fix_trunckfhi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1049; /* *fix_trunctfhi2_mem */

            default:
              return -1;
            }

        case E_TImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_TImode)
            return -1;
          if (vsx_register_operand (operands[0], E_TImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (vsx_register_operand (operands[1], E_KFmode)
                      && (
#line 6951 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 484; /* fix_trunckfti2 */
                  break;

                case E_TFmode:
                  if (vsx_register_operand (operands[1], E_TFmode)
                      && (
#line 6951 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 485; /* fix_trunctfti2 */
                  break;

                default:
                  break;
                }
            }
          if (!gpc_reg_operand (operands[0], E_TImode)
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 261 "../../gcc/config/rs6000/dfp.md"
(TARGET_POWER10))
            return -1;
          return 2302; /* fixtdti2 */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V4SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SImode)
              && gpc_reg_operand (operands[1], E_V4SFmode)
              && 
#line 2292 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1294; /* vsx_fix_truncv4sfv4si2 */
          if (!vsx_register_operand (operands[0], E_V4SImode)
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 2503 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1330; /* vsx_xvcvspsxws */

        case E_V2DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V2DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DImode)
              && gpc_reg_operand (operands[1], E_V2DFmode)
              && 
#line 2292 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1295; /* vsx_fix_truncv2dfv2di2 */
          if (!vsx_register_operand (operands[0], E_V2DImode)
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2510 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1332; /* vsx_xvcvdpsxds */

        case E_V4SFmode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && 
#line 2323 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1304; /* vsx_btruncv4sf2 */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 2468 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1960; /* *altivec_vrfiz */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2323 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1305; /* vsx_btruncv2df2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 242 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2298; /* ftruncdd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_TDmode
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 242 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2299; /* ftrunctd2 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 2680 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
        return -1;
      return 1344; /* vsx_xvcvspsxds_be */

    case 2:
      if (!
#line 2689 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
        return -1;
      return 1346; /* vsx_xvcvspsxds_le */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          if (reg_or_mem_operand (operands[1], E_SFmode)
              && 
#line 5241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)))
            return 317; /* *extendsfdf2_fpr */
          if (!gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5262 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && HONOR_SNANS (SFmode)))
            return -1;
          return 318; /* *extendsfdf2_snan */

        case E_IFmode:
          switch (pattern195 (x3))
            {
            case 0:
              if (!(
#line 8930 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 602; /* extenddfif2_vsx */

            case 1:
              if (!
#line 9461 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                return -1;
              return 628; /* *extendtfif2_internal */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_TFmode))
            {
              switch (pattern299 ())
                {
                case 0:
                  if ((
#line 8930 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 603; /* extenddftf2_vsx */
                  break;

                case 1:
                  if (
#line 9448 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                    return 626; /* *extendiftf2_internal */
                  break;

                case 2:
                  if (
#line 9448 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
                    return 627; /* *extendkftf2_internal */
                  break;

                default:
                  break;
                }
            }
          if (altivec_register_operand (operands[0], E_TFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1016; /* extendsftf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1018; /* extenddftf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_TFmode)
              || !vsx_register_operand (operands[1], E_KFmode)
              || !
#line 15211 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1019; /* *extendkftf2 */

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_KFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && 
#line 9461 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
            return 629; /* *extendtfkf2_internal */
          if (altivec_register_operand (operands[0], E_KFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1015; /* extendsfkf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1017; /* extenddfkf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_KFmode)
              || !vsx_register_operand (operands[1], E_TFmode)
              || !
#line 15227 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1020; /* *extendtfkf2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_SDmode)
              || !
#line 62 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2274; /* extendsddd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 140 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2282; /* extendddtd2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern7 (x3, 
E_V2DFmode))
        {
        case 0:
          if (!
#line 2371 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1314; /* vsx_xvcvspdp_be */

        case 1:
          if (!
#line 2380 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1315; /* vsx_xvcvspdp_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || pattern34 (x3, 
E_SImode, 
32, 
E_DImode) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 3239 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 168; /* smulsi3_highpart_64 */

        case ZERO_EXTEND:
          if (GET_CODE (x7) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 3239 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 169; /* umulsi3_highpart_64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_TImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !
#line 1382 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1209; /* vsx_stxvrbx */

        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !
#line 1382 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1210; /* vsx_stxvrhx */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 1382 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1211; /* vsx_stxvrwx */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !
#line 1382 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1212; /* vsx_stxvrdx */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (gpc_reg_operand (operands[1], E_DImode))
    {
      res = recog_152 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != -1L)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET
          || pattern335 (x1, 
NE) != 0)
        return -1;
      return 78; /* *adddi3_imm_carry_m1 */

    case REG:
      if (REGNO (x5) != 98)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern492 (x1, 
E_SImode) != 0)
            return -1;
          return 84; /* addsi3_carry_in_0 */

        case E_DImode:
          if (pattern492 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 85; /* adddi3_carry_in_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern384 (x6))
        {
        case 0:
          if (!
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2432; /* *fuse_and_nand */

        case 1:
          if (!(
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2433; /* *fuse_and_nand */

        case 2:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2788; /* *fuse_vand_vnand */

        case 3:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2789; /* *fuse_vand_vnand */

        case 4:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2790; /* *fuse_vand_vnand */

        case 5:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2791; /* *fuse_vand_vnand */

        case 6:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2792; /* *fuse_vand_vnand */

        case 7:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2793; /* *fuse_vand_vnand */

        case 8:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2794; /* *fuse_vand_vnand */

        case 9:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2795; /* *fuse_vand_vnand */

        case 10:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2796; /* *fuse_vand_vnand */

        case 11:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2797; /* *fuse_vand_vnand */

        case 12:
          if (!
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2434; /* *fuse_andc_nand */

        case 13:
          if (!(
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2435; /* *fuse_andc_nand */

        case 14:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2798; /* *fuse_vandc_vnand */

        case 15:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2799; /* *fuse_vandc_vnand */

        case 16:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2800; /* *fuse_vandc_vnand */

        case 17:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2801; /* *fuse_vandc_vnand */

        case 18:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2802; /* *fuse_vandc_vnand */

        case 19:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2803; /* *fuse_vandc_vnand */

        case 20:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2804; /* *fuse_vandc_vnand */

        case 21:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2805; /* *fuse_vandc_vnand */

        case 22:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2806; /* *fuse_vandc_vnand */

        case 23:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2807; /* *fuse_vandc_vnand */

        case 24:
          if (!
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2440; /* *fuse_nor_nand */

        case 25:
          if (!(
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2441; /* *fuse_nor_nand */

        case 26:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2828; /* *fuse_vnor_vnand */

        case 27:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2829; /* *fuse_vnor_vnand */

        case 28:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2830; /* *fuse_vnor_vnand */

        case 29:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2831; /* *fuse_vnor_vnand */

        case 30:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2832; /* *fuse_vnor_vnand */

        case 31:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2833; /* *fuse_vnor_vnand */

        case 32:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2834; /* *fuse_vnor_vnand */

        case 33:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2835; /* *fuse_vnor_vnand */

        case 34:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2836; /* *fuse_vnor_vnand */

        case 35:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2837; /* *fuse_vnor_vnand */

        default:
          return -1;
        }

    case NOT:
      switch (pattern387 (x6))
        {
        case 0:
          if (!
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2436; /* *fuse_eqv_nand */

        case 1:
          if (!(
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2437; /* *fuse_eqv_nand */

        case 2:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2808; /* *fuse_veqv_vnand */

        case 3:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2809; /* *fuse_veqv_vnand */

        case 4:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2810; /* *fuse_veqv_vnand */

        case 5:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2811; /* *fuse_veqv_vnand */

        case 6:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2812; /* *fuse_veqv_vnand */

        case 7:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2813; /* *fuse_veqv_vnand */

        case 8:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2814; /* *fuse_veqv_vnand */

        case 9:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2815; /* *fuse_veqv_vnand */

        case 10:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2816; /* *fuse_veqv_vnand */

        case 11:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2817; /* *fuse_veqv_vnand */

        default:
          return -1;
        }

    case IOR:
      switch (pattern388 (x6))
        {
        case 0:
          if (!
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2438; /* *fuse_nand_nand */

        case 1:
          if (!(
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2439; /* *fuse_nand_nand */

        case 2:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2818; /* *fuse_vnand_vnand */

        case 3:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2819; /* *fuse_vnand_vnand */

        case 4:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2820; /* *fuse_vnand_vnand */

        case 5:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2821; /* *fuse_vnand_vnand */

        case 6:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2822; /* *fuse_vnand_vnand */

        case 7:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2823; /* *fuse_vnand_vnand */

        case 8:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2824; /* *fuse_vnand_vnand */

        case 9:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2825; /* *fuse_vnand_vnand */

        case 10:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2826; /* *fuse_vnand_vnand */

        case 11:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2827; /* *fuse_vnand_vnand */

        case 12:
          if (!
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2444; /* *fuse_orc_nand */

        case 13:
          if (!(
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2445; /* *fuse_orc_nand */

        case 14:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2848; /* *fuse_vorc_vnand */

        case 15:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2849; /* *fuse_vorc_vnand */

        case 16:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2850; /* *fuse_vorc_vnand */

        case 17:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2851; /* *fuse_vorc_vnand */

        case 18:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2852; /* *fuse_vorc_vnand */

        case 19:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2853; /* *fuse_vorc_vnand */

        case 20:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2854; /* *fuse_vorc_vnand */

        case 21:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2855; /* *fuse_vorc_vnand */

        case 22:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2856; /* *fuse_vorc_vnand */

        case 23:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2857; /* *fuse_vorc_vnand */

        case 24:
          if (!
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2442; /* *fuse_or_nand */

        case 25:
          if (!(
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2443; /* *fuse_or_nand */

        case 26:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2838; /* *fuse_vor_vnand */

        case 27:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2839; /* *fuse_vor_vnand */

        case 28:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2840; /* *fuse_vor_vnand */

        case 29:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2841; /* *fuse_vor_vnand */

        case 30:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2842; /* *fuse_vor_vnand */

        case 31:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2843; /* *fuse_vor_vnand */

        case 32:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2844; /* *fuse_vor_vnand */

        case 33:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2845; /* *fuse_vor_vnand */

        case 34:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2846; /* *fuse_vor_vnand */

        case 35:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2847; /* *fuse_vor_vnand */

        default:
          return -1;
        }

    case XOR:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 1);
      operands[1] = x10;
      x11 = XEXP (x6, 1);
      switch (GET_CODE (x11))
        {
        case NOT:
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern374 (x6, 
E_SImode) != 0
                  || !
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2446; /* *fuse_xor_nand */

            case E_DImode:
              if (pattern374 (x6, 
E_DImode) != 0
                  || !(
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2447; /* *fuse_xor_nand */

            case E_V4SImode:
              if (pattern376 (x6, 
E_V4SImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2858; /* *fuse_vxor_vnand */

            case E_V8HImode:
              if (pattern376 (x6, 
E_V8HImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2859; /* *fuse_vxor_vnand */

            case E_V16QImode:
              if (pattern376 (x6, 
E_V16QImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2860; /* *fuse_vxor_vnand */

            case E_V4SFmode:
              if (pattern376 (x6, 
E_V4SFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2861; /* *fuse_vxor_vnand */

            case E_V2DFmode:
              if (pattern376 (x6, 
E_V2DFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2862; /* *fuse_vxor_vnand */

            case E_V2DImode:
              if (pattern376 (x6, 
E_V2DImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2863; /* *fuse_vxor_vnand */

            case E_V1TImode:
              if (pattern376 (x6, 
E_V1TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2864; /* *fuse_vxor_vnand */

            case E_TImode:
              if (pattern376 (x6, 
E_TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2865; /* *fuse_vxor_vnand */

            case E_KFmode:
              if (pattern376 (x6, 
E_KFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2866; /* *fuse_vxor_vnand */

            case E_TFmode:
              if (pattern376 (x6, 
E_TFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2867; /* *fuse_vxor_vnand */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern504 (x6, 
E_SImode) != 0
                  || !
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2476; /* *fuse_eqv_or */

            case E_DImode:
              if (pattern504 (x6, 
E_DImode) != 0
                  || !(
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2477; /* *fuse_eqv_or */

            case E_V4SImode:
              if (pattern505 (x6, 
E_V4SImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2968; /* *fuse_veqv_vor */

            case E_V8HImode:
              if (pattern505 (x6, 
E_V8HImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2969; /* *fuse_veqv_vor */

            case E_V16QImode:
              if (pattern505 (x6, 
E_V16QImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2970; /* *fuse_veqv_vor */

            case E_V4SFmode:
              if (pattern505 (x6, 
E_V4SFmode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2971; /* *fuse_veqv_vor */

            case E_V2DFmode:
              if (pattern505 (x6, 
E_V2DFmode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2972; /* *fuse_veqv_vor */

            case E_V2DImode:
              if (pattern505 (x6, 
E_V2DImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2973; /* *fuse_veqv_vor */

            case E_V1TImode:
              if (pattern505 (x6, 
E_V1TImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2974; /* *fuse_veqv_vor */

            case E_TImode:
              if (pattern505 (x6, 
E_TImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2975; /* *fuse_veqv_vor */

            case E_KFmode:
              if (pattern505 (x6, 
E_KFmode) != 0
                  || !(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2976; /* *fuse_veqv_vor */

            case E_TFmode:
              if (pattern505 (x6, 
E_TFmode) != 0
                  || !(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2977; /* *fuse_veqv_vor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern389 (x6))
        {
        case 0:
          if (!
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2448; /* *fuse_add_nand */

        case 1:
          if (!(
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2449; /* *fuse_add_nand */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern389 (x6))
        {
        case 0:
          if (!
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2450; /* *fuse_subf_nand */

        case 1:
          if (!(
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2451; /* *fuse_subf_nand */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern495 (x1, 
E_SImode) != 0)
                    return -1;
                  return 100; /* subfsi3_imm */

                case E_DImode:
                  if (pattern495 (x1, 
E_DImode) != 0
                      || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 101; /* subfdi3_imm */

                default:
                  return -1;
                }

            case SET:
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != LEU
                  || GET_MODE (x9) != E_DImode)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98
                  || GET_MODE (x8) != E_DImode
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !reg_or_short_operand (operands[2], E_DImode)
                  || !gpc_reg_operand (operands[1], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x9, 1);
              if (!rtx_equal_p (x11, operands[2]))
                return -1;
              return 104; /* subfdi3_carry */

            default:
              return -1;
            }

        case AND:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              switch (pattern449 (x3))
                {
                case 0:
                  if (!
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2540; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2541; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern451 (x3))
                {
                case 0:
                  if (!
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2544; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2545; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case NOT:
              switch (pattern451 (x3))
                {
                case 0:
                  if (!
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2542; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2543; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern449 (x3))
                {
                case 0:
                  if (!
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2546; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2547; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2532; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2533; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2536; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2537; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2534; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2535; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2538; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2539; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          switch (pattern454 (
E_DImode))
            {
            case 0:
              if (
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 414; /* fix_truncsfsi2_stfiwx */
              break;

            case 1:
              if (
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 415; /* fix_truncdfsi2_stfiwx */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      switch (pattern455 ())
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 436; /* *fix_truncsfsi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 442; /* *fix_truncdfsi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1045; /* *fix_trunckfsi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1051; /* *fix_trunctfsi2_mem */

        default:
          return -1;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 420; /* fix_truncsfqi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 424; /* fix_truncdfqi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      switch (pattern456 (
E_QImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 432; /* *fix_truncsfqi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 438; /* *fix_truncdfqi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1041; /* *fix_trunckfqi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1047; /* *fix_trunctfqi2_mem */

        default:
          return -1;
        }

    case 2:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 422; /* fix_truncsfhi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 426; /* fix_truncdfhi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      switch (pattern456 (
E_HImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 434; /* *fix_truncsfhi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 440; /* *fix_truncdfhi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1043; /* *fix_trunckfhi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1049; /* *fix_trunctfhi2_mem */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[3] = x6;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 17:
          if (GET_MODE (x3) != E_SImode
              || !mfcr_operation (operands[0], E_VOIDmode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !cc_reg_operand (operands[2], E_CCmode)
              || !
#line 13945 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MFCRF))
            return -1;
          return 916; /* *movesi_from_cr_one */

        case 18:
          if (GET_MODE (x3) != E_CCmode
              || !mtcrf_operation (operands[0], E_VOIDmode)
              || !cc_reg_operand (operands[1], E_CCmode)
              || !gpc_reg_operand (operands[2], E_SImode))
            return -1;
          return 927; /* *movsi_to_cr */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x3;
      if (gpc_reg_operand (operands[2], E_SImode))
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (memory_operand (operands[1], E_SImode))
            {
              if (crsave_operation (operands[0], E_VOIDmode))
                return 918; /* *crsave */
              if (stmw_operation (operands[0], E_VOIDmode)
                  && 
#line 13984 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULTIPLE))
                return 919; /* *stmw */
            }
        }
      if (!memory_operand (operands[2], E_SImode)
          || !lmw_operation (operands[0], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !
#line 14152 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULTIPLE))
        return -1;
      return 929; /* *lmw */

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 1
          || !tie_operand (operands[0], E_VOIDmode))
        return -1;
      return 926; /* stack_tie */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 21
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 108
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 108
          || GET_MODE (x4) != E_SImode
          || !vrsave_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 421 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1701; /* *set_vrsave_internal */

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return NULL;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[2] = x8;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern509 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !((
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_590 (insn, operands);

        case E_DImode:
          if (pattern509 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !((
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_591 (insn, operands);

        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return NULL;
          if (vsx_register_operand (operands[0], E_SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && scratch_operand (operands[3], E_V4SFmode)
              && (
#line 3692 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 3694 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return gen_split_596 (insn, operands);
          if (!register_operand (operands[0], E_SFmode)
              || !memory_operand (operands[1], E_V4SFmode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !((
#line 3725 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3727 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_597 (insn, operands);

        case E_QImode:
          if (GET_MODE (x3) != E_QImode)
            return NULL;
          if (int_reg_operand (operands[0], E_QImode)
              && altivec_register_operand (operands[1], E_V16QImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_600 (insn, operands);
          if (!const_0_to_15_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_QImode)
              && gpc_reg_operand (operands[1], E_V16QImode)
              && scratch_operand (operands[3], E_V16QImode)
              && (
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_610 (insn, operands);
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_612 (insn, operands);

        case E_HImode:
          if (GET_MODE (x3) != E_HImode)
            return NULL;
          if (int_reg_operand (operands[0], E_HImode)
              && altivec_register_operand (operands[1], E_V8HImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_601 (insn, operands);
          if (!const_0_to_7_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_HImode)
              && gpc_reg_operand (operands[1], E_V8HImode)
              && scratch_operand (operands[3], E_V8HImode)
              && (
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_611 (insn, operands);
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_613 (insn, operands);

        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          if (int_reg_operand (operands[0], E_SImode)
              && altivec_register_operand (operands[1], E_V4SImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_602 (insn, operands);
          if (!const_0_to_3_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_SImode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && scratch_operand (operands[3], E_V4SImode)
              && (
#line 4081 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 4083 "../../gcc/config/rs6000/vsx.md"
( INTVAL (operands[2]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
            return gen_split_609 (insn, operands);
          if (!register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_614 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (pattern395 (x1) != 0
          || !(
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_665 (insn, operands);

    case SMIN:
      if (pattern395 (x1) != 0
          || !(
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_666 (insn, operands);

    case SMAX:
      if (pattern395 (x1) != 0
          || !(
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_667 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern78 (x1))
    {
    case 0:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                return gen_split_200 (insn, operands);
              break;

            case 1:
              if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                return gen_split_204 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return NULL;
      switch (pattern456 (
E_QImode))
        {
        case 0:
          if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 1:
          if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_214 (insn, operands);

        case 2:
          if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_493 (insn, operands);

        case 3:
          if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_499 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                return gen_split_202 (insn, operands);
              break;

            case 1:
              if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                return gen_split_206 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return NULL;
      switch (pattern456 (
E_HImode))
        {
        case 0:
          if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_210 (insn, operands);

        case 1:
          if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 2:
          if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_495 (insn, operands);

        case 3:
          if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_501 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (memory_operand (operands[0], E_SImode))
        {
          switch (pattern455 ())
            {
            case 0:
              if ((
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_212 (insn, operands);
              break;

            case 1:
              if ((
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_218 (insn, operands);
              break;

            case 2:
              if (((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_497 (insn, operands);
              break;

            case 3:
              if (((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_503 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonimmediate_operand (operands[0], E_SImode))
        return NULL;
      switch (pattern454 (
E_DImode))
        {
        case 0:
          if (!(
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6471 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_219 (insn, operands);

        case 1:
          if (!(
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6471 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_220 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern397 (x2, 
E_SImode) != 0
                  || !(
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3844 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_78 (insn, operands);

            case E_DImode:
              if (pattern397 (x2, 
E_DImode) != 0
                  || !((
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3844 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_79 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern355 (x2, 
E_TImode) != 0
                  || !
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
                return NULL;
              return gen_split_230 (insn, operands);

            case E_PTImode:
              if (pattern355 (x2, 
E_PTImode) != 0
                  || !
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
                return NULL;
              return gen_split_231 (insn, operands);

            case E_V16QImode:
              if (pattern355 (x2, 
E_V16QImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_232 (insn, operands);

            case E_V8HImode:
              if (pattern355 (x2, 
E_V8HImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_233 (insn, operands);

            case E_V4SImode:
              if (pattern355 (x2, 
E_V4SImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_234 (insn, operands);

            case E_V4SFmode:
              if (pattern355 (x2, 
E_V4SFmode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_235 (insn, operands);

            case E_V2DImode:
              if (pattern355 (x2, 
E_V2DImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_236 (insn, operands);

            case E_V2DFmode:
              if (pattern355 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_237 (insn, operands);

            case E_V1TImode:
              if (pattern355 (x2, 
E_V1TImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_238 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16]
          || pattern118 (x2, 
E_DImode) != 0
          || !((
#line 9532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 9534 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_340 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (nonimmediate_operand (operands[0], E_TImode)
      && input_operand (operands[1], E_TImode)
      && 
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], TImode)
       || int_reg_operand (operands[1], TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TImode)
           && !vsx_register_operand (operands[1], TImode)))))
    return gen_split_354 (insn, operands);
  if (int_reg_operand (operands[0], E_TImode)
      && const_scalar_int_operand (operands[1], E_TImode)
      && 
#line 10063 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (TImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))))
    return gen_split_387 (insn, operands);
  if (nonimmediate_operand (operands[0], E_TImode)
      && input_operand (operands[1], E_TImode))
    {
      if (
#line 10090 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return gen_split_389 (insn, operands);
      if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return gen_split_523 (insn, operands);
    }
  if (indexed_or_indirect_operand (operands[0], E_TImode)
      && indexed_or_indirect_operand (operands[1], E_TImode)
      && (
#line 427 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && TARGET_VSX
   && !TARGET_P9_VECTOR
   && can_create_pseudo_p ()) && 
#line 432 "../../gcc/config/rs6000/vsx.md"
( 1)))
    return gen_split_548 (insn, operands);
  if (vsx_register_operand (operands[0], E_TImode)
      && memory_operand (operands[1], E_TImode)
      && 
#line 1045 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TImode)))
    return gen_split_571 (insn, operands);
  if (memory_operand (operands[0], E_TImode)
      && vsx_register_operand (operands[1], E_TImode))
    {
      if (
#line 1075 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return gen_split_575 (insn, operands);
      if (
#line 1131 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return gen_split_579 (insn, operands);
    }
  if (!altivec_register_operand (operands[0], E_TImode))
    return NULL;
  if (easy_vector_constant_msb (operands[1], E_TImode)
      && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && reload_completed))
    return gen_split_681 (insn, operands);
  if (easy_vector_constant_add_self (operands[1], E_TImode)
      && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && reload_completed))
    return gen_split_691 (insn, operands);
  if (!easy_vector_constant_vsldoi (operands[1], E_TImode)
      || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()))
    return NULL;
  return gen_split_701 (insn, operands);
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = split_9 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case IOR:
    case XOR:
      res = split_11 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT)
    return NULL;
  operands[3] = x3;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!boolean_operator (operands[3], E_TImode)
              || GET_MODE (x4) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && 
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], TImode)))
            return gen_split_248 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !
#line 7490 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_257 (insn, operands);

        case E_PTImode:
          if (!boolean_operator (operands[3], E_PTImode)
              || GET_MODE (x4) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && 
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], PTImode)))
            return gen_split_249 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !
#line 7490 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_258 (insn, operands);

        case E_V16QImode:
          if (pattern359 (x4, 
E_V16QImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_250 (insn, operands);

        case E_V8HImode:
          if (pattern359 (x4, 
E_V8HImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_251 (insn, operands);

        case E_V4SImode:
          if (pattern359 (x4, 
E_V4SImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_252 (insn, operands);

        case E_V4SFmode:
          if (pattern359 (x4, 
E_V4SFmode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_253 (insn, operands);

        case E_V2DImode:
          if (pattern359 (x4, 
E_V2DImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_254 (insn, operands);

        case E_V2DFmode:
          if (pattern359 (x4, 
E_V2DFmode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_255 (insn, operands);

        case E_V1TImode:
          if (pattern359 (x4, 
E_V1TImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_256 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!boolean_operator (operands[3], E_TImode)
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], TImode)))
            return gen_split_259 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7551 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_268 (insn, operands);

        case E_PTImode:
          if (!boolean_operator (operands[3], E_PTImode)
              || GET_MODE (x4) != E_PTImode
              || GET_MODE (x5) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], PTImode)))
            return gen_split_260 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7551 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_269 (insn, operands);

        case E_V16QImode:
          if (pattern362 (x3, 
E_V16QImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_261 (insn, operands);

        case E_V8HImode:
          if (pattern362 (x3, 
E_V8HImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_262 (insn, operands);

        case E_V4SImode:
          if (pattern362 (x3, 
E_V4SImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_263 (insn, operands);

        case E_V4SFmode:
          if (pattern362 (x3, 
E_V4SFmode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_264 (insn, operands);

        case E_V2DImode:
          if (pattern362 (x3, 
E_V2DImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_265 (insn, operands);

        case E_V2DFmode:
          if (pattern362 (x3, 
E_V2DFmode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_266 (insn, operands);

        case E_V1TImode:
          if (pattern362 (x3, 
E_V1TImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_267 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2)
    return NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return peephole2_2 (x1, insn, pmatch_len_);

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 3
          || pattern259 (x1, 
E_V1TImode, 
E_CCFPmode, 
106) != 0)
        return NULL;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1TImode))
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1TImode))
        return NULL;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_1_operand (operands[3], E_QImode))
        return NULL;
      x7 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 2)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_CODE (x8) != SET)
        return NULL;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != COMPARE
          || GET_MODE (x9) != E_CCFPmode)
        return NULL;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != UNSPEC
          || XVECLEN (x10, 0) != 3
          || GET_MODE (x10) != E_V2DFmode)
        return NULL;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 106
          || GET_MODE (x11) != E_CCFPmode)
        return NULL;
      x12 = XVECEXP (x7, 0, 1);
      if (GET_CODE (x12) != CLOBBER)
        return NULL;
      x13 = XEXP (x9, 1);
      operands[4] = x13;
      if (!zero_constant (operands[4], E_V2DFmode))
        return NULL;
      x14 = XEXP (x12, 0);
      operands[5] = x14;
      if (!register_operand (operands[5], E_V1TImode))
        return NULL;
      x15 = XVECEXP (x10, 0, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return NULL;
      x16 = XVECEXP (x10, 0, 1);
      if (!rtx_equal_p (x16, operands[2]))
        return NULL;
      x17 = XVECEXP (x10, 0, 2);
      if (!rtx_equal_p (x17, operands[3]))
        return NULL;
      switch (XINT (x3, 1))
        {
        case 342:
          if (XINT (x10, 1) != 342
              || !
#line 4819 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_42 (insn, operands);

        case 343:
          if (XINT (x10, 1) != 343
              || !
#line 4819 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_43 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
